﻿using OASystem.Domain.Dtos.System;
using OASystem.Domain.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.CRM
{
    public class TableOperationRecordDto
    {
    }

    /// <summary>
    /// 表操作记录
    /// Add Dto
    /// </summary>
    public class TableOperationRecordAddDto
    {
        /// <summary>
        /// 用户Id
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// 表名
        /// "Crm_NewClientData" 客户资料表
        /// </summary>
        public string? TableName { get; set; }

        /// <summary>
        /// 访问端口 
        /// 1 WEb 2 安卓 3 苹果
        /// </summary>
        public int PortType { get; set; }

        /// <summary>
        /// 操作项目
        /// 0 未操作 1浏览列表 2 浏览详情 3 添加 4 修改 5 删除 6 审核 7 上传 8 下载
        /// </summary>
        public OperationEnum OperationItem { get; set; } = OperationEnum.NoOperation;

        /// <summary>
        /// 数据Id
        /// </summary>
        public int DataId { get; set; } = 0;
    }

    public class TableOperationRecordPageDto
    {

        public int PageIndex { get; set; } = 1;
        public int PageSize { get; set; } = 10;
        /// <summary>
        /// 表名
        /// 资料操作表记录 'Crm_NewClientData'
        /// </summary>
        public string TableName { get; set; }
    }
}
