﻿using Microsoft.AspNetCore.Http;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos
{
    /// <summary>
    /// 请求实体类 基类
    /// </summary>
    public class DtoBase: PortDtoBase
    {
        public int PageIndex { get; set; } = 1;
        public int PageSize { get; set; } = 10;
    }

    /// <summary>
    /// 请求实体类
    /// 端口
    /// 基类
    /// </summary>
    public class PortDtoBase
    {
        /// <summary>
        /// 请求端口分类
        /// 1 Web 2 Android 3 IOS
        /// </summary>
        public int PortType { get; set; } = 1;
    }

    public class JsonDtoBase
    {
        public string Paras { get; set; }
    }
    /// <summary>
    /// 删除参数
    /// </summary>
    public class DelBaseDto:PortDtoBase
    {

        /// <summary>
        /// 删除的数据Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 删除者Id
        /// </summary>
        public int DeleteUserId { get; set; }
    }

    public class OpBaseDto
    {
        /// <summary>
        /// 操作状态
        /// 1 添加 
        /// 2 修改 
        /// </summary>
        public int Status { get; set; }

        /// <summary>
        /// 编号
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 创建者Id
        /// </summary>
        public int CreateUserId { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }

    /// <summary>
    /// 员工页面操作功能权限
    /// </summary>
    public class UserPageFuncDtoBase : PortDtoBase
    {
        /// <summary>
        /// 用户Id
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// 页面Id
        /// </summary>
        public int PageId { get; set; }
    }

   
}
