﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{
    public class Fin_GroupExtraCostDto_OP : PortDtoBase
    {

        /// <summary>
        /// 1新增，2修改，3删除
        /// </summary>
        public int editType { get; set; }

        public int Id { get; set; }
        public int diId { get; set; }

        /// <summary>
        /// 费用名称
        /// </summary>
        public string priceName { get; set; }

        /// <summary>
        /// 金额
        /// </summary>
        public decimal price { get; set; }

        /// <summary>
        /// 费用类型Id
        /// </summary>
        public int priceType { get; set; }

        /// <summary>
        /// 费用详细类型Id
        /// </summary>
        public int priceDetailType { get; set; }

        /// <summary>
        /// 系数
        /// </summary>
        public decimal coefficient { get; set; }

        /// <summary>
        /// 费用币种
        /// </summary>
        public int currency { get; set; }

        /// <summary>
        /// 收款方
        /// </summary>
        public string payee { get; set; }

        /// <summary>
        /// 费用标识
        /// </summary>
        public int costSign { get; set; }

        /// <summary>
        /// 支付方式
        /// </summary>
        public int payType { get; set; }

        /// <summary>
        /// 卡类型，支付方式为刷卡时有效
        /// </summary>
        public int payCardId { get; set; }

        /// <summary>
        /// 附件路径
        /// </summary>
        public string filePath { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string remark { get; set; }

        /// <summary>
        /// 操作人员
        /// </summary>
        public int createUser { get; set; }

        /// <summary>
        /// 费用实际产生日期
        /// </summary>
        public string PriceDt { get; set; }

        /// <summary>
        /// 费用数量
        /// </summary>
        public int PriceCount { get; set; }
    }

    public class Fin_GroupExtraCostDto_Search : DtoBase
    {
        public int diId { get; set; }
    }

    public class Fin_GroupExtraCostDto_Detail : PortDtoBase
    {
        public int Id { get; set; }
    }

    public class Fin_GroupExtraCostDto_DataListInit : PortDtoBase
    {
    }

    public class Fin_GroupExtraCostExcelDto : PortDtoBase
    {
        public int diId { get; set; }
    }

    public class Fin_GroupExtraCostExcelColumnSetting
    {
        public int columnIndex { get; set; }
        public string columnName { get; set; }
        public double columnWidth { get; set; }
        public int rowCount { get; set; } = 1;
    }
}
