﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{
    /// <summary>
    /// 财务模块
    /// 对外收款
    /// </summary>
    public class ForForeignReceivablesInfoDto: PortDtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }
    }

    /// <summary>
    /// 财务模块
    /// 收款账单
    /// Add or Update Info
    /// </summary>
    public class ForeignReceivablesAddAndUpdateDto : PortDtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        /// <summary>
        /// 用户Id
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// 财务模块
        /// Add or Update Info
        /// </summary>
        public List<ForeignReceivablesInfo>? foreignReceivablesInfos { get; set; }
    }

    /// <summary>
    /// 财务模块
    /// Add or Update Info
    /// </summary>
    public class ForeignReceivablesInfo 
    {
        /// <summary>
        /// 主键编号
        /// id=0 时添加
        /// 其他值时 修改
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 费用名称
        /// </summary>
        public string? PriceName { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 数量
        /// </summary>
        public int Count { get; set; }

        /// <summary>
        /// 单位
        /// </summary>
        public string? Unit { get; set; }

        /// <summary>
        /// 单项总和
        /// </summary>
        public decimal ItemSumPrice { get; set; }

        /// <summary>
        /// 汇率
        /// </summary>
        public decimal Rate { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public int Currency { get; set; }

        /// <summary>
        /// 添加方式   
        /// 0 - 账单页面添加   1 - 预算成本页面添加
        /// </summary>
        public int AddingWay { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }
    }

    /// <summary>
    /// 应收款项 删除Id dto
    /// </summary>
    public class DelForForeignReceivablesInfoDto
    {
        /// <summary>
        /// 用户Id
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// 主键
        /// </summary>
        public int Id { get; set; }
    }

    
}
