﻿using OASystem.Domain.Dtos.System;
using OASystem.Domain.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{
    /// <summary>
    /// 收款退还与其他款项
    /// Item Dto
    /// </summary>
    public class PaymentRefundAndOtherMoneyItemByDiIdDto : UserPageFuncDtoBase
    {
        /// <summary>
        /// 团组Id 
        /// </summary>
        public int DiId { get; set; }
    }

    /// <summary>
    /// 收款退还与其他款项
    /// Del Dto
    /// </summary>
    public class PaymentRefundAndOtherMoneyDelDto:UserPageFuncDtoBase
    {
        /// <summary>
        ///  Id 
        /// </summary>
        public int Id { get; set; }
    }

    /// <summary>
    /// 收款退还与其他款项
    /// 详情 Dto
    /// </summary>
    public class PaymentRefundAndOtherMoneyInfoDto : PortDtoBase
    {
        /// <summary>
        /// Id 
        /// </summary>
        public int Id { get; set; }
    }

    /// <summary>
    /// 收款退还与其他款项
    /// 操作(Add Or Update) Dto
    /// </summary>
    public class PaymentRefundAndOtherMoneyAddOrEditDto : UserPageFuncDtoBase
    {
        /// <summary>
        /// 操作状态
        /// 1 添加 
        /// 2 修改 
        /// </summary>
        public int Status { get; set; }

        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// C表Id
        /// </summary>
        public int CcpId { get; set; }

        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        /// <summary>
        /// 费用名称
        /// </summary>
        public string? PriceName { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 币种Id
        /// </summary>
        public int CurrencyId { get; set; }

        /// <summary>
        /// 币种Code
        /// </summary>
        public string? CurrencyCode { get; set; }

        /// <summary>
        /// 收款方
        /// </summary>
        public string? Payee { get; set; }

        /// <summary>
        /// 支付方式Id
        /// </summary>
        public int PayDId { get; set; }

        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }

        /// <summary>
        /// 消费方式
        /// </summary>
        public string? ConsumptionPatterns { get; set; }

        /// <summary>
        /// 费用类型
        /// 0 其他 1 退多付款
        /// </summary>
        public int PayType { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }
    }
}
