﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{
    public class PostPayRequestByDateRangeDto:UserPageFuncDtoBase
    {
        /// <summary>
        /// 数据选中状态
        /// 1 全部 2 选中
        /// </summary>
        public int Status { get; set; }

        public string beginDt { get; set; }
        public string endDt { get; set; }
    }

    public class PayRequestRateChangeDto: PostPayRequestByDateRangeDto
    {
        public int UserId { get; set; }
        public int Id { get; set; }
        public decimal Rate { get; set; }
    }

    public class PayRequestPayChangeDto
    {
        public int UserId { get; set; }

        /// <summary>
        /// 团组相关费用 id集合 多个英文逗号隔开 
        /// 1,2,3,4,5
        /// </summary>
        public string GroupIds { get; set; }

        /// <summary>
        /// 日付相关费用 id集合 多个英文逗号隔开 
        /// 1,2,3,4,5
        /// </summary>
        public string DailyPaymentIds { get; set; }
    }

    public class PayRequestCheckedChangeDto: PayRequestPayChangeDto
    {
        /// <summary>
        /// 操作类型
        /// 1 checked 2 清除上次勾选
        /// </summary>
        public int Type { get; set; }
    }

    public class PayRequestFileDownloadDto: UserPageFuncDtoBase
    {

        public string beginDt { get; set; }
        public string endDt { get; set; }

        public int ConpanyId { get; set; }
    }
}
