﻿using OASystem.Domain.ViewModels.Financial;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{

    /// <summary>
    /// 团组汇率 Dto
    /// </summary>
    public class TeamRateDto : DtoBase
    {
    }

    /// <summary>
    /// 团组汇率信息 Dto
    /// </summary>
    public class TeamRateInfoDto : DtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int Diid { get; set; }
    }

    /// <summary>
    /// 团组汇率信息 Dto
    /// </summary>
    public class TeamRateUpdateDto : DtoBase
    {
        /// <summary>
        /// 创建用户Id
        /// </summary>
        public int CreateUserId { get; set; }

        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        /// <summary>
        /// 团组汇率 信息
        /// </summary>
        public List<TeamRateUpdateInfo>? teamRateUpdateInfos { get; set; }
    }

    /// <summary>
    /// 团组汇率信息
    /// </summary>
    public class TeamRateUpdateInfo
    {
        /// <summary>
        /// 团组汇率Id
        /// </summary>
        public int Id { get; set; }


        /// <summary>
        /// 团组指向分类
        /// </summary>
        public int CTable { get; set; }

        /// <summary>
        /// 币种 Info
        /// </summary>
        public List<TeamRateDescView>? teamRates { get; set; }
    }

    /// <summary>
    /// 通用团组汇率 Dto
    /// </summary>
    public class GeneralTeamRateInfoDto:PortDtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        /// <summary>
        /// 业务类型Id
        /// 酒店预定，机票预定，等等
        /// 76	酒店预订 77	行程           79  车/导游地接
        /// 80	签证     81	邀请/公务活动  82  团组客户保险
        /// 85	机票预订 98	其他款项       751 酒店早餐
        /// </summary>
        public int CTable { get; set; }
    }
}
