﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Groups
{
    /// <summary>
    /// Op费用根据diid查询列表
    /// </summary>
    public class CarTouristGuideGroundDto: DtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        public int IsPaySign { get; set; } = -1;
    }
    /// <summary>
    /// 根据id查询单挑数据
    /// </summary>
    public class CarTouristGuideGroundIdDto
    {
        public int Id { get; set; }
    }
    /// <summary>
    /// op费用新增、修改
    /// </summary>
    public class OpCarTouristGuideGroundDto
    {
        /// <summary>
        /// 操作状态
        /// 1 添加 
        /// 2 修改 
        /// </summary>
        public int Status { get; set; }
        /// <summary>
        /// 编号
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DiId { get; set; }
        /// <summary>
        /// 地接地区
        /// </summary>
        public string Area { get; set; }
        /// <summary>
        /// 服务公司
        /// </summary>
        public string ServiceCompany { get; set; }
        /// <summary>
        /// 服务导游
        /// </summary>
        public string ServiceGuide { get; set; }
        /// <summary>
        /// 导游地接联系电话
        /// </summary>
        public string ServiceTel { get; set; }
        /// <summary>
        /// Bus名称
        /// </summary>
        public string BusName { get; set; }
        /// <summary>
        /// Bus描述
        /// </summary>
        public string BusDescription { get; set; }
        /// <summary>
        /// 车公司联系电话
        /// </summary>
        public string BusTel { get; set; }

        /// <summary>
        /// 服务时间起
        /// </summary>
        public string ServiceStartTime { get; set; }
        /// <summary>
        /// 服务时间止
        /// </summary>
        public string ServiceEndTime { get; set; }
        /// <summary>
        /// 服务描述
        /// </summary>
        public string ServiceDescription { get; set; }
       
        /// <summary>
        /// 公转私转标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }
        /// <summary>
        /// 创建者Id
        /// </summary>
        public int CreateUserId { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        /// 此笔费用类型
        /// </summary>
        public int PriceType { get; set; }

    }

    public class CarTouristGuideGroundContentDto : PortDtoBase
    {
        public int UserId { get; set; }

        public int Id { get; set; }
    }

    public class OpCarTouristGuideGroundContentDto
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }
        /// <summary>
        /// Op费用Id
        /// </summary>
        public int CTGGRId { get; set; }
        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }
        /// <summary>
        /// 付款百分百
        /// </summary>
        public decimal PayPercentage { get; set; }
        /// <summary>
        /// 收款方
        /// </summary>
        public string Payee { get; set; }
        /// <summary>
        /// 支付方式
        /// </summary>
        public int PayDId { get; set; }
        /// <summary>
        /// 币种Id
        /// </summary>
        public int Currency { get; set; }
        /// <summary>
        /// 详情数据
        /// </summary>
        public List<OPContentList> OPContentList { get; set; }
        /// <summary>
        /// 创建人Id
        /// </summary>
        public int CreateUserId { get; set; }

        /// <summary>
        /// 选中的列
        /// </summary>
        public List<string> SelectCheck { get; set; }
    }
    public class OPContentList
    {
        
        /// <summary>
        /// 费用详细Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 类型名称Id
        /// </summary>
        public int SId { get; set; }
        /// <summary>
        /// 费用金额
        /// </summary>
        public decimal Price { get; set; }
        /// <summary>
        /// 费用描述
        /// </summary>
        public string priceContent { get; set; }

        /// <summary>
        /// 费用日期
        /// </summary>
        public DateTime? DatePrice { get; set; }

        /// <summary>
        /// 数量
        /// </summary>
        public int Count { get; set; }

        /// <summary>
        /// 单位
        /// </summary>
        public int Units { get; set; }


        ///// <summary>
        ///// 备注
        ///// </summary>
        //public string Remark { get; set; }
    }


    public class InitOpTravelDto
    {
        public int Diid { get; set;}
    }

    public class DelOpTravelDto
    {
        public int Diid { get; set; }

        public int UserId { get; set; }
    }

    public class TravelSaveDto
    {
       public List<TravelArrView> Arr { get; set; }

    }

    public class TravelArrView
    {
        public int Id { get; set; }
        /// <summary>
        ///  团组ID
        /// </summary>
        public int Diid { get; set; }

        /// <summary>
        ///  天数
        /// </summary>
        public int Days { get; set; }

        /// <summary>
        ///  日期
        /// </summary>
        public string Date { get; set; }

        /// <summary>
        ///  星期
        /// </summary>
        public string WeekDay { get; set; }

        /// <summary>
        ///  当日第1个交通工具
        /// </summary>
        public string Traffic_First { get; set; }

        /// <summary>
        ///   当日第2个交通工具
        /// </summary>
        public string Traffic_Second { get; set; }

        /// <summary>
        ///  行程       
        /// </summary>
        public string Trip { get; set; }

        /// <summary>
        /// 区分属于第几次保存
        /// </summary>
        public int Diffgroup { get; set; }
    }
}
