﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Groups
{
    /// <summary>
    /// 团组增减款项Dto
    /// </summary>
    public class DecreasePaymentsDto
    {
        public int UserId { get; set; }
        public int CTId { get; set; }
        public int PageIndex { get; set; } = 1;
        public int PageSize { get; set; } = 10;
        
    }
    public class DecreasePaymentsListDto
    {
        public int UserId { get; set; }
        public int DiId { get; set; }
        public int IsPaySign { get; set; } = -1;
    }
    /// <summary>
    /// 团组增减款项操作
    /// </summary>
    public class DecreasePaymentsOpDto
    {
        /// <summary>
        /// 操作状态
        /// 1 添加 
        /// 2 修改 
        /// </summary>
        public int Status { get; set; }
        /// <summary>
        /// 支付方式
        /// </summary>
        public int PayDId { get; set; }
        /// <summary>
        /// 费用表示
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }
        /// <summary>
        /// 收款方
        /// </summary>
        public string Payee { get;set; }
        /// <summary>
        /// 编号
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DiId { get; set; }
        /// <summary>
        /// 费用名称
        /// </summary>
        public string PriceName { get; set; }
        /// <summary>
        /// 费用金额
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 费用币种
        /// </summary>
        public int Currency { get; set; }
        /// <summary>
        /// 附件地址
        /// </summary>
        public string FilePath { get; set; }
        /// <summary>
        /// 创建者Id
        /// </summary>
        public int CreateUserId { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }
    public class DecreasePaymentsByIdDto
    {
        public int Id { get; set; }
    }

    public class DelFileDto
    {
        public string fileName { get; set; }

        public int Id { get; set; }
    }
}
