﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Groups
{
    /// <summary>
    /// 根据团组id查询签证费用列表
    /// </summary>
    public class VisaPriceDto
    {
        public int PageIndex { get; set; } = 1;
        public int PageSize { get; set; } = 10;
        public int PortType { get; set; } = 1;
        public int DiID { get; set; }
        /// <summary>
        /// 客户名称
        /// </summary>
        public String VisaClient { get; set; }
        public int IsPaySign { get; set; } = -1;
    }
    public class PostVisaByIdDto 
    {
        public int Id { get; set; }
    }
    /// <summary>
    /// 签证费用修改添加dto
    /// </summary>
    public class OpVisaPriceDto
    {
        /// <summary>
        /// 操作状态
        /// 1 添加 
        /// 2 修改 
        /// </summary>
        public int Status { get; set; }
        /// <summary>
        /// 主键Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }
        /// <summary>
        /// 签证客户
        /// </summary>
        public string VisaClient { get; set; }
        /// <summary>
        /// 签证费用
        /// </summary>
        public decimal VisaPrice { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public int VisaCurrency { get; set; }
        /// <summary>
        /// 是否第三方代办
        /// </summary>
        public int IsThird { get; set; }
        /// <summary>
        /// 签证人员类型
        /// </summary>
        public int PassengerType { get; set; }
        /// <summary>
        /// 办理签证人数
        /// </summary>
        public int VisaNumber { get; set; }
        /// <summary>
        /// 免签人数
        /// </summary>
        public int VisaFreeNumber { get; set; }

        /// <summary>
        /// 创建者Id
        /// </summary>
        public int CreateUserId { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }


        //c表dto参数
        /// <summary>
        /// 支付方式
        /// </summary>
        public int PayDId { get; set; }
        /// <summary>
        /// 消费方式
        /// </summary>
        public string ConsumptionPatterns { get; set; }
        /// <summary>
        /// 消费日期
        /// </summary>
        public String ConsumptionDate { get; set; }
        /// <summary>
        /// 卡类型
        /// </summary>
        public int CTDId { get; set; }

        /// <summary>
        /// 公司银行卡号
        /// </summary>
        public string CompanyBankNo { get; set; }
        /// <summary>
        /// 对方开户行
        /// </summary>
        public string OtherBankName { get; set; }
        /// <summary>
        /// 对方银行账号
        /// </summary>
        public string OtherSideNo { get; set; }
        /// <summary>
        /// 对方姓名
        /// </summary>
        public string OtherSideName { get; set; }

        /// <summary>
        /// 银行卡号
        /// </summary>
        public string BankNo { get; set; }
        /// <summary>
        /// 持卡人姓名
        /// </summary>
        public string CardholderName { get; set; }
        /// <summary>
        /// 收款方
        /// </summary>
        public string Payee { get; set; }
        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }

        /// <summary>
        /// C表备注
        /// </summary>
        public string CRemark { get; set; }

        /// <summary>
        /// 签证描述
        /// </summary>
        public string VisaDescription { get; set; }
    }
}
