﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.QiYeWeChat
{
    /// <summary>
    /// 企业微信 
    /// 获取打卡记录数据 Dto
    /// </summary>
    public class CheckInData_Request
    {
        /// <summary>
        /// 调用接口凭证。必须使用打卡应用的Secret获取access_token，获取方式参考：文档-获取access_token
        /// </summary>
        public string access_token { get; set; }

        /// <summary>
        /// 打卡类型。1：上下班打卡；2：外出打卡；3：全部打卡
        /// </summary>
        public int opencheckindatatype { get; set; }

        /// <summary>
        /// 获取打卡记录的开始时间。Unix时间戳
        /// </summary>
        public long starttime { get; set; }

        /// <summary>
        /// 获取打卡记录的结束时间。Unix时间戳
        /// </summary>
        public long endtime { get; set; }

        /// <summary>
        /// 需要获取打卡记录的用户列表
        /// </summary>
        public List<string> useridlist { get; set; }
    }
}
