﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.QiYeWeChat
{
    /// <summary>
    /// 企业微信API
    /// 添加员工
    /// </summary>
    public class Create_Request
    {/// <summary>
     /// 调用接口凭证
     /// </summary>
        public string? access_token { get; set; }

        /// <summary>
        /// 成员UserID。对应管理端的账号，企业内必须唯一。长度为1~64个字节。只能由数字、字母和“_-@.”四种字符组成，且第一个字符必须是数字或字母。系统进行唯一性检查时会忽略大小写
        /// </summary>
        public string? userid { get; set; }

        /// <summary>
        /// 成员名称。长度为1~64个utf8字符
        /// </summary>
        public string? name { get; set; }

        /// <summary>
        /// 手机号码。企业内必须唯一，mobile/email二者不能同时为空
        /// </summary>
        public string? mobile { get; set; }

        /// <summary>
        /// 成员所属部门id列表，不超过100个
        /// </summary>
        public List<long> department { get; set; }

        /// <summary>
        /// 职务信息。长度为0~128个字符
        /// </summary>
        public string? position { get; set; }

        /// <summary>
        /// 性别。1表示男性，2表示女性
        /// </summary>
        public int gender { get; set; }

        /// <summary>
        /// 企业邮箱。仅对开通企业邮箱的企业有效。长度6~64个字节，且为有效的企业邮箱格式。
        /// 企业内必须唯一。
        /// 未填写则系统会为用户生成默认企业邮箱（由系统生成的邮箱可修改一次，2022年4月25日之后创建的成员需通过企业管理后台-协作-邮件-邮箱管理-成员邮箱修改）
        /// </summary>
        public string? biz_mail { get; set; }

        /// <summary>
        /// 启用/禁用成员。1表示启用成员，0表示禁用成员
        /// </summary>
        public int enable { get; set; } = 1;
    }
}
