﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Statistics
{
    /// <summary>
    /// 团组报表
    /// Items Dto
    /// </summary>
    public class GroupStatementItemsDto : UserPageFuncDtoBase
    {
        public int PageIndex { get; set; }

        public int PageSize { get; set; }

        /// <summary>
        /// 是否操作完成 
        /// -1 全部 0 否 1 是
        /// </summary>
        public int IsSure { get; set; }

        /// <summary>
        /// 搜索条件
        /// 团组类型/团队名称/客户名称/客户单位/接团操作人
        /// </summary>
        public string? SearchCriteria { get; set; }
    }

    /// <summary>
    /// 团组报表
    /// Details Dto
    /// </summary>
    public class GroupStatementDetailsDto : UserPageFuncDtoBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }
    }

    /// <summary>
    /// 企业利润请求dto
    /// </summary>
    public class PostCorporateProfitDto : UserPageFuncDtoBase
    {
        /// <summary>
        /// 年份
        /// </summary>
        public int Year { get; set; }

        /// <summary>
        /// 业务类型
        /// 1 所有 2 团组 3 会务 
        /// </summary>
        public int BusinessType { get; set; }

        /// <summary>
        /// 统计类型
        /// 1 月份 2 季度 
        /// </summary>
        public int StatisticsType { get; set; }
    }

    /// <summary>
    /// 地区预订 dto
    /// </summary>
    public class PostRegionalBookingsNumberDto : UserPageFuncDtoBase
    {
        /// <summary>
        /// 类型
        /// 1 团 2 酒店 3 机票 4 车辆
        /// </summary>
        public int Type { get; set; }

        public int Year { get; set; }
    }

}
