﻿using OASystem.Domain.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.System
{
    /// <summary>
    /// 发布消息 提交参数实体类
    /// </summary>
    public class MessageDto
    {
        /// <summary>
        /// 消息类型 
        /// 1 公告通知
        /// 2 团组流程管控通知
        /// 1 团组业务操作通知
        /// 2 团组费用审核消息
        /// 5 团组签证进度通知
        /// 6 团组任务进度通知
        /// </summary>
        public MessageTypeEnum Type { get; set; }

        /// <summary>
        /// 发布人
        /// </summary>
        public int IssuerId { get; set; }

        public int DiId { get; set; } = 0;

        /// <summary>
        /// 消息标题
        /// </summary>
        public string Title { get; set; }

        /// <summary>
        /// 消息内容
        /// </summary>
        public string Content { get; set; }

        /// <summary>
        /// 发布时间
        /// </summary>
        public DateTime ReleaseTime { get; set; }

        /// <summary>
        /// 可阅读员工
        /// </summary>
        public List<int> UIdList { get; set; }

        /// <summary>
        /// 参数(json存储)
        /// </summary>
        public string Param { get; set; }
    }
}
