﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.System
{
    /// <summary>
    /// 消息列表
    /// 请求dto
    /// </summary>
    public class MsgDto:DtoBase
    {
        /// <summary>
        /// 用户ID
        /// </summary>
        public int UserId { get; set; }
    }

    /// <summary>
    /// 消息类型
    /// 请求dto
    /// </summary>
    public class MsgTypeDto : PortDtoBase
    {
        /// <summary>
        /// 用户ID
        /// </summary>
        public int UserId { get; set; }
    }
   
    public class PotsMessagePageListDto : DtoBase
    {
        /// <summary>
        /// 消息类型
        /// 1020 团组操作通知 1021 任务操作通知 1022 系统公告
        /// </summary>
        public int Type { get; set; }

        public int UserId { get; set; }

        /// <summary>
        /// 阅读状态
        /// 1 全部(包含已读/未读) 2 未读 3 已读
        /// </summary>
        public int ReadStatus { get; set; }
    }

    public class PotsMessageUnreadTotalCountDto
    {
        public int UserId { get; set; }

    }

    /// <summary>
    /// 消息详细信息
    /// 请求dto
    /// </summary>
    public class MsgInfoDto : PortDtoBase
    {
        public int UserId { get; set; }
        /// <summary>
        /// 消息Id
        /// </summary>
        public int MsgId { get; set; }
        
    }

    /// <summary>
    /// 消息设置已读
    /// 请求dto
    /// </summary>
    public class MsgSetReadDto : PortDtoBase
    {
        /// <summary>
        /// 
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// MsgAnthId
        /// </summary>
        public int MsgId { get; set; }
    }

    /// <summary>
    /// 消息删除
    /// 请求dto
    /// </summary>
    public class MsgDeleteDto : DtoBase
    {
        /// <summary>
        /// MsgId
        /// </summary>
        public int MsgId { get; set; }

        /// <summary>
        /// userId
        /// </summary>
        public int UserId { get; set; }
    }
}
