﻿using OASystem.Domain.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Customer
{
    /// <summary>
    /// 表操作记录
    /// </summary>
    [SugarTable("Crm_TableOperationRecord")]
    public class Crm_TableOperationRecord : EntityBase
    {
        /// <summary>
        /// 表名
        /// "Crm_NewClientData" 客户资料表
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? TableName { get; set; }

        /// <summary>
        /// 1 Web 2 安卓 3 苹果
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int PortType { get; set; }

        /// <summary>
        /// 操作项目
        /// 0 未操作 1浏览列表 2 浏览详情 3 添加 4 修改 5 删除 6 审核 7 上传 8 下载
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public OperationEnum OperationItem { get; set; } = OperationEnum.NoOperation;

        /// <summary>
        /// 数据Id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int DataId { get; set; } = 0;
    }
}
