﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.District
{
    /// <summary>
    /// 地区 城市
    /// </summary>
    [SugarTable("Dis_City")]
    public class Dis_City : EntityBase
    {
        /// <summary>
        /// 国家表Id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int CountryId { get; set; }

        /// <summary>
        /// 城市名称 中文
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? CnName { get; set; }

        /// <summary>
        /// 城市名称 英文
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? EnName { get; set; }

        /// <summary>
        /// 城市三字码 机场三字码
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(20)")]
        public string? ThreeCharacterCode { get; set; }

        /// <summary>
        /// 城市四字码
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(20)")]
        public string? FourCharacterCode { get; set; }

        /// <summary>
        /// 城市机场中文名称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? CnAirportName { get; set; }

        /// <summary>
        /// 城市机场英名称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(100)")]
        public string? EnAirportName { get; set; }
    }
}
