﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.District
{

    /// <summary>
    /// 地区 国家表
    /// </summary>
    [SugarTable("Dis_Country")]
    public class Dis_Country : EntityBase
    {
        /// <summary>
        /// 洲际表Id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int IntercontinentalId { get; set; }

        /// <summary>
        /// 国家名称 全称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(100)")]
        public string? FullName { get; set; }


        /// <summary>
        /// 国家名称 简称 中文
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? CnShortName { get; set; }

        /// <summary>
        /// 国家名称 简称 英文
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(100)")]
        public string? EnShortName { get; set; }

        /// <summary>
        /// 国家币种三字码Code 
        /// </summary>
        public string? CurrencyCode { get; set; }
    }
}
