﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Financial
{
    /// <summary>
    /// 收款退还
    /// </summary>
    [SugarTable("Fin_PaymentRefundAndOtherMoney")]
    public class Fin_PaymentRefundAndOtherMoney : EntityBase
    {
        /// <summary>
        /// 团组id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int DiId { get; set; }

        /// <summary>
        /// 费用名称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(125)")]
        public string? PriceName { get; set; }

        /// <summary>
        /// 费用金额
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public decimal Price { get; set; }

        /// <summary>
        /// 费用币种
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int CurrencyId { get; set; }

        /// <summary>
        /// 付款类型？？？ 
        /// 0 其他  1 退多付款
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int PayType { get; set; }

        /// <summary>
        /// 退款表识 
        /// 0 未退 1 已退
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int PriceType { get; set; }

    }
}
