﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Financial
{
    /// <summary>
    /// 财务 - 已收款项
    /// 雷怡 2023-08-14 17:07
    /// </summary>
    public class Fin_ProceedsReceived:EntityBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int Diid { get; set; }

        /// <summary>
        /// 到款时间
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? SectionTime { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(18,2)")]
        public decimal Price { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int Currency { get; set; }

        /// <summary>
        /// 收款类型
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int ReceivablesType { get; set; }

        /// <summary>
        /// 收款单位
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(200)")]
        public string? Client { get; set; }

        /// <summary>
        /// 收款单位 负责人 姓名
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(100)")]
        public string? CustomerName { get; set; }

        /// <summary>
        /// 收款单位 负责人 电话
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(30)")]
        public string? CustomerTel { get; set; }

        /// <summary>
        /// 应付项id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int FID { get; set; } = 0;
    }
}
