﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Financial
{
    /// <summary>
    /// 团组汇率表
    /// </summary>
    [SugarTable("Grp_TeamRate")]
    public class Grp_TeamRate : EntityBase
    {
        /// <summary>
        /// 团组id
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int DiId { get; set; }

        /// <summary>
        /// 团组指向分类
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int CTable { get; set; }
        /// <summary>
        /// 其他汇率名称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(20)")]
        public string OtherRateCode { get; set; }

        /// <summary>
        /// 其他汇率金额
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal OtherPrice { get; set; }

        /// <summary>
        /// 美元汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateU { get; set; }

        /// <summary>
        /// 欧元汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateE { get; set; }
        /// <summary>
        /// 日元汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateJ { get; set; }
        /// <summary>
        /// 港币汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateH { get; set; }
        /// <summary>
        /// 新西兰元汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateN { get; set; }
        /// <summary>
        /// 新加坡币汇率
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateS { get; set; }
        /// <summary>                                    
        /// 澳大利亚元汇率                               
        /// </summary>                                   
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateA { get; set; }
        /// <summary>                                     
        /// 加拿大元汇率                                  
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateC { get; set; }
        /// <summary>                                     
        /// 泰铢汇率                                      
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateT { get; set; }
        /// <summary>                                    
        /// 波兰汇率                                     
        /// </summary>                                   
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateBL { get; set; }
        /// <summary>                                     
        /// 韩币                                          
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateHB { get; set; }
        /// <summary>                                     
        /// 斐济币汇率                                    
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateFJD { get; set; }
        /// <summary>                                     
        /// 土耳其币汇率                                  
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateTL { get; set; }
        /// <summary>                                     
        /// 卢比汇率                                      
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateRP { get; set; }
        /// <summary>                                    
        /// 菲律宾汇率                                   
        /// </summary>                                   
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RatePeso { get; set; }
        /// <summary>                                     
        /// 马来西亚汇率                                  
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateMYR { get; set; }
        /// <summary>                                     
        /// 捷克币汇率                                    
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateCZK { get; set; }
        /// <summary>                                     
        /// 墨西哥币汇率                                  
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateMXN { get; set; }
        /// <summary>                                    
        /// 澳门元                                       
        /// </summary>                                   
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateMOP { get; set; }
        /// <summary>                                     
        /// 阿根廷比索                                    
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateARS { get; set; }
        /// <summary>                                     
        /// 匈牙利货币                                    
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateHUF { get; set; }
        /// <summary>                                     
        /// 俄罗斯卢布                                    
        /// </summary>                                    
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,4)")]
        public decimal RateRUB { get; set; }
    }
}
