﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Groups
{
    /// <summary>
    /// 司兼导
    /// </summary>
    public class Grp_CarGuides:EntityBase
    {
        /// <summary>
        /// 国家
        /// </summary>
        public string Country { get; set; }

        /// <summary>
        /// 城市
        /// </summary>
        public string City { get; set; }

        /// <summary>
        /// 服务类型
        /// </summary>
        public string ServiceType { get; set; }
        /// <summary>
        /// 车类型
        /// </summary>
        public string CarType { get; set; }
        /// <summary>
        /// 用车报价
        /// </summary>
        public string Offer { get; set; }
        /// <summary>
        /// 司兼导费用
        /// </summary>
        public string CGCost { get; set; }
        /// <summary>
        /// 用车时长
        /// </summary>
        public string RuningTime { get; set; }
        /// <summary>
        /// 车超时费用/时
        /// </summary>
        public string OvertimeFee { get; set; }
        /// <summary>
        /// 司兼导超时费/时
        /// </summary>
        public string CGOvertimeFee { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public string Currency { get; set; }
    }

    /// <summary>
    /// 导游
    /// </summary>

    public class Grp_GuidesInfo : EntityBase
    {
        /// <summary>
        /// 国家
        /// </summary>
        public string Country { get; set; }
        /// <summary>
        /// 城市
        /// </summary>
        public string City { get; set; }
        /// <summary>
        /// 导游服务类型
        /// </summary>
        public string ServiceType { get; set; }
        /// <summary>
        /// 工作时间
        /// </summary>
        public string When { get; set; }
        /// <summary>
        /// 导游工资
        /// </summary>
        public string Price { get; set; }
        /// <summary>
        /// 翻译工资
        /// </summary>
        public string TranslationPrice { get; set; }

        /// <summary>
        /// 超时费用
        /// </summary>
        public string OvertimeFee { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public string Currency { get; set; }
    }


    /// <summary>
    /// 车数据
    /// </summary>
    public class Grp_CarInfo : EntityBase
    {
        /// <summary>
        /// 国家
        /// </summary>
        public string Country { get; set; }
        /// <summary>
        /// 城市
        /// </summary>
        public string City { get; set; }
        /// <summary>
        /// 车类型
        /// </summary>
        public string CarType { get; set; }
        /// <summary>
        /// 服务类型
        /// </summary>
        public string ServiceType { get; set; }
        /// <summary>
        /// 用车时间
        /// </summary>
        public string When { get; set; }
        /// <summary>
        /// 价格
        /// </summary>
        public string Price { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public string Currency { get; set; }
        /// <summary>
        /// 超时费用
        /// </summary>
        public string OvertimeFee { get; set; }
    }


    /// <summary>
    /// 景点类
    /// </summary>
    public class Grp_ScenicSpotInfo : EntityBase
    {
        /// <summary>
        /// 国家
        /// </summary>
        public string Country { get; set; }
        /// <summary>
        /// 城市
        /// </summary>
        public string City { get; set; }
        /// <summary>
        /// 景点
        /// </summary>
        public string ScenicSpot { get; set; }
        /// <summary>
        /// 景点项目描述
        /// </summary>
        public string ScenicSpotDetail { get; set; }
        /// <summary>
        /// 景点价格
        /// </summary>
        public float Price { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public string Currency { get; set; }
        /// <summary>
        /// 汇率
        /// </summary>
        public float Rate { get; set; }
        /// <summary>
        /// 景点地址
        /// </summary>
        public string Address { get; set; }
    }

}
