﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Groups
{
    /// <summary>
    /// 车/导游地接预订详细类
    /// </summary>
    public class Grp_CarTouristGuideGroundReservationsContent:EntityBase
    {
        /// <summary>
        /// 团组外键编号
        /// </summary>
        [SugarColumn(IsNullable =true,ColumnDataType ="int")]
        public int DiId { get; set; }

        /// <summary>
        /// 车/导游地接预订外键编号
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int CTGGRId { get; set; }
        /// <summary>
        /// 费用项目明细
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int SId { get; set; }
        /// <summary>
        /// 金额
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(18,2)")]
        public decimal Price { get; set; }
        /// <summary>
        /// 费用明细
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(500)")]
        public string PriceContent { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int Currency { get; set; }

        /// <summary>
        /// 费用日期
        /// </summary>
        [SugarColumn(ColumnDescription = "费用日期", IsNullable = true, ColumnDataType = "DateTime")]
        public DateTime? DatePrice { get; set; }

        /// <summary>
        /// 数量
        /// </summary>
        [SugarColumn(ColumnDescription = "数量", IsNullable = true, ColumnDataType = "int")]
        public int Count { get; set; }

        /// <summary>
        /// 单位
        /// </summary>
        [SugarColumn(ColumnDescription = "单位", IsNullable = true, ColumnDataType = "int")]
        public int Units { get; set; }
    }
}
