﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Groups
{
    /// <summary>
    /// 团组 - 出入境国家费用标准
    /// 适用于出入境模块
    /// </summary>
    [SugarTable("Grp_NationalTravelFee")]
    public class Grp_NationalTravelFee : EntityBase
    {
        /// <summary>
        /// 洲别
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? Continent { get; set; }

        /// <summary>
        /// 国家
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? Country { get; set; }

        /// <summary>
        /// 城市
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(50)")]
        public string? City { get; set; }

        /// <summary>
        /// 币种
        /// Sys_SetData STid=66
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int Currency { get; set; }

        /// <summary>
        /// 住宿费
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public string? RoomCost { get; set; }

        /// <summary>
        /// 伙食费
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public string? FoodCost { get; set; }

        /// <summary>
        /// 公杂费 
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public string? PublicCost { get; set; }

        /// <summary>
        /// 最后更新人 
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int LastUpdateUserId { get; set; }

        /// <summary>
        /// 最后更新时间 
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "DateTime")]
        public DateTime? LastUpdateTime { get; set; } = DateTime.Now;

    }
}
