﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Groups
{
    /// <summary>
    /// 接团客户名单
    /// 关联表 
    /// 关联 团组信息 客户资料库 
    /// </summary>
    [SugarTable("Grp_TourClientList")]
    public class Grp_TourClientList : EntityBase
    {
        /// <summary>
        /// 团组Id(团组信息表)
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int DiId { get; set; }

        /// <summary>
        /// 客户Id(客户资料表)
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int ClientId { get; set; }

        /// <summary>
        /// 舱位类型Id (数据表Id)
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int ShippingSpaceTypeId { get; set; }

        /// <summary>
        /// 舱位特殊需求
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(500)")]
        public string? ShippingSpaceSpecialNeeds { get; set; }

        /// <summary>
        /// 酒店特殊需求
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(500)")]
        public string? HotelSpecialNeeds { get; set; }

        /// <summary>
        /// 餐食特殊需求
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "varchar(500)")]
        public string? MealSpecialNeeds { get; set; }
    }
}
