﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Entities.Groups
{
    /// <summary>
    /// 团组签证
    /// 费用详情
    /// </summary>
    [SugarTable("Grp_VisaFeeInfo")]
    public class Grp_VisaFeeInfo:EntityBase
    {
        /// <summary>
        /// 团组Id
        /// </summary>
        [SugarColumn(IsNullable = true ,ColumnDataType = "int")]
        public int DiId { get; set; }

        /// <summary>
        /// 是否选中
        /// 0 未选 1 选中
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int IsChecked { get; set; } = 0;

        /// <summary>
        /// 国家签证费用 Id
        /// Res_CountryFeeCost Id
        /// </summary>
        [SugarColumn(IsNullable = true,ColumnDataType = "int")]
        public int CountryVisaFeeId { get; set; }


        /// <summary>
        /// 代办费 - 公务 类型 1 大公务 2 小公务
        /// 新增字段
        /// 雷怡 2024-05-07 15:45:09
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "int")]
        public int OBType { get; set; }

        /// <summary>
        /// 代办费
        /// 新增字段
        /// 雷怡 2024-05-07 15:45:09
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public decimal AgencyFee { get; set; }


        /// <summary>
        /// 其他费用
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDataType = "decimal(10,2)")]
        public decimal OtherFee { get; set; }
    }
}
