﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Enums
{
    /// <summary>
    /// 任务指派状态
    /// </summary>
    public enum TaskEnum : int
    {
        /// <summary>
        /// 任务指派状态
        /// 未开始
        /// </summary>
        NotStarted = 0,
        /// <summary>
        /// 任务指派状态
        /// 进行中
        /// </summary>
        UnderWay = 1,
        /// <summary>
        /// 任务指派状态
        /// 待审核
        /// </summary>
        WaitConfirm = 2,
        /// <summary>
        /// 任务指派状态
        /// 未完成
        /// </summary>
        UnFinished = 3,
        /// <summary>
        /// 任务指派状态
        /// 已完成
        /// </summary>
        Finished = 4,
        /// <summary>
        /// 任务指派状态
        /// 任务终止
        /// </summary>
        TaskStop = 5

    }

    /// <summary>
    /// 任务者状态
    /// </summary>
    public enum TaskerEnum : int
    {
        /// <summary>
        /// 任务指派状态
        /// 未开始
        /// </summary>
        NotStarted = -1,
        /// <summary>
        /// 任务指派状态
        /// 已知晓
        /// </summary>
        HaveKnown = 0,
        /// <summary>
        /// 任务指派状态
        /// 进行中
        /// </summary>
        UnderWay = 1,
        /// <summary>
        /// 任务指派状态
        /// 待审核
        /// </summary>
        WaitConfirm = 2,
        /// <summary>
        /// 任务指派状态
        /// 未完成
        /// </summary>
        UnFinished = 3,
        /// <summary>
        /// 任务指派状态
        /// 已完成
        /// </summary>
        Finished = 4,
        /// <summary>
        /// 任务指派状态
        /// 任务终止
        /// </summary>
        TaskStop = 5
    }

    
}
