﻿using OASystem.Domain.Entities.System;
using System.Text.RegularExpressions;

namespace OASystem.Domain.ViewModels
{
    /// <summary>
    /// 公司视图表（返回数据model）安卓端
    /// </summary>
    public class CompanyView
    {
        /// <summary>
        /// 公司Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 公司Code
        /// </summary>
        public string CompanyCode { get; set; }
        /// <summary>
        /// 公司名称
        /// </summary>
        public string CompanyName { get; set; }

        /// <summary>
        /// 公司所在地
        /// </summary>
        public string Address { get; set; }
        /// <summary>
        /// 负责人Id
        /// </summary>
        public int ContactUserId { get; set; }
        /// <summary>
        /// 负责人名字
        /// </summary>
        public string ContactUserName { get; set; }
        /// <summary>
        /// 联系方式
        /// </summary>
        public string Tel { get; set; }
        
        /// <summary>
        /// 父级公司Id
        /// </summary>
        public int ParentCompanyId { get; set; }
        /// <summary>
        /// 父级公司Name
        /// </summary>
        public string ParentCompanyName { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

    }

    /// <summary>
    /// 公司名称
    /// </summary>
    public class CompanyNameView 
    {
        /// <summary>
        /// 公司Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 公司名称
        /// </summary>
        public string? CompanyName { get; set; }
    }


    /// <summary>
    /// 机票预订类
    /// </summary>
    public class oa2021_AirTicketReservations
    {
        int id;

        /// <summary>
        /// 主键编号
        /// </summary>
        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        int dIId;

        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DIId
        {
            get { return dIId; }
            set { dIId = value; }
        }
        string edition;
        /// <summary>
        /// 版本
        /// </summary>

        public string Edition
        {
            get { return edition; }
            set { edition = value; }
        }

        string flightsCode;

        /// <summary>
        /// 航班号
        /// </summary>
        public string FlightsCode
        {
            get { return flightsCode; }
            set { flightsCode = value; }
        }

        string flightsDate;

        /// <summary>
        /// 航班日期
        /// </summary>
        public string FlightsDate
        {
            get { return flightsDate; }
            set { flightsDate = value; }
        }

        string flightsTime;

        /// <summary>
        /// 航班时间
        /// </summary>
        public string FlightsTime
        {
            get { return flightsTime; }
            set { flightsTime = value; }
        }
        string arrivedTime;
        /// <summary>
        /// 抵达时间
        /// </summary>

        public string ArrivedTime
        {
            get { return arrivedTime; }
            set { arrivedTime = value; }
        }
        /// <summary>
        /// 是否值机
        /// </summary>
        public string IsCheckIn { get; set; }
        /// <summary>
        /// 是否选座
        /// </summary>
        public string IsSetSeat { get; set; }

        /// <summary>
        /// 是否购买行李服务
        /// </summary>
        public string IsPackage { get; set; }
        /// <summary>
        /// 是否行李直挂
        /// </summary>
        public string IsBagHandle { get; set; }
        /// <summary>
        /// 是否火车票出票选座
        /// </summary>
        public string IsTrain { get; set; }




        string flightsCity;

        /// <summary>
        /// 城市A-B
        /// </summary>
        public string FlightsCity
        {
            get { return flightsCity; }
            set { flightsCity = value; }
        }


        /// <summary>
        /// 去程航班描述代码
        /// </summary>
        public string LeaveDescription { get; set; }


        /// /// <summary>
        /// 内陆段航班描述
        /// </summary>
        public string FlightsDescription
        {
            get { return flightsDescription; }
            set { flightsDescription = value; }
        }

        /// <summary>
        /// 返程航班描述代码
        /// </summary>
        public string ReturnDescription { get; set; }

        string flightsDescription;


        int clientNum;
        /// <summary>
        /// 客户人数
        /// </summary>
        public int ClientNum
        {
            get { return clientNum; }
            set { clientNum = value; }
        }

        string clientName;

        /// <summary>
        /// 客人名称
        /// </summary>
        public string ClientName
        {
            get { return clientName; }
            set { clientName = value; }
        }

        float prePrice;
        /// <summary>
        /// 出票前报价
        /// </summary>
        public float PrePrice
        {
            get { return prePrice; }
            set { prePrice = value; }
        }

        float preCurrency;
        /// <summary>
        /// 出票前报价币种
        /// </summary>
        public float PreCurrency
        {
            get { return preCurrency; }
            set { preCurrency = value; }
        }

        float price;

        /// <summary>
        /// 机票全价
        /// </summary>
        public float Price
        {
            get { return price; }
            set { price = value; }
        }

        int currency;

        /// <summary>
        /// 币种
        /// </summary>
        public int Currency
        {
            get { return currency; }
            set { currency = value; }
        }




        string priceDescription;

        /// <summary>
        /// 报价说明
        /// </summary>
        public string PriceDescription
        {
            get { return priceDescription; }
            set { priceDescription = value; }
        }
        /// <summary>
        /// 机票编号
        /// </summary>
        public string TicketNumber { get; set; }
        /// <summary>
        /// 机票票号
        /// </summary>
        public string TicketCode { get; set; }
        string remark;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return remark; }
            set { remark = value; }
        }

        int operators;

        /// <summary>
        /// 操作人
        /// </summary>
        public int Operators
        {
            get { return operators; }
            set { operators = value; }
        }

        string operatorsDate;

        /// <summary>
        /// 操作时间
        /// </summary>
        public string OperatorsDate
        {
            get { return operatorsDate; }
            set { operatorsDate = value; }
        }

        int isDel;

        /// <summary>
        /// 删除标识
        /// </summary>
        public int IsDel
        {
            get { return isDel; }
            set { isDel = value; }
        }
        /// <summary>
        /// 舱类型
        /// </summary>
        int cType;

        public int CType
        {
            get { return cType; }
            set { cType = value; }
        }
        /// <summary>
        /// 乘客类型
        /// </summary>
        public string PassengerType { get; set; }
    }
}
