﻿using OASystem.Domain.Entities.Financial;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Financial
{
    /// <summary>
    /// 收款退还与其他款项
    /// </summary>
    public class Fin_PaymentRefundAndOtherMoneyView: Fin_PaymentRefundAndOtherMoney
    {
    }

    /// <summary>
    /// 收款退还与其他款项
    /// ItemView
    /// </summary>
    public class Fin_PaymentRefundAndOtherMoneyItemView 
    {
        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 费用名称
        /// </summary>
        public string? PriceName { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 币种Name
        /// </summary>
        public string? CurrencyCode { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }

        /// <summary>
        /// 总经理是否审核 
        /// 0 未审核 1已通过 2 未通过
        /// 1 已通过 不可 删除 And 修改
        /// </summary>
        public int IsAuditGM { get; set; }

        /// <summary>
        /// 审核人
        /// </summary>
        public string? AuditGMName { get; set; }

        /// <summary>
        /// 审核时间
        /// </summary>
        public string? AuditGMDate { get; set; }

        /// <summary>
        /// 创建人
        /// </summary>
        public string? CreateUserName { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreateTime { get; set; }
    }

    /// <summary>
    /// 收款退还与其他款项
    /// InfoView
    /// </summary>
    public class Fin_PaymentRefundAndOtherMoneyInfoView
    {
        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// C表Id
        /// </summary>
        public int CcpId { get; set; }

        /// <summary>
        /// 团组Id
        /// </summary>
        public int DiId { get; set; }

        /// <summary>
        /// 费用名称
        /// </summary>
        public string? PriceName { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 币种Id
        /// </summary>
        public int CurrencyId { get; set; }

        /// <summary>
        /// 收款方
        /// </summary>
        public string? Payee { get; set; }

        /// <summary>
        /// 支付方式Id
        /// </summary>
        public int PayDId { get; set; }

        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }

        /// <summary>
        /// 消费方式
        /// </summary>
        public string? ConsumptionPatterns { get; set; }

        /// <summary>
        /// 费用类型
        /// 0 其他 1 退多付款
        /// </summary>
        public int PayType { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }

    }
}
