﻿using OASystem.Domain.Entities.Financial;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Financial
{
    /// <summary>
    /// 团组已收款项 View
    /// </summary>
    public class Fin_ProceedsReceivedView:Fin_ProceedsReceived
    {
    }

    /// <summary>
    /// 团组已收款项Info View
    /// </summary>
    public class ProceedsReceivedView
    {
        public int Id { get; set; }

        ///// <summary>
        ///// 团组Id
        ///// </summary>
        //public int Diid { get; set; }

        /// <summary>
        /// 到款时间
        /// </summary>
        public string? SectionTime { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public int Currency { get; set; }

        /// <summary>
        /// 收款类型
        /// </summary>
        public int ReceivablesType { get; set; }

        /// <summary>
        /// 收款单位
        /// </summary>
        public string? Client { get; set; }

        /// <summary>
        /// 收款单位 负责人 姓名
        /// </summary>
        public string? CustomerName { get; set; }

        /// <summary>
        /// 收款单位 负责人 姓名
        /// </summary>
        public string? CustomerTel { get; set; }

        /// <summary>
        /// 应付项id
        /// </summary>
        public int FID { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }
    }


    /// <summary>
    /// 团组已收款项-1Info View
    /// </summary>
    public class ProceedsReceived1View
    {
        public int Id { get; set; }

        /// <summary>
        /// 团组Id
        /// </summary>
        public int Diid { get; set; }

        /// <summary>
        /// 到款时间
        /// </summary>
        public string? SectionTime { get; set; }

        /// <summary>
        /// 费用
        /// </summary>
        public decimal Price { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public int Currency { get; set; }

        /// <summary>
        /// 收款类型
        /// </summary>
        public int ReceivablesType { get; set; }

        /// <summary>
        /// 收款单位
        /// </summary>
        public string? Client { get; set; }

        /// <summary>
        /// 收款单位 负责人 姓名
        /// </summary>
        public string? CustomerName { get; set; }

        /// <summary>
        /// 收款单位 负责人 姓名
        /// </summary>
        public string? CustomerTel { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string? Remark { get; set; }
    }
}
