﻿using OASystem.Domain.Entities.Financial;
using OASystem.Domain.Entities.Groups;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Financial
{
    /// <summary>
    /// 团组汇率 View 
    /// </summary>
    public class TeamRateView : Grp_TeamRate
    {
    }

    /// <summary>
    /// 团组汇率info
    /// </summary>
    public class TeamRateInfoView : Grp_TeamRate
    {
        /// <summary>
        /// 权限模块名称
        /// </summary>
        public string? Name { get; set; }
    }

    #region 团组汇率 信息
    public class TeamRateModelView
    {
        /// <summary>
        /// 汇率Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 汇率模块 Id
        /// </summary>
        public int CTableId { get; set; }

        /// <summary>
        /// 汇率模块
        /// </summary>
        public string? CTableName { get; set; }

        /// <summary>
        /// 汇率 List
        /// </summary>
        public List<TeamRateDescView>? TeamRates { get; set; }
    }

    public class TeamRateDescView
    {
        /// <summary>
        /// 币种名称
        /// </summary>
        public string? CurrencyName { get; set; }

        /// <summary>
        /// 币种Code
        /// </summary>
        public string? CurrencyCode { get; set; }

        /// <summary>
        /// 汇率 
        /// 保存四位小数
        /// </summary>
        public decimal Rate { get; set; }

    }

    public class CurrencyHot
    {
        /// <summary>
        /// 币种Id
        /// </summary>
        public int CurrencyId { get; set; }

        /// <summary>
        /// 币种名称
        /// </summary>
        public string? CurrencyName { get; set; }

        /// <summary>
        /// 币种Code
        /// </summary>
        public string? CurrencyCode { get; set; }

        public decimal Rate { get; set; } = 0.0000M;

        /// <summary>
        /// 使用次数
        /// </summary>
        public int Number { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class TeamRateDescAddCurrencyIdView: TeamRateDescView
    {
        /// <summary>
        /// 币种Id
        /// </summary>
        public int CurrencyId { get; set; }

    }

    public class TeamRateModelGeneralView
    {
        /// <summary>
        /// 汇率Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 汇率模块 Id
        /// </summary>
        public int CTableId { get; set; }

        /// <summary>
        /// 汇率模块
        /// </summary>
        public string? CTableName { get; set; }

        /// <summary>
        /// 汇率 List
        /// </summary>
        public List<TeamRateDescAddCurrencyIdView>? TeamRates { get; set; }
    }

    #endregion

}
