﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Groups
{
    /// <summary>
    /// 根据团组Id查询保险费用列表
    /// </summary>
    public class CustomersView
    {
        public int RowNumber { get; set; }
        /// <summary>
        /// 主键Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 客人姓名
        /// </summary>
        public string ClientName { get; set; }
        /// <summary>
        /// 保险费用
        /// </summary>
        public decimal InsuranceCosts { get; set; }
        /// <summary>
        /// 保险费用币种
        /// </summary>
        public int Currency { get; set; }
        /// <summary>
        /// 保险费用币种Str
        /// </summary>
        public string CurrencyStr { get; set; }
        /// <summary>
        /// 附件地址
        /// </summary>
        public string Attachment { get; set; }
        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }
        /// <summary>
        /// 费用表示Str
        /// </summary>
        public string OrbitalPrivateTransferStr { get; set; }
        /// <summary>
        /// 创建人姓名
        /// </summary>
        public string CnName { get; set; }
        /// <summary>
        /// 是否审核
        /// </summary>
        public int IsAuditGM { get; set; }
        /// <summary>
        /// 是否审核Str
        /// </summary>
        public string IsAuditGMStr { get; set; }
    }

    public class CustomersByIdView
    {
        /// <summary>
        /// 主键Id
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DiId { get; set; }
        /// <summary>
        /// 保险名称
        /// </summary>
        public int Iid { get; set; }
        /// <summary>
        /// 保险名称Str
        /// </summary>
        public string IidStr { get; set; }

        /// <summary>
        /// 客户名称
        /// </summary>
        public string ClientName { get; set; }

        /// <summary>
        /// 保险费用
        /// </summary>
        public decimal InsuranceCosts { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public int Currency { get; set; }
        /// <summary>
        /// 币种Str
        /// </summary>
        public string CurrencyStr { get; set; }
        /// <summary>
        /// 保险附件
        /// </summary>
        public string Attachment { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        /// 余额
        /// </summary>
        public decimal InsuranceBalance { get; set; }

    }
    public class CreditCardView
    {
        /// <summary>
        /// 支付方式
        /// </summary>
        public int PayDId { get; set; }
        /// <summary>
        /// 支付方式Str
        /// </summary>
        public string PayDIdStr { get; set; }
        /// <summary>
        /// 付款金额
        /// </summary>
        public decimal PayMoney { get; set; }
        /// <summary>
        /// 付款币种 数据类型Id
        /// </summary>
        public int PaymentCurrency { get; set; }
        /// <summary>
        /// 付款币种 数据类型Str
        /// </summary>
        public string PaymentCurrencyStr { get; set; }
        /// <summary>
        /// 消费方式
        /// </summary>
        public string ConsumptionPatterns { get; set; }
        /// <summary>
        /// 消费日期
        /// </summary>
        public string ConsumptionDate { get; set; }
        /// <summary>
        /// 卡类型
        /// </summary>
        public int CTDId { get; set; }
        /// <summary>
        /// 卡类型Str
        /// </summary>
        public string CTDIdStr { get; set; }

        /// <summary>
        /// 公司银行卡号
        /// </summary>
        public string CompanyBankNo { get; set; }
        /// <summary>
        /// 对方开户行
        /// </summary>
        public string OtherBankName { get; set; }
        /// <summary>
        /// 对方银行账号
        /// </summary>
        public string OtherSideNo { get; set; }
        /// <summary>
        /// 对方姓名
        /// </summary>
        public string OtherSideName { get; set; }
        /// <summary>
        /// 银行卡号
        /// </summary>
        public string BankNo { get; set; }
        /// <summary>
        /// 持卡人姓名
        /// </summary>
        public string CardholderName { get; set; }
        /// <summary>
        /// 收款方
        /// </summary>
        public string Payee { get; set; }
        /// <summary>
        /// 费用标识
        /// </summary>
        public int OrbitalPrivateTransfer { get; set; }
        /// <summary>
        /// 费用标识
        /// </summary>
        public string OrbitalPrivateTransferStr { get; set; }
        /// <summary>
        /// 总经理是否审核  0 未审核 1已通过 2未通过
        /// </summary>
        public int IsAuditGM { get; set; }
        /// <summary>
        /// C表备注
        /// </summary>
        public string Remark { get; set; }
    }

    public class InsuranceCostView
    {
        public int Id { get; set; }
        /// <summary>
        /// 保险名称
        /// </summary>
        public string GName { get; set; }

        /// <summary>
        /// 余额
        /// </summary>
        public decimal Balance { get; set; }
    }
}
