﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Groups
{
    /// <summary>
    /// OA2021团组信息类
    /// </summary>
    public class OA2021_DelegationInfo
    {
        int id;

        /// <summary>
        /// 主键编号
        /// </summary>
        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        string salesQuoteNo;

        /// <summary>
        /// 销售报价号
        /// </summary>
        public string SalesQuoteNo
        {
            get { return salesQuoteNo; }
            set { salesQuoteNo = value; }
        }

        string salesDate;

        /// <summary>
        /// 销售日期
        /// </summary>
        public string SalesDate
        {
            get { return salesDate; }
            set { salesDate = value; }
        }

        string clientName;

        /// <summary>
        /// 客户名称
        /// </summary>
        public string ClientName
        {
            get { return clientName; }
            set { clientName = value; }
        }

        string clientUnit;

        /// <summary>
        /// 客户单位
        /// </summary>
        public string ClientUnit
        {
            get { return clientUnit; }
            set { clientUnit = value; }
        }

        string tourCode;

        /// <summary>
        /// 团组号
        /// </summary>
        public string TourCode
        {
            get { return tourCode; }
            set { tourCode = value; }
        }

        string teamName;

        /// <summary>
        /// 团组名称
        /// </summary>
        public string TeamName
        {
            get { return teamName; }
            set { teamName = value; }
        }

        int teamDid;

        /// <summary>
        /// 团组类型（设置数据外键编号）
        /// </summary>
        public int TeamDid
        {
            get { return teamDid; }
            set { teamDid = value; }
        }

        string visitDate;

        /// <summary>
        /// 出访时间
        /// </summary>
        public string VisitDate
        {
            get { return visitDate; }
            set { visitDate = value; }
        }

        string visitStartDate;

        /// <summary>
        /// 出团时间起
        /// </summary>
        public string VisitStartDate
        {
            get { return visitStartDate; }
            set { visitStartDate = value; }
        }

        string visitEndDate;

        /// <summary>
        /// 出团时间止
        /// </summary>
        public string VisitEndDate
        {
            get { return visitEndDate; }
            set { visitEndDate = value; }
        }

        string visitCountry;

        /// <summary>
        /// 出访国家
        /// </summary>
        public string VisitCountry
        {
            get { return visitCountry; }
            set { visitCountry = value; }
        }

        string visitPurpose;

        /// <summary>
        /// 出访目的
        /// </summary>
        public string VisitPurpose
        {
            get { return visitPurpose; }
            set { visitPurpose = value; }
        }

        int visitDays;

        /// <summary>
        /// 出访天数
        /// </summary>
        public int VisitDays
        {
            get { return visitDays; }
            set { visitDays = value; }
        }

        int visitPNumber;

        /// <summary>
        /// 出访人数
        /// </summary>
        public int VisitPNumber
        {
            get { return visitPNumber; }
            set { visitPNumber = value; }
        }

        string speciaNeeds;

        /// <summary>
        /// 特殊需求
        /// </summary>
        public string SpecialNeeds
        {
            get { return speciaNeeds; }
            set { speciaNeeds = value; }
        }

        string otherNeeds;

        /// <summary>
        /// 其他需求
        /// </summary>
        public string OtherNeeds
        {
            get { return otherNeeds; }
            set { otherNeeds = value; }
        }

        string clientNeeds;

        /// <summary>
        /// 客户需求
        /// </summary>
        public string ClientNeeds
        {
            get { return clientNeeds; }
            set { clientNeeds = value; }
        }

        string remark;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return remark; }
            set { remark = value; }
        }

        int isState;

        /// <summary>
        /// 状态标识
        /// </summary>
        public int IsState
        {
            get { return isState; }
            set { isState = value; }
        }

        int jietuanOperator;

        /// <summary>
        /// 接团操作人
        /// </summary>
        public int JietuanOperator
        {
            get { return jietuanOperator; }
            set { jietuanOperator = value; }
        }

        string jietuanTime;

        /// <summary>
        /// 接团操作时间
        /// </summary>
        public string JietuanTime
        {
            get { return jietuanTime; }
            set { jietuanTime = value; }
        }

        int groupsOperator;

        /// <summary>
        /// 团信息操作人
        /// </summary>
        public int GroupsOperator
        {
            get { return groupsOperator; }
            set { groupsOperator = value; }
        }

        string groupsTime;

        /// <summary>
        /// 团信息操作时间
        /// </summary>
        public string GroupsTime
        {
            get { return groupsTime; }
            set { groupsTime = value; }
        }

        int isDel;

        /// <summary>
        /// 删除标识
        /// </summary>
        public int IsDel
        {
            get { return isDel; }
            set { isDel = value; }
        }

        string budgetCost;

        /// <summary>
        /// 预算成本
        /// </summary>
        public string BudgetCost
        {
            get { return budgetCost; }
            set { budgetCost = value; }
        }
        int isSure;

        /// <summary>
        /// 是否操作完成
        /// </summary>
        public int IsSure
        {
            get { return isSure; }
            set { isSure = value; }
        }
        DateTime sureTime;

        /// <summary>
        /// 预算成本
        /// </summary>
        public DateTime SureTime
        {
            get { return sureTime; }
            set { sureTime = value; }
        }

        string tellPhone;

        /// <summary>
        /// 手机号
        /// </summary>
        public string TellPhone
        {
            get { return tellPhone; }
            set { tellPhone = value; }
        }


        string teamLev;
        /// <summary>
        /// 团组客户级别
        /// </summary>
        public string TeamLev
        {
            get { return teamLev; }
            set { teamLev = value; }
        }
        /// <summary>
        /// 酒店投诉标识：0-未投诉；1-已投诉
        /// </summary>
        public int HotelComplain { get; set; }
        /// <summary>
        /// OP投诉标识：0-未投诉；1-已投诉
        /// </summary>
        public int OPComplain { get; set; }
        /// <summary>
        /// 签证投诉标识：0-未投诉；1-已投诉
        /// </summary>
        public int VisaComplain { get; set; }
        /// <summary>
        /// 商邀投诉标识：0-未投诉；1-已投诉
        /// </summary>
        public int OAComplain { get; set; }
        /// <summary>
        /// 机票投诉标识：0-未投诉；1-已投诉
        /// </summary>
        public int AirComplain { get; set; }
        /// <summary>
        /// 团组负责人标识（会展会务、策划、销售算提成需要查看团组负责人）
        /// </summary>
        public int Director { get; set; }

        /// <summary>
        /// 合同时间
        /// </summary>
        public string TontractTime { get; set; }

        /// <summary>
        /// 支付款项（预付）
        /// </summary>
        public string PaymentMoney { get; set; }

        /// <summary>
        /// 预付期限
        /// </summary>
        public string PayDay { get; set; }

        #region 新增字段  出国任务审批部门名称、批件文号等 
        public string CGRWSPBMMC { get; set; }
        public string CGRWSPWH { get; set; }
        public string ZZSCBMMC { get; set; }
        public string ZZSCSPWH { get; set; }

        #endregion

    }


    /// <summary>
    /// OA2021团组客户信息类
    /// </summary>
    public class OA2021_DeleClient1
    {
        /// <summary>
        ///  标识
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        ///  团号
        /// </summary>
        public int Diid { get; set; }

        /// <summary>
        ///  名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        ///  姓
        /// </summary>
        public string LastName { get; set; }
        /// <summary>
        ///  拼音姓名
        /// </summary>
        public string Pinyin { get; set; }
        /// <summary>
        ///  单位
        /// </summary>
        public string Company { get; set; }
        /// <summary>
        /// 组团单位
        /// </summary>
        public string GroupUnit { get; set; }
        /// <summary>
        ///  职务
        /// </summary>
        public string Job { get; set; }

        /// <summary>
        ///  手机电话
        /// </summary>
        public string Phone { get; set; }

        /// <summary>
        ///  性别
        /// </summary>
        public string Sex { get; set; }
        /// <summary>
        ///  身份证
        /// </summary>
        public string IDcard { get; set; }
        /// <summary>
        ///  护照类型
        /// </summary>
        public string PassprotType { get; set; }

        /// <summary>
        /// 签发国家码
        /// </summary>
        public string passportCountry { get; set; }
        /// <summary>
        ///  护照编号
        /// </summary>
        public string PassportNo { get; set; }
        /// <summary>
        ///  护照签发地
        /// </summary>
        public string IssuePlace { get; set; }
        /// <summary>
        ///  护照签发日期
        /// </summary>
        public string IssueDate { get; set; }

        /// <summary>
        ///  护照有效期
        /// </summary>
        public string ExpiryDate { get; set; }
        /// <summary>
        ///  生日
        /// </summary>
        public string Birthday { get; set; }

        /// <summary>
        ///  舱位类型
        /// </summary>
        public string AirType { get; set; }
        /// <summary>
        ///  舱位备注
        /// </summary>
        public string AirRemark { get; set; }
        /// <summary>
        ///  房型
        /// </summary>
        public string RoomType { get; set; }

        /// <summary>
        ///  备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        ///  记录人
        /// </summary>
        public int OPer { get; set; }

        /// <summary>
        ///  记录时间
        /// </summary>
        public string OPdate { get; set; }

        /// <summary>
        ///  删除标识
        /// </summary>
        public int Isdel { get; set; }

    }
}
