﻿using OASystem.Domain.Entities.Groups;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.Groups
{
    /// <summary>
    /// 团组签证费用info
    /// </summary>
    public class VisaFeeInfoView: Grp_VisaFeeInfo
    {
    }

    public class VisaFeeInfosView
    {
        public int Id { get; set; }

        /// <summary>
        /// 是否选中
        /// </summary>
        public int IsChecked { get; set; }

        /// <summary>
        /// 国家
        /// </summary>
        public string Country { get; set; }

        /// <summary>
        /// 签证费用
        /// </summary>
        public decimal VisaFee { get; set; }

        /// <summary>
        /// 代办费 - 公务 类型 1 大公务 2 小公务
        /// 新增
        /// 雷怡 2024-08-07 17:08:13
        /// </summary>
        public int OBType { get; set; } = 1;

        /// <summary>
        /// 代办费公务描述
        /// 雷怡 2024-08-07 17:08:23
        /// </summary>
        public string OBTypeStr
        {
            get
            {
                string str = "Unknown";
                if (OBType == 1) str = "大公务";
                else if (OBType == 2) str = "小公务";
                return str;
            }
        }

        /// <summary>
        /// 代办费
        /// 新增
        /// 雷怡 2024-05-07 15:45:09
        /// </summary>
        public decimal AgencyFee { get; set; }

        /// <summary>
        /// 其他费用
        /// </summary>
        public decimal OtherFee { get; set; }
    }
}
