﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels
{
    public class OA2014DB
    {
    }

    public class OA2014_Visa
    {
        int id;

        /// <summary>
        /// 主键编号
        /// </summary>
        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        int dIId;

        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DIId
        {
            get { return dIId; }
            set { dIId = value; }
        }

        string visaClient;

        /// <summary>
        /// 签证客户
        /// </summary>
        public string VisaClient
        {
            get { return visaClient; }
            set { visaClient = value; }
        }

        float visaPrice;

        /// <summary>
        /// 签证费用
        /// </summary>
        public float VisaPrice
        {
            get { return visaPrice; }
            set { visaPrice = value; }
        }

        int visaCurrency;

        /// <summary>
        /// 币种
        /// </summary>
        public int VisaCurrency
        {
            get { return visaCurrency; }
            set { visaCurrency = value; }
        }

        /// <summary>
        /// 是否第三方支付
        /// </summary>
        public int IsThird { get; set; }

        string visaAttachment;

        /// <summary>
        /// 签证附件
        /// </summary>
        public string VisaAttachment
        {
            get { return visaAttachment; }
            set { visaAttachment = value; }
        }

        string remark;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return remark; }
            set { remark = value; }
        }

        public int Operator { get; set; }

        string operatorsDate;

        /// <summary>
        /// 操作时间
        /// </summary>
        public string OperatorsDate
        {
            get { return operatorsDate; }
            set { operatorsDate = value; }
        }

        int isDel;

        /// <summary>
        /// 删除标识
        /// </summary>
        public int IsDel
        {
            get { return isDel; }
            set { isDel = value; }
        }

        public string IsAuditGM { get; set; }
        /// <summary>
        /// 签字人员类型
        /// </summary>
        public string PassengerType { get; set; }
        /// <summary>
        /// 办理签证人数
        /// </summary>
        public int VisaNumber { get; set; }
        /// <summary>
        /// 免签人数
        /// </summary>
        public int VisaFreeNumber { get; set; }
    }

    public class OA2014_CreditCardPayment
    {
        int id;

        /// <summary>
        /// 主键编号
        /// </summary>
        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        int payDId;

        /// <summary>
        /// 支付方式（设置数据外键编号）
        /// </summary>
        public int PayDId
        {
            get { return payDId; }
            set { payDId = value; }
        }

        string consumptionPatterns;

        /// <summary>
        /// 消费方式
        /// </summary>
        public string ConsumptionPatterns
        {
            get { return consumptionPatterns; }
            set { consumptionPatterns = value; }
        }

        string consumptionDate;

        /// <summary>
        /// 消费日期
        /// </summary>
        public string ConsumptionDate
        {
            get { return consumptionDate; }
            set { consumptionDate = value; }
        }

        int cTDId;

        /// <summary>
        /// 卡类型
        /// </summary>
        public int CTDId
        {
            get { return cTDId; }
            set { cTDId = value; }
        }

        string bankNo;

        /// <summary>
        /// 银行卡号
        /// </summary>
        public string BankNo
        {
            get { return bankNo; }
            set { bankNo = value; }
        }

        string cardholderName;

        /// <summary>
        /// 持卡人姓名
        /// </summary>
        public string CardholderName
        {
            get { return cardholderName; }
            set { cardholderName = value; }
        }

        float payMoney;

        /// <summary>
        /// 付款金额
        /// </summary>
        public float PayMoney
        {
            get { return payMoney; }
            set { payMoney = value; }
        }

        int paymentCurrency;

        /// <summary>
        /// 付款币种
        /// </summary>
        public int PaymentCurrency
        {
            get { return paymentCurrency; }
            set { paymentCurrency = value; }
        }

        string dayRate;

        /// <summary>
        /// 当天汇率
        /// </summary>
        public string DayRate
        {
            get { return dayRate; }
            set { dayRate = value; }
        }

        string companyBankNo;

        /// <summary>
        /// 公司银行卡号
        /// </summary>
        public string CompanyBankNo
        {
            get { return companyBankNo; }
            set { companyBankNo = value; }
        }

        string otherBankName;

        /// <summary>
        /// 对方开户行
        /// </summary>
        public string OtherBankName
        {
            get { return otherBankName; }
            set { otherBankName = value; }
        }

        string otherSideNo;

        /// <summary>
        /// 对方银行账号
        /// </summary>
        public string OtherSideNo
        {
            get { return otherSideNo; }
            set { otherSideNo = value; }
        }

        string otherSideName;

        /// <summary>
        /// 对方姓名
        /// </summary>
        public string OtherSideName
        {
            get { return otherSideName; }
            set { otherSideName = value; }
        }

        string remark;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return remark; }
            set { remark = value; }
        }

        int operators;

        /// <summary>
        /// 操作人
        /// </summary>
        public int Operators
        {
            get { return operators; }
            set { operators = value; }
        }

        string operatorsDate;

        /// <summary>
        /// 操作时间
        /// </summary>
        public string OperatorsDate
        {
            get { return operatorsDate; }
            set { operatorsDate = value; }
        }

        int mFOperators;

        /// <summary>
        /// 财务操作人
        /// </summary>
        public int MFOperators
        {
            get { return mFOperators; }
            set { mFOperators = value; }
        }

        string mFOperatorsDate;

        /// <summary>
        /// 财务操作时间
        /// </summary>
        public string MFOperatorsDate
        {
            get { return mFOperatorsDate; }
            set { mFOperatorsDate = value; }
        }

        int isAuditDM;

        /// <summary>
        /// 部门经理是否审核
        /// </summary>
        public int IsAuditDM
        {
            get { return isAuditDM; }
            set { isAuditDM = value; }
        }

        int auditDMOperate;

        /// <summary>
        /// 部门经理审核人
        /// </summary>
        public int AuditDMOperate
        {
            get { return auditDMOperate; }
            set { auditDMOperate = value; }
        }

        string auditDMDate;

        /// <summary>
        /// 部门经理审核时间
        /// </summary>
        public string AuditDMDate
        {
            get { return auditDMDate; }
            set { auditDMDate = value; }
        }

        int isAuditMF;

        /// <summary>
        /// 财务部是否审核
        /// </summary>
        public int IsAuditMF
        {
            get { return isAuditMF; }
            set { isAuditMF = value; }
        }

        int auditMFOperate;

        /// <summary>
        /// 财务部审核人
        /// </summary>
        public int AuditMFOperate
        {
            get { return auditMFOperate; }
            set { auditMFOperate = value; }
        }

        string auditMFDate;

        /// <summary>
        /// 财务部审核时间
        /// </summary>
        public string AuditMFDate
        {
            get { return auditMFDate; }
            set { auditMFDate = value; }
        }

        int isAuditGM;

        /// <summary>
        /// 总经理是否审核
        /// </summary>
        public int IsAuditGM
        {
            get { return isAuditGM; }
            set { isAuditGM = value; }
        }

        int auditGMOperate;

        /// <summary>
        /// 总经理审核人
        /// </summary>
        public int AuditGMOperate
        {
            get { return auditGMOperate; }
            set { auditGMOperate = value; }
        }

        string auditGMDate;

        /// <summary>
        /// 总经理审核时间
        /// </summary>
        public string AuditGMDate
        {
            get { return auditGMDate; }
            set { auditGMDate = value; }
        }

        int isPay;

        /// <summary>
        /// 是否付款
        /// </summary>
        public int IsPay
        {
            get { return isPay; }
            set { isPay = value; }
        }

        int dIId;

        /// <summary>
        /// 团组外键编号
        /// </summary>
        public int DIId
        {
            get { return dIId; }
            set { dIId = value; }
        }

        int cId;

        /// <summary>
        /// 指向表外键编号
        /// </summary>
        public int CId
        {
            get { return cId; }
            set { cId = value; }
        }

        int cTable;

        /// <summary>
        /// 指向标识（设置数据外键编号）
        /// </summary>
        public int CTable
        {
            get { return cTable; }
            set { cTable = value; }
        }

        int isDel;

        /// <summary>
        /// 删除标识
        /// </summary>
        public int IsDel
        {
            get { return isDel; }
            set { isDel = value; }
        }

        string payPercentage;

        /// <summary>
        /// 此次付款百分比
        /// </summary>
        public string PayPercentage
        {
            get { return payPercentage; }
            set { payPercentage = value; }
        }

        string payThenMoney;

        /// <summary>
        /// 此次付款金额
        /// </summary>
        public string PayThenMoney
        {
            get { return payThenMoney; }
            set { payThenMoney = value; }
        }

        string payPercentageOld;
        /// <summary>
        /// 上次付款百分比
        /// </summary>
        public string PayPercentageOld
        {
            get { return payPercentageOld; }
            set { payPercentageOld = value; }
        }
        string payThenMoneyOld;
        /// <summary>
        /// 上次付款金额
        /// </summary>
        public string PayThenMoneyOld
        {
            get { return payThenMoneyOld; }
            set { payThenMoneyOld = value; }
        }
        string updateDate;

        /// <summary>
        /// 上次付款时间
        /// </summary>
        public string UpdateDate
        {
            get { return updateDate; }
            set { updateDate = value; }
        }

        string payee;
        /// <summary>
        /// 收款方
        /// </summary>
        public string Payee
        {
            get { return payee; }
            set { payee = value; }
        }

        float rMBPrice;

        /// <summary>
        /// 人民币费用
        /// </summary>
        public float RMBPrice
        {
            get { return rMBPrice; }
            set { rMBPrice = value; }
        }



        string orbitalPrivateTransfer;
        /// <summary>
        /// 费用标识
        /// </summary>
        public string OrbitalPrivateTransfer
        {
            get { return orbitalPrivateTransfer; }
            set { orbitalPrivateTransfer = value; }
        }

        /// <summary>
        /// 超出预算比例
        /// </summary>
        public float ExceedBudget { get; set; }

        /// <summary>
        /// 是否匹配上了信用卡账单
        /// </summary>
        public int IsMatchCreditCard { get; set; }

    }
}
