﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.QiYeWeChat
{
    /// <summary>
    /// 部门详情
    /// </summary>
    public class DepartmentView
    {
        /// <summary>
        /// 部门Id
        /// </summary>
        public long id { get; set; }

        /// <summary>
        /// 部门名称
        /// </summary>
        public string? name { get; set; }

        /// <summary>
        /// 部门负责人的UserID；第三方仅通讯录应用可获取
        /// </summary>
        public List<string>? department_leader { get; set; }

        /// <summary>
        /// 父部门id。根部门为1
        /// </summary>
        public int parentid { get; set; }

        /// <summary>
        /// 在父部门中的次序值。order值大的排序靠前。值范围是[0, 2^32)
        /// </summary>
        public long order { get; set; }
    }

    /// <summary>
    /// 部门列表
    /// </summary>
    public class DepartmentListView : ResponseBase
    {
        /// <summary>
        /// 部门列表数据
        /// </summary>
        public List<DepartmentView>? department { get; set; }
    }
}
