﻿using OASystem.Domain.Entities.System;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.System
{
    public class SetDataView
    {
        public int Id { get; set; }
        /// <summary>
        /// 分类名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// setdatatype id
        /// </summary>
        public int STid { get; set; }

        public string Remark { get; set; }
    }

    /// <summary>
    /// 数据data
    /// </summary>
    public class SetDataInfoView
    {
        public int Id { get; set; }
        /// <summary>
        /// 分类名称
        /// </summary>
        public string Name { get; set; }

        public string Remark { get; set; }
    }

    /// <summary>
    /// 卡类型数据data
    /// </summary>
    public class SetDataCurrencyInfoView
    {
        public int Id { get; set; }
        /// <summary>
        /// 分类名称
        /// </summary>
        public string? Name { get; set; }

        /// <summary>
        /// 卡类型对应的币种
        /// </summary>
        public string? Currency { get {
                string? currency = string.Empty;
                if (Id == 74) currency = "USD"; //74	美元卡
                else if (Id == 75) currency = "EUR"; //775	欧元卡
                else if(Id == 86) currency = "CNY";  //86	招行卡
                else if (Id == 346) currency = "CNY";  //346	中信卡
                else if (Id == 363) currency = "CNY";  //363	交行卡
                return currency;
            } }

        /// <summary>
        /// 持卡人
        /// </summary>
        public string? Cardholder { get; set; } = "Zhang Hailin";

        /// <summary>
        /// 卡号
        /// </summary>
        public string? Remark { get; set; }
    }

    public class SetDataAndPageInfoView
    {
        /// <summary>
        /// 模块id
        /// </summary>
        public int Modulid { get; set; }
        /// <summary>
        /// 分类名称
        /// </summary>
        public string ModulName { get; set; }
        /// <summary>
        /// setdatatype id
        /// </summary>
        public int STid { get; set; }
        /// <summary>
        /// 模块备注
        /// </summary>
        public string ModulRemark { get; set; }

        /// <summary>
        /// 页面id
        /// </summary>
        public int Pageid { get; set; }
        
        /// <summary>
        /// 页面名称
        /// </summary>
        public string PageName { get; set; }

        /// <summary>
        /// 页面是否启用
        /// </summary>
        public int PageIsEnable { get; set; }

       
        public int PagePhoneIsEnable { get; set; }

        /// <summary>
        /// 页面Code
        /// </summary>
        public string SystemMenuCode { get; set; }

        public string WebUrl { get; set; }

        public string AndroidUrl { get; set; }

        public string IosUrl { get; set; }

        /// <summary>
        /// 手机端图标
        /// </summary>
        public string Icon { get; set; }

        /// <summary>
        /// 页面备注
        /// </summary>
        public string PageRemark { get; set; }

        /// <summary>
        /// 页面添加的操作
        /// </summary>
        public List<int> FunArr { get; set; }
    }


    public class SetDataAndPageInfoDto
    {
        /// <summary>
        /// 模块id
        /// </summary>
        public int Modulid { get; set; }
        /// <summary>
        /// 分类名称
        /// </summary>
        public string ModulName { get; set; }
        /// <summary>
        /// setdatatype id
        /// </summary>
        public int STid { get; set; }
        /// <summary>
        /// 模块备注
        /// </summary>
        public string ModulRemark { get; set; }

        /// <summary>
        /// 页面id
        /// </summary>
        public int Pageid { get; set; }

        /// <summary>
        /// 页面名称
        /// </summary>
        public string PageName { get; set; }

        /// <summary>
        /// 页面是否启用
        /// </summary>
        public int PageIsEnable { get; set; }


        public int PagePhoneIsEnable { get; set; }

        /// <summary>
        /// 页面Code
        /// </summary>
        public string SystemMenuCode { get; set; }

        public string WebUrl { get; set; }

        public string AndroidUrl { get; set; }

        public string IosUrl { get; set; }

        /// <summary>
        /// 手机端图标
        /// </summary>
        public string Icon { get; set; }

        /// <summary>
        /// 页面备注
        /// </summary>
        public string PageRemark { get; set; }

        /// <summary>
        /// 页面添加的操作
        /// </summary>
        public List<int> FunArr { get; set; }

        /// <summary>
        /// 用户ID
        /// </summary>
        public int UserId { get; set; }
    }

    public class SetDataIView:Sys_SetData
    {
        public string StName { get; set; }
        public string CnName { get;set; }
    }
}
