﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.ViewModels.System
{
    public class UserAuthorityView
    {
        /// <summary>
        /// 数据id
        /// </summary>
        public int ID { get; set; }
        /// 用户Id
        /// </summary>
        public int UId { get; set; }
        /// <summary>
        /// 页面权限Id
        /// </summary>
        public int SmId { get; set; }
        /// <summary>
        /// 页面功能Id
        /// </summary>
        public int FId { get; set; }

        /// <summary>
        /// 是否由职位模板导入
        /// </summary>
        public int IsTemp { get; set; }

    }

    /// <summary>
    /// 用户页面功能
    /// View
    /// </summary>
    public class UserPageFuncView
    {
        /// <summary>
        /// 用户Id
        /// </summary>
        public int UserId { get; set; }

        /// <summary>
        /// 用户名称
        /// </summary>
        public string? UserName { get; set; }

        /// <summary>
        /// 模块Id
        /// </summary>
        public int ModuleId { get; set; }

        /// <summary>
        /// 模块名称
        /// </summary>
        public string? ModuleName { get; set; }

        /// <summary>
        /// 页面Id 
        /// </summary>
        public int PageId { get; set; }

        /// <summary>
        /// 页面名称
        /// </summary>
        public string? PageName { get; set; }

        /// <summary>
        /// 页面是否启用
        /// 0 未启用 1 已启用
        /// </summary>
        public int PageIsEnable { get; set; }

        /// <summary>
        /// 手机端页面也否启用
        ///  0 未启用 1 已启用
        /// </summary>
        public int PagePhoneIsEnable { get; set; }

        /// <summary>
        /// 功能Id
        /// </summary>
        public int FuncId { get; set; }

        /// <summary>
        /// 功能名称
        /// </summary>
        public string FuncName { get; set; }

        /// <summary>
        /// 功能是否启用
        /// 0 未启用 1 已启用
        /// </summary>
        public int FuncIsEnable { get; set; }
    }


}
