using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using OASystem.Domain.Dtos.CRM;
using OASystem.Domain.Dtos.QiYeWeChat;
using OASystem.Domain.Entities.Groups;
using OASystem.Domain.Entities.Resource;
using OASystem.Domain.Enums;
using OpenAI.GPT3.ObjectModels;
using SqlSugar;
using System.Data;
using System.Net;
using System.Text.RegularExpressions;
using static QRCoder.PayloadGenerator;
using System.Windows.Forms;
using Microsoft.Data.SqlClient;
using OASystem.Domain.Entities.Customer;
using Aspose.Words;
using Bookmark = Aspose.Words.Bookmark;
using OASystem.Domain.ViewModels.QiYeWeChat;
using NPOI.SS.UserModel;
using System.Collections;

namespace OpWin
{
    public partial class Home : Form
    {
        static List<Grp_DelegationInfo> soure = null;

        const string OA2023DB = "server=132.232.92.186;uid=sa;pwd=Yjx@158291;database=OA2023DB;MultipleActiveResultSets=True;";

        SqlSugarClient Db = new SqlSugarClient(new ConnectionConfig()
        {
            ConfigId = DBEnum.OA2023DB,
            ConnectionString = OA2023DB,
            DbType = SqlSugar.DbType.SqlServer,
            IsAutoCloseConnection = true
        });

        public Home()
        {
            InitializeComponent();
        }

        string[] weekdays = new string[] { "", "һ", "ڶ", "", "", "", "" };

        private void Home_Load(object sender, EventArgs e)
        {
            comb_Delegation.ValueMember = "Id";
            comb_Delegation.DisplayMember = "TeamName";
            soure = Db.Queryable<Grp_DelegationInfo>().Where(x=>x.IsDel == 0).ToList();
            comb_Delegation.Items.AddRange(soure.ToArray());
            comb_Delegation.DropDownHeight = 200;
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            lblOutputResult.Text = "ļڵ...";
            lblOutputResult.ForeColor = Color.Black;

            //Դ
            List<Grp_TravelList> _travelList = new List<Grp_TravelList>();
            int diid = 0;
            try
            {
                var dele = (comb_Delegation.SelectedItem as Grp_DelegationInfo);
                diid = dele.Id;
            }
            catch (Exception)
            {
                lblOutputResult.Text = "ѡȷ!";
                lblOutputResult.ForeColor = Color.Black;
                MessageBox.Show("ѡȷ!");
                return;
            }

            DataTable dtBlack = null;
            try
            {
                dtBlack = GetTableByBlackCode(diid);
            }
            catch (Exception)
            {
                lblOutputResult.Text = "Ʊ!";
                lblOutputResult.ForeColor = Color.Black;
                MessageBox.Show("Ʊ!");
                return;
            }

            Grp_DelegationInfo di = Db.Queryable<Grp_DelegationInfo>().First(x => x.Id == diid && x.IsDel == 0);

            if (di == null)
            {
                lblOutputResult.Text = "ѡȷ!";
                lblOutputResult.ForeColor = Color.Black;
                MessageBox.Show("ѡȷ!");
                return;
            }

            string CityStr1 = "";
            List<string> countriesList = new List<string>();
            List<string> cityList = new List<string>();

            string countriesIntroduction = "";
            string cityIntroduction = "";
            string timeDifference = "";
            string currExchangeRate = "";
            string txt_itemPrepare = "";
            string txt_specialReminder = "";
            string txt_cGPrecautions = "";
            string txt_yGCG = "";
            string txt_conduct = "";
            string txt_commonEnglish = "";

            if (dtBlack == null && (dtBlack.Rows[0]["Day"] == null || dtBlack.Rows[0]["Day"].ToString() == ""))
            {
                //ʾ

                //PublicCode.GetAlertMsg(this, GetType(), dt.Rows[dt.Rows.Count - 1]["Error"].ToString());
            }
            else
            {
                //ʾ
                Res_ThreeCode t = new Res_ThreeCode();
                //л
                string city = "";

                //ó
                for (int i = 0; i < dtBlack.Rows.Count; i++)
                {
                    if ((i + 1) < dtBlack.Rows.Count && dtBlack.Rows[i]["Three"].ToString() == dtBlack.Rows[i + 1]["Three"].ToString())
                    {
                        continue;
                    }
                    if (dtBlack.Rows.Count > 0 && (dtBlack.Rows[i]["Three"].ToString() != null && dtBlack.Rows[i]["Three"].ToString() != ""))
                    {
                        //
                        string cityTemp = dtBlack.Rows[i]["Three"].ToString().Replace("/", string.Empty).Substring(0, 3);
                        t = Db.Queryable<Res_ThreeCode>().First(x => x.Three == cityTemp && x.IsDel == 0 );
                        if (t != null)
                        {
                            city = city + "/" + t.City;
                        }
                        else
                        {
                            city = city + "/" + cityTemp + "δ¼ϵƱͬ¼롿";
                        }

                        if (i == dtBlack.Rows.Count - 1)
                        {
                            //ִ
                            cityTemp = dtBlack.Rows[i]["Three"].ToString().Replace("/", string.Empty).Substring(3, 3);
                            t = Db.Queryable<Res_ThreeCode>().First(x => x.Three == cityTemp && x.IsDel == 0);
                            if (t != null)
                            {
                                city = city + "/" + t.City;
                            }
                            else
                            {
                                city = city + "/" + cityTemp + "δ¼ϵƱͬ¼롿";
                            }
                        }
                    }
                }
                if (city != "" && city != null)
                {
                    string[] cityStr2 = city.Split('/');
                    string[] strs = cityStr2.Distinct().ToArray(); ;
                    string str = "";
                    foreach (var s in strs)
                    {
                        str += s + "/";
                    }
                    str = str.TrimStart('/');
                    str = str.TrimEnd('/');
                    //lblTourCity.Text = "ȥǰ" + city.TrimStart('/') + "\n ȥغ:" + str;
                    CityStr1 = city.TrimStart('/');
                }

                //opitineraryService opitservice = new opitineraryService();

                ////вΪ
                //if (!string.IsNullOrEmpty(city))
                //{
                //    cityList = city.TrimStart('/').Split('/').ToList();
                //    if (cityList.Count > 1)
                //    {
                //        cityList.RemoveAt(0);
                //    }
                //    opitinerarydata cityData = opitservice.getDaFirstData(cityList[0]);
                //    cityIntroduction = cityData.Introduction;
                //    timeDifference = cityData.TimeDifference;
                //    currExchangeRate = cityData.CurrExchangeRate.ToString();
                //}

                ////ҲΪ
                //if (!string.IsNullOrEmpty(di.VisitCountry))
                //{
                //    countriesList = di.VisitCountry.Split(' ').ToList();
                //    opitinerarydata Country = opitservice.getDaFirstData(countriesList[0]);
                //    countriesIntroduction = Country.Introduction == null ? "" : Country.Introduction;
                //}

                ////ȡ̶
                //opitineraryfixed fixedData = opitservice.getFiFirstData();
                ////if (!string.IsNullOrEmpty(fixedData.Tid.ToString()))
                ////{

                ////}

                //txt_cGPrecautions = fixedData.CGPrecautions;
                //txt_commonEnglish = fixedData.CommonEnglish;
                //txt_conduct = fixedData.Conduct;
                //txt_itemPrepare = fixedData.ItemPrepare;
                //txt_specialReminder = fixedData.SpecialReminder;
                //txt_yGCG = fixedData.YGCG;


                // гrepeater
                if (GetByDiid(diid).Count > 0)
                {
                    _travelList = GetByDiid(diid).Where(x => x.Issel == 1 && x.IsDel == 0).ToList();
                }
                else
                {

                    //ɸʱ
                    List<string> timeList = GetTimeListByDataTable(dtBlack);

                    if (timeList != null)
                    {
                        string[] str = new string[timeList.Count];
                        //rpData.DataSource = str;
                        //rpData.DataBind();
                    }
                }
            }


            //ԴTable
            DataTable dtSource = new DataTable();
            dtSource.Columns.Add("Days", typeof(string));
            dtSource.Columns.Add("Date", typeof(string));
            dtSource.Columns.Add("Week", typeof(string));
            dtSource.Columns.Add("Traffic", typeof(string));
            dtSource.Columns.Add("Trip", typeof(string));

            //ȡ,ŵdatatable
            foreach (var item in _travelList)
            {
                DataRow dr = dtSource.NewRow();
                dr["Days"] = item.Days;
                dr["Date"] = item.Date;
                dr["Week"] = item.WeekDay;
                dr["Traffic"] = item.Traffic_First
                                + "\r\n"
                                + item.Traffic_Second;
                if (item.Trip.Replace("˵ΪȲע磩", "").Length < 15)
                {
                    item.Trip += @"
08:00 ھƵꣻ
09:00 
10:30 
12:00 ڵز
14:00 
16:00 
18:00 ڵز
19:00 סƵϢ";
                }

                dr["Trip"] = item.Trip;
                dtSource.Rows.Add(dr);
            }

            //lblTeamName.Text = di.TourCode;
            //lblVisitDays.Text = di.VisitDays.ToString();
            //lblVisitDays2.Text = di.VisitDays.ToString();
            //lblPNumber.Text = di.VisitPNumber.ToString();
            //lblGroup.Text = di.TeamName.ToString();

            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("Dele", di.TeamName.ToString() + GetNum(di.VisitDays.ToString()));
            dic.Add("City", CityStr1);
            dic.Add("Days", di.VisitDays.ToString());
            dic.Add("DeleCode", di.TourCode);
            dic.Add("Pnum", di.VisitPNumber.ToString());
            dic.Add("Pnum2", di.VisitPNumber.ToString());

            List<Crm_DeleClient> leader = GetByDiidClient(di.Id);
            if (leader != null && leader.Count > 0)
            {
                dic.Add("Leader", GetByDiidClient(di.Id)[0].LastName + GetByDiidClient(di.Id)[0].FirstName);
            }
            else
            {
                dic.Add("Leader", "");
            }
            dic.Add("Pnum3", di.VisitPNumber.ToString());
            int UserId = 253;
            dic.Add("OP", "");
            dic.Add("OPTel", "");
            //dic.Add("OP", "OP");
            //dic.Add("OPTel", "OPֻ");

            string countriesStr = "";
            countriesList.ForEach(s => countriesStr += s + "");
            countriesStr = countriesStr.TrimEnd('');

            string cityStr = "";
            cityList.ForEach(s => cityStr += s + "");
            cityStr = cityStr.TrimEnd('');

            //·
            dic.Add("selCountries", countriesStr == null ? "" : countriesStr);
            dic.Add("selCity", cityStr == null ? "" : cityStr);
            dic.Add("countriesIntroduction", countriesIntroduction == null ? "" : countriesIntroduction);
            dic.Add("CityIntroduction", cityIntroduction == null ? "" : cityIntroduction);
            dic.Add("timeDifference", timeDifference == null ? "" : timeDifference);
            dic.Add("currExchangeRate", currExchangeRate == null ? "" : currExchangeRate);
            dic.Add("temperature", "");
            dic.Add("txt_itemPrepare", txt_itemPrepare == null ? "" : txt_itemPrepare);
            dic.Add("txt_specialReminder", txt_specialReminder == null ? "" : txt_specialReminder);
            dic.Add("txt_cGPrecautions", txt_cGPrecautions == null ? "" : txt_cGPrecautions);
            dic.Add("txt_yGCG", txt_yGCG == null ? "" : txt_yGCG);
            dic.Add("txt_conduct", txt_conduct == null ? "" : txt_conduct);
            dic.Add("txt_commonEnglish", txt_commonEnglish == null ? "" : txt_commonEnglish);

            //ģ·
            string tempPath = @"C:\г3.docx";
            //ģ
            Document doc = null;
            DocumentBuilder builder = null;
            try
            {
                //ģ
                doc = new Document(tempPath);
                builder = new DocumentBuilder(doc);
            }
            catch (Exception)
            {
                //ģ
                doc = new Document(@"D:\г3.docx");
                builder = new DocumentBuilder(doc);
            }


            foreach (var key in dic.Keys)
            {
                Bookmark bookmark = doc.Range.Bookmarks[key];
                if (bookmark != null)
                {
                    builder.MoveToBookmark(key);
                    builder.Write(dic[key]);
                }
            }

            //ȡwordб
            NodeCollection allTables = doc.GetChildNodes(NodeType.Table, true);
            //ȡ
            Aspose.Words.Tables.Table tableOne = allTables[0] as Aspose.Words.Tables.Table;

            try
            {
                //ѭֵ
                for (int i = 0; i < dtSource.Rows.Count; i++)
                {
                    builder.MoveToCell(0, i + 1, 0, 0);
                    builder.Write(dtSource.Rows[i]["Days"].ToString());

                    builder.MoveToCell(0, i + 1, 1, 0);
                    builder.Write(dtSource.Rows[i]["Date"].ToString() + "\r\n" + dtSource.Rows[i]["Week"].ToString());

                    builder.MoveToCell(0, i + 1, 2, 0);
                    builder.Write(dtSource.Rows[i]["Traffic"].ToString());

                    var trip = dtSource.Rows[i]["Trip"].ToString();
                    builder.MoveToCell(0, i + 1, 3, 0);
                    builder.Write(trip);

                    var cell = (Aspose.Words.Tables.Cell)doc.GetChild(NodeType.Cell, ((i + 2) * 4) - 1, true);
                    var paragraphs = cell.GetChildNodes(NodeType.Paragraph, true);

                    // ȡضĶ
                    Paragraph paragraph = (Paragraph)paragraphs[0];
                    Run run = paragraph.Runs[0];
                    Aspose.Words.Font font = run.Font;
                    font.Name = "";

                    //˫ݺɫ
                    cell = (Aspose.Words.Tables.Cell)doc.GetChild(NodeType.Cell, ((i + 2) * 4) - 3, true);
                    paragraphs = cell.GetChildNodes(NodeType.Paragraph, true);
                    paragraph = (Paragraph)paragraphs[1];
                    if (paragraph.GetText().Contains("") || paragraph.GetText().Contains(""))
                    {
                        run = paragraph.Runs[0];
                        font = run.Font;
                        font.Color = Color.Red;
                    }
                }
            }
            catch (Exception ex)
            {

            }


            //ɾ
            while (tableOne.Rows.Count > 1 + dtSource.Rows.Count)
            {
                tableOne.Rows.RemoveAt(1 + dtSource.Rows.Count);//(1+dtSource.Rows.Count + 1)-1
            }


            string savePath = "C:\\OPг̵\\";
            if (!Directory.Exists(savePath))
            {
                try
                {
                    Directory.CreateDirectory(savePath);
                }
                catch
                {

                }
            }
            string strFileName = savePath + di.TeamName + "ճ.docx";

            try
            {
                doc.Save(strFileName, Aspose.Words.SaveFormat.Doc);
                lblOutputResult.Text = "ļ";
                lblOutputResult.ForeColor = Color.Green;
                System.Diagnostics.Process.Start("Explorer.exe", "/select," + strFileName);
            }
            catch (Exception)
            {

                lblOutputResult.Text = "ԣ";
                lblOutputResult.ForeColor = Color.Green;
            }



            //doc.Save(HttpUtility.UrlEncode(strFileName, Encoding.UTF8), Aspose.Words.SaveFormat.Doc, Aspose.Words.SaveType.OpenInWord, Response);
        }

        private void btnImport_Click(object sender, EventArgs e)
        {
            lblImport.Text = "";
            lblImport.Text = "ڵ";
            int comb_Diid = 0;
            try
            {
                var dele = (comb_Delegation.SelectedItem as Grp_DelegationInfo);
                comb_Diid = dele.Id;
            }
            catch (Exception)
            {
                lblImport.Text = "ȷѡ!";
                lblImport.ForeColor = Color.Black;
                MessageBox.Show("ȷѡ!");
                return;
            }
            int UserId = 253;
            //ʵ
            //Grp_DelegationInfo di = dis.GetDelegationInfoByID(comb_Diid);
            Grp_DelegationInfo di = Db.Queryable<Grp_DelegationInfo>().First(x => x.Id == comb_Diid && x.IsDel == 0);

            if (di == null)
            {
                lblImport.Text = "ȷѡ!";
                lblImport.ForeColor = Color.Black;
                MessageBox.Show("ȷѡ!");
                return;
            }

            DataTable dt = null;
            try
            {
                //ȡƱϢdatatable
                dt = GetTableByBlackCode(di.Id);
            }
            catch (Exception)
            {
                lblImport.Text = "ȷѡ!";
                lblImport.ForeColor = Color.Black;
                MessageBox.Show("Ʊ!");
                return;
            }

            Del(di.Id);

            //ͨdatatableĵһֶεϢжǷк
            //ûʾδ¼
            if (dt.Rows[0]["Day"] == null || dt.Rows[0]["Day"].ToString() == "")
            {
                //PublicCode.GetAlertMsg(this, GetType(), dt.Rows[dt.Rows.Count - 1]["Error"].ToString());
                lblImport.Text = "δ¼";
            }
            else//ɹȡ
            {

                //ݺڶ
                List<string> timeList = GetTimeListByDataTable(dt);

                //ųؽϢ
                //List<CarTouristGuideGroundReservations> listctg = ctgs.GetCarTouristGuideGroundReservationsByDIID(di.Id);
                List<Grp_CarTouristGuideGroundReservations> listctg = Db.Queryable<Grp_CarTouristGuideGroundReservations>().Where(x => x.DiId == di.Id && x.IsDel == 0).ToList();

                //žƵϢ
                //List<HotelReservations> listht = htrs.GetByDIId(di.Id);
                List<Grp_HotelReservations> listht = Db.Queryable<Grp_HotelReservations>().Where(x => x.DiId == di.Id && x.IsDel == 0).ToList();

                //г̵
                //List<Grp_TravelList> listTravel = tls.GetByDiid(di.Id);
                List<Grp_TravelList> listTravel = Db.Queryable<Grp_TravelList>().Where(x => x.Diid == di.Id && x.IsDel == 0).ToList();

                try
                {
                    if (listTravel != null && listTravel.Count > 0)//Ѵг,ϲ/£ͬʱΪƱг̵ı仯гı仯ᵼг̸
                    {
                        if (timeList.Count > listTravel.Count)//1.İ>Ѵг̵
                        {
                            //1.1滻ں
                            for (int i = 0; i < listTravel.Count; i++)
                            {
                                //ת
                                string weekday = weekdays[(int)new DateTime(
                                   Convert.ToInt32(timeList[i].Split('-')[0]),
                                   Convert.ToInt32(timeList[i].Split('-')[1]),
                                   Convert.ToInt32(timeList[i].Split('-')[2])).DayOfWeek];


                                // ȥ0
                                string monthStr = "Unknown", dayStr = "Unknown";

                                if (!string.IsNullOrEmpty(timeList[i]))
                                {
                                    DateTime dateTime = new DateTime();
                                    bool convertResult = DateTime.TryParse(timeList[i], out dateTime);
                                    if (convertResult)
                                    {
                                        monthStr = dateTime.Month.ToString();
                                        dayStr = dateTime.Day.ToString();
                                    }
                                }

                                //
                                listTravel[i].Date = monthStr + "" + dayStr + "";

                                //listTravel[i].Date = timeList[i].Substring(5, 2) + "" + timeList[i].Substring(8, 2) + "";
                                listTravel[i].WeekDay = weekday;


                                listTravel[i].CreateUserId = UserId;
                                listTravel[i].CreateTime = GetBeijingTime();
                                listTravel[i].IsDel = 0;
                                //tls.EditTravelList(listTravel[i]);
                                Db.Updateable<Grp_TravelList>(listTravel[i]).ExecuteCommand();
                            }

                            //1.2δг
                            //űʶ
                            //string flightcode_Sign = "";
                            //ʶ
                            //string citycode_Sign = "";

                            #region  20210823 
                            List<CityInDate> CityInDateList = GetCityByDataTable(dt);
                            #endregion

                            //г
                            for (int i = listTravel.Count; i < timeList.Count; i++)
                            {
                                //ʵһtemp
                                Grp_TravelList tlTemp = new Grp_TravelList();

                                //ź
                                tlTemp.Diid = di.Id;
                                //
                                tlTemp.Days = i + 1;
                                //
                                tlTemp.Date = timeList[i].Substring(5, 2) + "" + timeList[i].Substring(8, 2) + "";

                                //ת
                                string weekday = weekdays[(int)new DateTime(
                                   Convert.ToInt32(timeList[i].Split('-')[0]),
                                   Convert.ToInt32(timeList[i].Split('-')[1]),
                                   Convert.ToInt32(timeList[i].Split('-')[2])).DayOfWeek];
                                tlTemp.WeekDay = weekday;


                                //г
                                string trip = "";
                                //
                                string city = "";


                                #region  Ʊ

                                //ݺϢƳִλϢ
                                string AirPort = "";

                                //ݺʱǰƽ뿪ʱ
                                string GoAirportTime = "", leaveAirPortTime = "";

                                //ɻʶ
                                bool airSign = false;

                                //ѯµĺϢ
                                //resultRowsֶ˳Ϊ,,,ʱ,ʱ,վ¥,ﺽվ¥,,ʱ,,ĵ
                                DataRow[] resultRows = dt.Select("Day like '%" + timeList[i] + "%'");

                                if (resultRows.Count() > 0)
                                {
                                    //޸ıʶ
                                    airSign = true;
                                }

                                //ͬһֻһж
                                if (resultRows.Count() == 1)
                                {

                                    #region 

                                    string _citycode = resultRows[0]["Three"].ToString();

                                    //ɳ
                                    Res_ThreeCode font_threecode = null;

                                    string font_citycode = _citycode.Replace("/", string.Empty).Substring(0, 3);
                                    //ִ
                                    string font_City = "";
                                    //ɳл
                                    string font_Airport = "";

                                    //ִ
                                    Res_ThreeCode back_threecode = null;

                                    string end_citycode = _citycode.Replace("/", string.Empty).Substring(3, 3);
                                    //ִл
                                    string back_Airport = "";
                                    //ִ
                                    string back_City = "";




                                    font_threecode = getByThree(font_citycode);
                                    //֤Ƿ
                                    if (font_threecode == null)
                                    {
                                        city = city + "" + font_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                        font_Airport = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                        font_City = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        city = city + "/" + font_threecode.City;
                                        font_Airport = font_threecode.AirPort;
                                        font_City = font_threecode.City; ;
                                    }
                                    back_threecode = getByThree(end_citycode);
                                    if (back_threecode == null)
                                    {
                                        city = city + "" + end_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                        back_Airport = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                        back_City = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        city = city + "/" + back_threecode.City;
                                        //ֻȲңҪѴ
                                        string result = GetCountryInfo(back_threecode.Country);
                                        if (result.Contains("3"))
                                        {
                                            city += "˵ΪȲע磩";
                                        }
                                        back_Airport = back_threecode.AirPort;
                                        back_City = back_threecode.City;
                                        //ѯƵ·Ҫ
                                        AirPort = back_threecode.AirPort;
                                    }
                                    //г
                                    #endregion

                                    #region Ϣ׼

                                    trip = city.TrimStart('/');
                                    //ɺվ¥
                                    string _StartBuilding = resultRows[0]["StartBuilding"].ToString();
                                    //תվ¥
                                    string _EndBuilding = resultRows[0]["EndBuilding"].ToString();
                                    //ʱ
                                    string _startTime = resultRows[0]["StartTime"].ToString();
                                    //ʱ
                                    string _flightTime = resultRows[0]["FlightTime"].ToString();
                                    _flightTime = _flightTime.Contains("H") ? _flightTime.Split('H')[0] + "Сʱ" + _flightTime.Split('H')[1].Split('M')[0] + "" : _flightTime.Split('M')[0] + "";
                                    //ʱ
                                    string _endTime = resultRows[0]["EndTime"].ToString();

                                    //
                                    string _flightcode = resultRows[0]["Fliagtcode"].ToString();
                                    //˾
                                    //Res_AirCompany aircompany = acs.getByShortCode(_flightcode.Substring(0, 2));
                                    Res_AirCompany aircompany = getByShortCode(_flightcode.Substring(0, 2));

                                    string _aircompany_Name = "";
                                    if (aircompany == null)
                                    {
                                        _aircompany_Name = "˺˾" + resultRows[0]["Fliagtcode"].ToString().Substring(0, 2) + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        _aircompany_Name = aircompany.CnName;
                                    }



                                    //ж
                                    string airModel = resultRows[0]["AirModel"].ToString();

                                    airModel = GetLonger(airModel.Substring(0, 1)) + airModel;
                                    #endregion

                                    #region trip༭
                                    //еִʱ"+1",Ϊĸ,ʾǻ
                                    if (resultRows[0]["Sign"].ToString() == "0" && _endTime.Contains("+"))
                                    {
                                        //ݺϢʱ                               
                                        int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰСʱ
                                        string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰСʱ
                                        if (result.Contains("2"))
                                        {
                                            temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                        }
                                        if (temp < 0)
                                        {
                                            temp = temp + 24;
                                        }
                                        GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                        GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                        //һ֮г̿ԼϡƵľʱ
                                        if (i > 0)
                                        {
                                            #region Ƶ      
                                            foreach (var h in listht)
                                            {
                                                if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                 && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                                {
                                                    //ùȸAPI·
                                                    if (AirPort != "")
                                                    {
                                                        GoogleMapApiResult g = null;

                                                        if (g != null)
                                                        {
                                                            //㡰Ƶ굽ʱ
                                                            string CheckoutHotelTime;

                                                            //ʱʽ
                                                            string hours = "", mins = "";
                                                            if (g.Time.Contains("hour"))
                                                            {
                                                                g.Time = g.Time.Replace("hour", "h");

                                                            }
                                                            else if (g.Time.Contains("hours"))
                                                            {
                                                                g.Time = g.Time.Replace("hours", "h");
                                                            }

                                                            g.Time = g.Time.Replace("mins", "m");
                                                            if (g.Time.Contains("h"))
                                                            {
                                                                hours = g.Time.Split('h')[0].Trim();

                                                            }
                                                            else if (!g.Time.Contains("h"))
                                                            {
                                                                mins = g.Time.Split('m')[0].Trim();
                                                            }

                                                            int hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                            int min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                            min = min - Convert.ToInt32(mins);
                                                            if (min < 0)
                                                            {
                                                                min = min + 60;
                                                                hour = hour - 1;
                                                            }
                                                            if (hours != "")
                                                            {
                                                                hour = hour - Convert.ToInt32(hours);
                                                            }
                                                            if (hour < 0)
                                                            {
                                                                hour = hour + 24;
                                                            }

                                                            CheckoutHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                            CheckoutHotelTime = CheckoutHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                            trip = trip + "\r\n"
                                                                        + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                        }
                                                        else
                                                        {
                                                            try
                                                            {
                                                                JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                //㡰ִƵסʱ
                                                                string CheckoutHotelTime;

                                                                //ʱʽ
                                                                string Gtime = "", hours = "", mins = "";
                                                                if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                {
                                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                }
                                                                else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                {
                                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                }
                                                                Gtime = Gtime.Replace("mins", "m");

                                                                if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                {
                                                                    hours = Gtime.Split('h')[0].Trim();

                                                                }
                                                                else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                {
                                                                    mins = Gtime.Split('m')[0].Trim();
                                                                }


                                                                int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                min = min - Convert.ToInt32(mins);
                                                                if (min < 0)
                                                                {
                                                                    min = min + 60;
                                                                    hour = hour - 1;
                                                                }

                                                                if (hours != "")
                                                                {
                                                                    hour = hour + Convert.ToInt32(hours);
                                                                }
                                                                if (hour < 0)
                                                                {
                                                                    hour = hour + 24;
                                                                }
                                                                CheckoutHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                                CheckoutHotelTime = CheckoutHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                                trip = trip + "\r\n"
                                                                            + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                gtemp.Diid = di.Id;
                                                                gtemp.Date = "";
                                                                gtemp.Moment = "";
                                                                gtemp.StartAddress = AirPort;
                                                                gtemp.EndAddress = h.HotelAddress;
                                                                gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                //gmrs.Add(gtemp);

                                                            }
                                                            catch
                                                            {
                                                                trip = trip + "\r\n"
                                                                     + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            #endregion
                                        }

                                        //г
                                        trip = trip
                                             + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                             + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                             + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + "";

                                        //ǱΪĸ
                                        //flightcode_Sign = resultRows[0]["Fliagtcode"].ToString();
                                        //citycode_Sign = resultRows[0]["Three"].ToString();
                                    }
                                    //ǰһк,ͬұеִʱ䲻"+1"Ǳɵظ,ʾִ
                                    else if (resultRows[0]["Sign"].ToString() == "1") /* && (!_endTime.Contains("+"))&&(_flightcode == flightcode_Sign)&&(_citycode == citycode_Sign)*/
                                    {

                                        //г
                                        trip = trip
                                             + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                        //ݺϢ뿪ʱ
                                        int temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                        leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                        leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                        if (i == timeList.Count - 1)//г̵һ죬ѡгԲ 
                                        {
                                            trip = trip + " Բ˴η֮У";
                                        }
                                        else //ղг̵һ죬
                                        {
                                            //trip += pushTrip(leaveAirPortTime, back_Airport, city,out leaveAirPortTime);
                                            trip = trip + "\r\n" + leaveAirPortTime + " רǰƵִ꣬ס";
                                        }

                                        //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                        int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                        int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                        min = min + 10;
                                        if (min > 59)
                                        {
                                            min = min - 60;
                                            hour = hour + 1;
                                        }
                                        if (hour > 23)
                                        {
                                            hour = hour - 24;
                                        }
                                        leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                        leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                    }
                                    //ʾ
                                    else
                                    {
                                        //ݺϢʱ
                                        int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰ2Сʱ
                                        string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰ3Сʱ
                                        if (result.Contains("2"))
                                        {
                                            temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                        }
                                        if (temp < 0)
                                        {
                                            temp = temp + 24;
                                        }
                                        GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                        GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                        //ݺϢ뿪ʱ
                                        temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                        leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                        leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                        //һ֮г̿ԼϡƵľʱ
                                        if (i > 0)
                                        {
                                            #region Ƶ      
                                            foreach (var h in listht)
                                            {
                                                if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                 && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                                {
                                                    //ùȸAPI·
                                                    if (AirPort != "")
                                                    {
                                                        GoogleMapApiResult g = null;

                                                        if (g != null)
                                                        {
                                                            //㡰Ƶ굽ʱ
                                                            string CheckoutHotelTime;

                                                            //ʱʽ
                                                            string hours = "0", mins = "0";
                                                            if (g.Time.Contains("hour"))
                                                            {
                                                                g.Time = g.Time.Replace("hour", "h");

                                                            }
                                                            else if (g.Time.Contains("hours"))
                                                            {
                                                                g.Time = g.Time.Replace("hours", "h");
                                                            }

                                                            g.Time = g.Time.Replace("mins", "m");
                                                            if (g.Time.Contains("h"))
                                                            {
                                                                hours = g.Time.Split('h')[0].Trim();

                                                            }
                                                            else if (!g.Time.Contains("h"))
                                                            {
                                                                mins = g.Time.Split('m')[0].Trim();
                                                            }

                                                            int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                            int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                            _min = _min - Convert.ToInt32(mins);
                                                            if (_min < 0)
                                                            {
                                                                _min = _min + 60;
                                                                _hour = _hour - 1;
                                                            }
                                                            if (hours != "")
                                                            {
                                                                _hour = _hour - Convert.ToInt32(hours);
                                                            }
                                                            if (_hour < 0)
                                                            {
                                                                _hour = _hour + 24;
                                                            }

                                                            CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                            CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                            trip = trip + "\r\n"
                                                                        + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                        }
                                                        else
                                                        {
                                                            try
                                                            {
                                                                JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                //㡰ִƵסʱ
                                                                string CheckoutHotelTime;

                                                                //ʱʽ
                                                                string Gtime = "", hours = "0", mins = "0";
                                                                if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                {
                                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                }
                                                                else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                {
                                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                }
                                                                Gtime = Gtime.Replace("mins", "m");

                                                                if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                {
                                                                    hours = Gtime.Split('h')[0].Trim();

                                                                }
                                                                else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                {
                                                                    mins = Gtime.Split('m')[0].Trim();
                                                                }


                                                                int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                _min = _min - Convert.ToInt32(mins);
                                                                if (_min < 0)
                                                                {
                                                                    _min = _min + 60;
                                                                    _hour = _hour - 1;
                                                                }

                                                                if (hours != "")
                                                                {
                                                                    _hour = _hour + Convert.ToInt32(hours);
                                                                }
                                                                if (_hour < 0)
                                                                {
                                                                    _hour = _hour + 24;
                                                                }
                                                                CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                trip = trip + "\r\n"
                                                                            + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                gtemp.Diid = di.Id;
                                                                gtemp.Date = "";
                                                                gtemp.Moment = "";
                                                                gtemp.StartAddress = AirPort;
                                                                gtemp.EndAddress = h.HotelAddress;
                                                                gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                //gmrs.Add(gtemp);

                                                            }
                                                            catch
                                                            {
                                                                trip = trip + "\r\n"
                                                                     + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            #endregion
                                        }

                                        trip = trip
                                             + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                             + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                             + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                             + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";



                                        if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                        {
                                            trip = trip + "Բ˴η֮У";
                                        }
                                        else //ղг̵һ죬
                                        {
                                            trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                            trip = trip + "\r\n" + leaveAirPortTime + "רǰƵִ꣬ס";
                                        }

                                        //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                        int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                        int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                        min = min + 10;
                                        if (min > 59)
                                        {
                                            min = min - 60;
                                            hour = hour + 1;
                                        }
                                        if (hour > 23)
                                        {
                                            hour = hour - 24;
                                        }
                                        leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                        leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                    }
                                    #endregion

                                }
                                //ͬһ߷
                                else
                                {
                                    for (int n = 0; n < resultRows.Count(); n++)
                                    {
                                        city = "";

                                        #region 

                                        string _citycode = resultRows[n]["Three"].ToString();

                                        //ɳ
                                        Res_ThreeCode font_threecode = null;
                                        string font_citycode = _citycode.Replace("/", string.Empty).Substring(0, 3);
                                        //ִ
                                        string font_City = "";
                                        //ɳл
                                        string font_Airport = "";

                                        //ִ
                                        Res_ThreeCode back_threecode = null;
                                        string end_citycode = _citycode.Replace("/", string.Empty).Substring(3, 3);
                                        //ִл
                                        string back_Airport = "";
                                        //ִ
                                        string back_City = "";


                                        font_threecode = getByThree(font_citycode);
                                        //֤Ƿ
                                        if (font_threecode == null)
                                        {
                                            city = city + "" + font_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                            font_Airport = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                            font_City = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                        }
                                        else
                                        {
                                            city = city + "/" + font_threecode.City;
                                            font_Airport = font_threecode.AirPort;
                                            font_City = font_threecode.City; ;
                                        }
                                        back_threecode = getByThree(end_citycode);
                                        if (back_threecode == null)
                                        {
                                            city = city + "" + end_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                            back_Airport = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                            back_City = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                        }
                                        else
                                        {
                                            city = city + "/" + back_threecode.City;
                                            //ֻȲңҪѴ
                                            string result = GetCountryInfo(back_threecode.Country);
                                            if (result.Contains("3"))
                                            {
                                                city += "˵ΪȲע磩";
                                            }
                                            back_Airport = back_threecode.AirPort;
                                            back_City = back_threecode.City;
                                            //ѯƵ·Ҫ
                                            AirPort = back_threecode.AirPort;
                                        }
                                        //г
                                        if (trip == "")
                                        {
                                            trip = city.TrimStart('/');
                                        }
                                        else
                                        {
                                            trip = trip + "\r\n"
                                                 + city.TrimStart('/');
                                        }
                                        //ɺվ¥
                                        string _StartBuilding = resultRows[n]["StartBuilding"].ToString();
                                        //תվ¥
                                        string _EndBuilding = resultRows[n]["EndBuilding"].ToString();
                                        //ʱ
                                        string _startTime = resultRows[n]["StartTime"].ToString();
                                        //ʱ
                                        string _flightTime = resultRows[n]["FlightTime"].ToString();
                                        _flightTime = _flightTime.Contains("H") ? _flightTime.Split('H')[0] + "Сʱ" + _flightTime.Split('H')[1].Split('M')[0] + "" : _flightTime.Split('M')[0] + "";
                                        //ʱ
                                        string _endTime = resultRows[n]["EndTime"].ToString();

                                        //
                                        string _flightcode = resultRows[n]["Fliagtcode"].ToString();
                                        //˾
                                        Res_AirCompany aircompany = getByShortCode(_flightcode.Substring(0, 2));
                                        string _aircompany_Name = "";
                                        if (aircompany == null)
                                        {
                                            _aircompany_Name = "˺˾" + resultRows[n]["Fliagtcode"].ToString().Substring(0, 2) + "δ¼Ʊͬ¼롿";
                                        }
                                        else
                                        {
                                            _aircompany_Name = aircompany.CnName;
                                        }



                                        //ж
                                        string airModel = resultRows[n]["AirModel"].ToString();

                                        airModel = GetLonger(airModel.Substring(0, 1)) + airModel;
                                        #endregion

                                        //SignֶΪʶstringͣ壺0ʾΪԭ롢1ʾ+1ĺ
                                        //ĿǰͬһĶݱʶΪ0->01->0
                                        //ʾ
                                        //Day ArrivedDate Sign
                                        //10      10       0
                                        //10      11       0
                                        //11      11       1
                                        //11      12       0
                                        //12      12       1
                                        if (n == 0)
                                        {
                                            //ԭƱ
                                            if (resultRows[n]["Sign"].ToString() == "0")
                                            {
                                                #region trip༭
                                                //ݺϢʱ
                                                int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰСʱ
                                                string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰСʱ
                                                if (result.Contains("2"))
                                                {
                                                    temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                                }
                                                if (temp < 0)
                                                {
                                                    temp = temp + 24;
                                                }
                                                GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);


                                                //һ֮г̿ԼϡƵľʱ
                                                if (i > 0)
                                                {
                                                    #region Ƶ      
                                                    foreach (var h in listht)
                                                    {
                                                        if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                         && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                                        {
                                                            //ùȸAPI·
                                                            if (AirPort != "")
                                                            {
                                                                GoogleMapApiResult g = null;

                                                                if (g != null)
                                                                {
                                                                    //㡰Ƶ굽ʱ
                                                                    string CheckoutHotelTime;

                                                                    //ʱʽ
                                                                    string hours = "0", mins = "0";
                                                                    if (g.Time.Contains("hour"))
                                                                    {
                                                                        g.Time = g.Time.Replace("hour", "h");

                                                                    }
                                                                    else if (g.Time.Contains("hours"))
                                                                    {
                                                                        g.Time = g.Time.Replace("hours", "h");
                                                                    }

                                                                    g.Time = g.Time.Replace("mins", "m");
                                                                    if (g.Time.Contains("h"))
                                                                    {
                                                                        hours = g.Time.Split('h')[0].Trim();

                                                                    }
                                                                    else if (!g.Time.Contains("h"))
                                                                    {
                                                                        mins = g.Time.Split('m')[0].Trim();
                                                                    }

                                                                    int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                                    int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                                    _min = _min - Convert.ToInt32(mins);
                                                                    if (_min < 0)
                                                                    {
                                                                        _min = _min + 60;
                                                                        _hour = _hour - 1;
                                                                    }
                                                                    if (hours != "")
                                                                    {
                                                                        _hour = _hour - Convert.ToInt32(hours);
                                                                    }
                                                                    if (_hour < 0)
                                                                    {
                                                                        _hour = _hour + 24;
                                                                    }

                                                                    CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                    CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                    trip = trip + "\r\n"
                                                                                + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                                }
                                                                else
                                                                {
                                                                    try
                                                                    {
                                                                        JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                        //㡰ִƵסʱ
                                                                        string CheckoutHotelTime;

                                                                        //ʱʽ
                                                                        string Gtime = "", hours = "0", mins = "0";
                                                                        if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                        {
                                                                            Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                        }
                                                                        else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                        {
                                                                            Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                        }
                                                                        Gtime = Gtime.Replace("mins", "m");

                                                                        if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                        {
                                                                            hours = Gtime.Split('h')[0].Trim();

                                                                        }
                                                                        else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                        {
                                                                            mins = Gtime.Split('m')[0].Trim();
                                                                        }


                                                                        int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                        int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                        _min = _min - Convert.ToInt32(mins);
                                                                        if (_min < 0)
                                                                        {
                                                                            _min = _min + 60;
                                                                            _hour = _hour - 1;
                                                                        }

                                                                        if (hours != "")
                                                                        {
                                                                            _hour = _hour + Convert.ToInt32(hours);
                                                                        }
                                                                        if (_hour < 0)
                                                                        {
                                                                            _hour = _hour + 24;
                                                                        }
                                                                        CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                        CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                        trip = trip + "\r\n"
                                                                                    + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                        GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                        gtemp.Diid = di.Id;
                                                                        gtemp.Date = "";
                                                                        gtemp.Moment = "";
                                                                        gtemp.StartAddress = AirPort;
                                                                        gtemp.EndAddress = h.HotelAddress;
                                                                        gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                        gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                        //gmrs.Add(gtemp);

                                                                    }
                                                                    catch
                                                                    {
                                                                        trip = trip + "\r\n"
                                                                             + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    #endregion
                                                }

                                                trip = trip
                                                     + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                                     + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                                     + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                                     + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,ȡ";

                                                #endregion
                                            }
                                            //"+1"ɵĻƱ
                                            else if (resultRows[n]["Sign"].ToString() == "1")
                                            {
                                                #region trip༭
                                                //г
                                                trip = trip
                                                     + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,ȡ";
                                                #endregion
                                            }
                                        }
                                        else if (n > 0)
                                        {
                                            //ǰԭģжΪת
                                            if (resultRows[n - 1]["Sign"].ToString() == "0")
                                            {
                                                #region trip༭
                                                int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 1;//һǰǰ2Сʱ
                                                if (temp < 0)
                                                {
                                                    temp = temp + 24;
                                                }
                                                GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                                trip = trip
                                                 + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                                 + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                                 + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                                 + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                                //ΪһУ󱸵ʱ
                                                if (n == resultRows.Count() - 1)
                                                {
                                                    //ݺϢ뿪ʱ
                                                    temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                                    leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                    leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                                    if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                                    {
                                                        trip = trip + "Բ˴η֮У";
                                                    }
                                                    else //ղг̵һ죬
                                                    {
                                                        trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                                        trip = trip + "\r\n" + leaveAirPortTime + "רǰƵִ꣬ס";
                                                    }

                                                    //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                                    int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                    int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                                    min = min + 10;
                                                    if (min > 59)
                                                    {
                                                        min = min - 60;
                                                        hour = hour + 1;
                                                    }
                                                    if (hour > 23)
                                                    {
                                                        hour = hour - 24;
                                                    }
                                                    leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                    leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                                }
                                                #endregion
                                            }
                                            //ǰɵģжΪ³
                                            else if (resultRows[n - 1]["Sign"].ToString() == "1")
                                            {
                                                #region trip༭
                                                //ݺϢʱ
                                                int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰ2Сʱ
                                                string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰ3Сʱ
                                                if (result.Contains("2"))
                                                {
                                                    temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                                }
                                                if (temp < 0)
                                                {
                                                    temp = temp + 24;
                                                }
                                                GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                                //ݺϢ뿪ʱ
                                                temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                                leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                                //һ֮г̿ԼϡƵľʱ
                                                if (i > 0)
                                                {
                                                    #region Ƶ      
                                                    foreach (var h in listht)
                                                    {
                                                        if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                         && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                                        {
                                                            //ùȸAPI·
                                                            if (AirPort != "")
                                                            {
                                                                GoogleMapApiResult g = null;

                                                                if (g != null)
                                                                {
                                                                    //㡰Ƶ굽ʱ
                                                                    string CheckoutHotelTime;

                                                                    //ʱʽ
                                                                    string hours = "0", mins = "0";
                                                                    if (g.Time.Contains("hour"))
                                                                    {
                                                                        g.Time = g.Time.Replace("hour", "h");

                                                                    }
                                                                    else if (g.Time.Contains("hours"))
                                                                    {
                                                                        g.Time = g.Time.Replace("hours", "h");
                                                                    }

                                                                    g.Time = g.Time.Replace("mins", "m");
                                                                    if (g.Time.Contains("h"))
                                                                    {
                                                                        hours = g.Time.Split('h')[0].Trim();

                                                                    }
                                                                    else if (!g.Time.Contains("h"))
                                                                    {
                                                                        mins = g.Time.Split('m')[0].Trim();
                                                                    }

                                                                    int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                                    int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                                    _min = _min - Convert.ToInt32(mins);
                                                                    if (_min < 0)
                                                                    {
                                                                        _min = _min + 60;
                                                                        _hour = _hour - 1;
                                                                    }
                                                                    if (hours != "")
                                                                    {
                                                                        _hour = _hour - Convert.ToInt32(hours);
                                                                    }
                                                                    if (_hour < 0)
                                                                    {
                                                                        _hour = _hour + 24;
                                                                    }

                                                                    CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                    CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                    trip = trip + "\r\n"
                                                                                + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                                }
                                                                else
                                                                {
                                                                    try
                                                                    {
                                                                        JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                        //㡰ִƵסʱ
                                                                        string CheckoutHotelTime;

                                                                        //ʱʽ
                                                                        string Gtime = "", hours = "0", mins = "0";
                                                                        if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                        {
                                                                            Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                        }
                                                                        else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                        {
                                                                            Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                        }
                                                                        Gtime = Gtime.Replace("mins", "m");

                                                                        if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                        {
                                                                            hours = Gtime.Split('h')[0].Trim();

                                                                        }
                                                                        else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                        {
                                                                            mins = Gtime.Split('m')[0].Trim();
                                                                        }


                                                                        int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                        int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                        _min = _min - Convert.ToInt32(mins);
                                                                        if (_min < 0)
                                                                        {
                                                                            _min = _min + 60;
                                                                            _hour = _hour - 1;
                                                                        }

                                                                        if (hours != "")
                                                                        {
                                                                            _hour = _hour + Convert.ToInt32(hours);
                                                                        }
                                                                        if (_hour < 0)
                                                                        {
                                                                            _hour = _hour + 24;
                                                                        }
                                                                        CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                        CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                        trip = trip + "\r\n"
                                                                                    + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                        GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                        gtemp.Diid = di.Id;
                                                                        gtemp.Date = "";
                                                                        gtemp.Moment = "";
                                                                        gtemp.StartAddress = AirPort;
                                                                        gtemp.EndAddress = h.HotelAddress;
                                                                        gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                        gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                        //gmrs.Add(gtemp);

                                                                    }
                                                                    catch
                                                                    {
                                                                        trip = trip + "\r\n"
                                                                             + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    #endregion
                                                }

                                                trip = trip
                                                     + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                                     + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                                     + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                                     + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                                if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                                {
                                                    trip = trip + "Բ˴η֮У";
                                                }
                                                else //ղг̵һ죬
                                                {
                                                    trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                                    trip = trip + "\r\n" + leaveAirPortTime + "רǰƵִ꣬ס";
                                                }

                                                //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                                int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                                min = min + 10;
                                                if (min > 59)
                                                {
                                                    min = min - 60;
                                                    hour = hour + 1;
                                                }
                                                if (hour > 23)
                                                {
                                                    hour = hour - 24;
                                                }
                                                leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                                #endregion
                                            }

                                        }
                                    }
                                }



                                #endregion


                                #region г̺ͳиֵ
                                if (trip == "" || trip == " " || city == "" || city == " ")
                                {
                                    //city = CityInDateList.Find(cid => cid.Date == timeList[i]).City;
                                    city = CityInDateList[i].City;
                                    //ֻȲңҪѴ
                                    string result = GetCountryInfo(getByCity(city)[0].Country);
                                    if (result.Contains("3"))
                                    {
                                        city += "˵ΪȲע磩";
                                    }
                                    trip = city;
                                }
                                #endregion


                                #region   20210820 
                                string OATemp = "";//ݴ湫

                                //źźڻȡ
                                List<Res_OfficialActivities> listoa = getByDiidAndDate(comb_Diid, timeList[i]);

                                //listoaڹݣٽе
                                if (listoa != null && listoa.Count > 0)
                                {
                                    //datatableŹ
                                    DataTable OA_DataTable = new DataTable();
                                    OA_DataTable.Columns.Add("StartTime", typeof(string)); //activityʼʱ
                                    OA_DataTable.Columns.Add("EndTime", typeof(string)); //activityʱ
                                    OA_DataTable.Columns.Add("Client", typeof(string)); //activityλ
                                    OA_DataTable.Columns.Add("Address", typeof(string)); //activityַ
                                    OA_DataTable.Columns.Add("Contact", typeof(string)); //activityϵ
                                    OA_DataTable.Columns.Add("Tel", typeof(string)); //activityϵ˵绰
                                    OA_DataTable.Columns.Add("Dresscode", typeof(string)); //activityװҪ
                                    OA_DataTable.Columns.Add("isTranslate", typeof(bool));//ǷҪԱ
                                    OA_DataTable.Columns.Add("Language", typeof(string));//ǷҪԱ

                                    //
                                    for (int b = 0; b < listoa.Count; b++)
                                    {
                                        //ֹʱ
                                        string[] time = new string[2];
                                        if (listoa[b].Time.Contains(''))
                                        {
                                            time = listoa[b].Time.Split('');
                                        }
                                        else if (listoa[b].Time.Contains('-'))
                                        {
                                            time = listoa[b].Time.Split('-');
                                        }

                                        //
                                        if (time.Length >= 2)
                                        {
                                            OA_DataTable.Rows.Add(time[0], time[1], listoa[b].Client, listoa[b].Address, listoa[b].Contact, listoa[b].Tel, listoa[b].Dresscode, listoa[b].IsNeedTrans, listoa[b].language);
                                        }
                                        else
                                        {
                                            //PublicCode.GetAlertMsg(this, GetType(), timeList[i] + "Ĺ");
                                        }

                                    }
                                    //
                                    OA_DataTable.DefaultView.Sort = "StartTime asc";
                                    OA_DataTable = OA_DataTable.DefaultView.ToTable();


                                    //Ϣ
                                    for (int index = 0; index < OA_DataTable.Rows.Count; index++)
                                    {
                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                        {
                                            if (OATemp != "")
                                            {
                                                OATemp = OATemp + "\r\n"
                                                         + OA_DataTable.Rows[index]["StartTime"].ToString()
                                                         + "-"
                                                         + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                            }
                                            else
                                            {
                                                OATemp = OA_DataTable.Rows[index]["StartTime"].ToString()
                                                         + "-"
                                                         + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                            }
                                        }
                                        else
                                        {
                                            //빫
                                            trip = trip + "\r\n"
                                                        + OA_DataTable.Rows[index]["StartTime"].ToString()
                                                        + "-"
                                                        + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                        }
                                        //һǴӾƵ˿ɼƵ굽ַľʱ
                                        if (index == 0)
                                        {
                                            #region Ƶ
                                            foreach (var h in listht)
                                            {
                                                if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                                 && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                                {
                                                    //ùȸAPI·
                                                    GoogleMapApiResult g = null;
                                                    if (g != null)
                                                    {
                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  " + g.Distance + "" + g.Time + "";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  " + g.Distance + "" + g.Time + "";
                                                        }

                                                    }
                                                    else
                                                    {
                                                        try
                                                        {
                                                            JObject Result = GetDirectionByGoogleApi(h.HotelAddress, OA_DataTable.Rows[0]["Address"].ToString());

                                                            if (i == 0)//г̵һĹھƵ棬ݴһ
                                                            {
                                                                OATemp = OATemp + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                                + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                            }
                                                            else
                                                            {
                                                                trip = trip + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                            + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                            }


                                                            GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                            gtemp.Diid = di.Id;
                                                            gtemp.Date = "";
                                                            gtemp.Moment = "";
                                                            gtemp.StartAddress = h.HotelAddress;
                                                            gtemp.EndAddress = OA_DataTable.Rows[0]["Address"].ToString();
                                                            gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                            gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                            //gmrs.Add(gtemp);
                                                        }
                                                        catch
                                                        {
                                                            if (i == 0)//г̵һĹھƵ棬ݴһ
                                                            {
                                                                OATemp = OATemp + "  ȸӿ쳣޷·ʱ䣩";
                                                            }
                                                            else
                                                            {
                                                                trip = trip + "  ȸӿ쳣޷·ʱ䣩";
                                                            }

                                                        }
                                                    }
                                                }
                                            }
                                            #endregion
                                        }
                                        //ڶĲǰַԣ˲˷ʱ䣻ɼɹַؾƵϢ
                                        else
                                        {
                                            #region Ƶ
                                            foreach (var h in listht)
                                            {
                                                if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                                 && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                                {
                                                    //ùȸAPI·
                                                    GoogleMapApiResult g = null;
                                                    if (g != null)
                                                    {
                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  " + g.Distance + "" + g.Time + "";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  " + g.Distance + "" + g.Time + "";
                                                        }
                                                    }
                                                    else
                                                    {
                                                        try
                                                        {
                                                            JObject Result = GetDirectionByGoogleApi(OA_DataTable.Rows[index]["Address"].ToString(), h.HotelAddress);
                                                            if (i == 0)//г̵һĹھƵ棬ݴһ
                                                            {
                                                                OATemp = OATemp + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                                + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                            }
                                                            else
                                                            {
                                                                trip = trip + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                            + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                            }

                                                            GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                            gtemp.Diid = di.Id;
                                                            gtemp.Date = "";
                                                            gtemp.Moment = "";
                                                            gtemp.StartAddress = OA_DataTable.Rows[0]["Address"].ToString();
                                                            gtemp.EndAddress = h.HotelAddress;
                                                            gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                            gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                            //gmrs.Add(gtemp);
                                                        }
                                                        catch
                                                        {
                                                            if (i == 0)//г̵һĹھƵ棬ݴһ
                                                            {
                                                                OATemp = OATemp + "  ȸӿ쳣޷·ʱ䣩";
                                                            }
                                                            else
                                                            {
                                                                trip = trip + "  ȸӿ쳣޷·ʱ䣩";
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            #endregion
                                        }
                                    }
                                }
                                #endregion


                                #region Ƶ      
                                foreach (var h in listht)
                                {

                                    if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                     && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))//ȥ=ԭгһһ㲻оƵ
                                    {
                                        //ùȸAPI·
                                        if (AirPort != "")
                                        {
                                            GoogleMapApiResult g = null;

                                            if (g != null)
                                            {
                                                trip = trip + "\r\n"
                                                    + leaveAirPortTime + " ˳ǰƵ:" + g.Distance + "" + g.Time + "";

                                                //㡰ִƵסʱ
                                                string CheckInHotelTime;

                                                //ʱʽ
                                                string hours = "", mins = "";
                                                if (g.Time.Contains("hour"))
                                                {
                                                    g.Time = g.Time.Replace("hour", "h");

                                                }
                                                else if (g.Time.Contains("hours"))
                                                {
                                                    g.Time = g.Time.Replace("hours", "h");
                                                }

                                                g.Time = g.Time.Replace("mins", "m");
                                                if (g.Time.Contains("h"))
                                                {
                                                    hours = g.Time.Split('h')[0].Trim();

                                                }
                                                else if (!g.Time.Contains("h"))
                                                {
                                                    mins = g.Time.Split('m')[0].Trim();
                                                }

                                                int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                min = min + Convert.ToInt32(mins);
                                                if (min > 59)
                                                {
                                                    min = min - 60;
                                                    hour = hour + 1;
                                                }
                                                if (hours != "")
                                                {
                                                    hour = hour + Convert.ToInt32(hours);
                                                }
                                                if (hour > 23)
                                                {
                                                    hour = hour - 24;
                                                }

                                                CheckInHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                CheckInHotelTime = CheckInHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                trip = trip + "\r\n"
                                                            + CheckInHotelTime + " ִƵס";
                                            }
                                            else
                                            {
                                                try
                                                {
                                                    JObject Result = GetDirectionByGoogleApi(AirPort, h.HotelAddress);

                                                    trip = trip + "\r\n"
                                                        + leaveAirPortTime + " ˳ǰƵ:" + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                                                 + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";

                                                    //㡰ִƵסʱ
                                                    string CheckInHotelTime;

                                                    //ʱʽ
                                                    string Gtime = "", hours = "", mins = "";
                                                    if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                    {
                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                    }
                                                    else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                    {
                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                    }
                                                    Gtime = Gtime.Replace("mins", "m");

                                                    if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                    {
                                                        hours = Gtime.Split('h')[0].Trim();

                                                    }
                                                    else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                    {
                                                        mins = Gtime.Split('m')[0].Trim();
                                                    }


                                                    int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                    int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                    min = min + Convert.ToInt32(mins);
                                                    if (min > 59)
                                                    {
                                                        min = min - 60;
                                                        hour = hour + 1;
                                                    }

                                                    if (hours != "")
                                                    {
                                                        hour = hour + Convert.ToInt32(hours);
                                                    }
                                                    if (hour > 23)
                                                    {
                                                        hour = hour - 24;
                                                    }
                                                    CheckInHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                    CheckInHotelTime = CheckInHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                    trip = trip + "\r\n"
                                                                + CheckInHotelTime + " ִƵס";

                                                    GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                    gtemp.Diid = di.Id;
                                                    gtemp.Date = "";
                                                    gtemp.Moment = "";
                                                    gtemp.StartAddress = AirPort;
                                                    gtemp.EndAddress = h.HotelAddress;
                                                    gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                    gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                    //gmrs.Add(gtemp);

                                                }
                                                catch
                                                {
                                                    trip = trip + "\r\n"
                                                         + "          ȸӿ쳣޷·ʱ䣩";
                                                }
                                            }

                                        }

                                        trip = trip + "\r\n"
                                            + "          Ƶƣ" + h.HotelName + "\r\n"
                                            + "          Ƶַ" + h.HotelAddress + "\r\n"
                                            + "          Ƶ绰" + h.HotelTel + "      Ƶ괫棺" + (h.HotelFax == "" ? "-" : h.HotelFax);

                                        if (i == 0 && !string.IsNullOrEmpty(OATemp))
                                        {
                                            trip = trip + "\r\n" + OATemp;
                                        }
                                    }
                                }
                                #endregion


                                #region 콻ͨ߸ֵ
                                //һг̵һ춼ȳɻ
                                if (i == 0)
                                {
                                    tlTemp.Traffic_First = "ɻ";
                                    tlTemp.Traffic_Second = "";
                                }
                                else
                                {
                                    // ݳؽӱжϽͨߣ
                                    List<Grp_CarTouristGuideGroundReservations> ListCar = listctg.FindAll(c => Convert.ToDateTime(c.ServiceStartTime) <= Convert.ToDateTime(timeList[i])
                                                                                                        && Convert.ToDateTime(c.ServiceEndTime) >= Convert.ToDateTime(timeList[i]));
                                    //ͨߣ
                                    if (ListCar.Count > 0)
                                    {
                                        tlTemp.Traffic_First = "";

                                        //ͨߣɻ
                                        if (airSign == true)
                                        {
                                            tlTemp.Traffic_Second = "ɻ";
                                        }
                                        else
                                        {
                                            tlTemp.Traffic_Second = "";
                                        }
                                    }
                                    else
                                    {
                                        tlTemp.Traffic_First = "";

                                        //ͨߣɻ
                                        if (airSign == true)
                                        {
                                            tlTemp.Traffic_Second = "ɻ";
                                        }
                                        else
                                        {
                                            tlTemp.Traffic_Second = "";
                                        }
                                    }


                                }
                                #endregion

                                tlTemp.Trip = trip;

                                tlTemp.CreateUserId = di.Id;
                                tlTemp.CreateTime = GetBeijingTime();
                                tlTemp.Issel = 1;
                                tlTemp.Diffgroup = 1;
                                tlTemp.IsDel = 0;

                                AddTravelList(tlTemp);
                            }

                        }
                        else if (timeList.Count < listTravel.Count)//2İ<ԭ
                        {
                            //2.1滻
                            for (int i = 0; i < timeList.Count; i++)
                            {

                                //ת
                                string weekday = weekdays[(int)new DateTime(
                                   Convert.ToInt32(timeList[i].Split('-')[0]),
                                   Convert.ToInt32(timeList[i].Split('-')[1]),
                                   Convert.ToInt32(timeList[i].Split('-')[2])).DayOfWeek];

                                //ȥ0
                                string monthStr = "Unknown", dayStr = "Unknown";

                                if (!string.IsNullOrEmpty(timeList[i]))
                                {
                                    DateTime dateTime = new DateTime();
                                    bool convertResult = DateTime.TryParse(timeList[i], out dateTime);
                                    if (convertResult)
                                    {
                                        monthStr = dateTime.Month.ToString();
                                        dayStr = dateTime.Day.ToString();
                                    }
                                }

                                //
                                listTravel[i].Date = monthStr + "" + dayStr + "";

                                //listTravel[i].Date = timeList[i].Substring(5, 2) + "" + timeList[i].Substring(8, 2) + "";
                                listTravel[i].WeekDay = weekday;


                                listTravel[i].CreateUserId = UserId;
                                listTravel[i].CreateTime = GetBeijingTime();
                                listTravel[i].IsDel = 0;
                                EditTravelList(listTravel[i]);
                            }

                            //2.2ɾг
                            DelOld(comb_Diid, listTravel[timeList.Count - 1].Id, listTravel[listTravel.Count - 1].Id);
                        }
                        else//3İ=ԭ
                        {
                            //3.1滻
                            for (int i = 0; i < timeList.Count; i++)
                            {
                                //ȥ0
                                string monthStr = "Unknown", dayStr = "Unknown";

                                if (!string.IsNullOrEmpty(timeList[i]))
                                {
                                    DateTime dateTime = new DateTime();
                                    bool convertResult = DateTime.TryParse(timeList[i], out dateTime);
                                    if (convertResult)
                                    {
                                        monthStr = dateTime.Month.ToString();
                                        dayStr = dateTime.Day.ToString();
                                    }
                                }

                                //
                                listTravel[i].Date = monthStr + "" + dayStr + "";

                                //ת
                                string weekday = weekdays[(int)new DateTime(
                                   Convert.ToInt32(timeList[i].Split('-')[0]),
                                   Convert.ToInt32(timeList[i].Split('-')[1]),
                                   Convert.ToInt32(timeList[i].Split('-')[2])).DayOfWeek];
                                listTravel[i].WeekDay = weekday;

                                listTravel[i].CreateUserId = UserId;
                                listTravel[i].CreateTime = GetBeijingTime();
                                listTravel[i].IsDel = 0;
                                EditTravelList(listTravel[i]);
                            }
                        }
                    }
                    else //Ųг̣г̡ ƱƵꡢؽӵ
                    {
                        //űʶ
                        //string flightcode_Sign = "";
                        //ʶ
                        //string citycode_Sign = "";

                        #region  20210823 
                        List<CityInDate> CityInDateList = GetCityByDataTable(dt);
                        #endregion

                        //г
                        for (int i = 0; i < timeList.Count; i++)
                        {
                            //ʵһtemp
                            Grp_TravelList tlTemp = new Grp_TravelList();

                            //ź
                            tlTemp.Diid = di.Id;
                            //
                            tlTemp.Days = i + 1;

                            //ȥ0

                            var datetime1 = timeList[i];
                            string monthStr = "Unknown", dayStr = "Unknown";

                            if (!string.IsNullOrEmpty(datetime1))
                            {
                                DateTime dateTime = new DateTime();
                                bool convertResult = DateTime.TryParse(datetime1, out dateTime);
                                if (convertResult)
                                {
                                    monthStr = dateTime.Month.ToString();
                                    dayStr = dateTime.Day.ToString();
                                }
                            }

                            //
                            tlTemp.Date = monthStr + "" + dayStr + "";
                            //
                            //tlTemp.Date = timeList[i].Substring(5, 2) + "" + timeList[i].Substring(8, 2) + "";

                            //ת
                            string weekday = weekdays[(int)new DateTime(
                               Convert.ToInt32(timeList[i].Split('-')[0]),
                               Convert.ToInt32(timeList[i].Split('-')[1]),
                               Convert.ToInt32(timeList[i].Split('-')[2])).DayOfWeek];
                            tlTemp.WeekDay = weekday;


                            //г
                            string trip = "";
                            //
                            string city = "";


                            #region  Ʊ

                            //ݺϢƳִλϢ
                            string AirPort = "";

                            //ݺʱǰƽ뿪ʱ
                            string GoAirportTime = "", leaveAirPortTime = "";

                            //ɻʶ
                            bool airSign = false;

                            //ѯµĺϢ
                            //resultRowsֶ˳Ϊ,,,ʱ,ʱ,վ¥,ﺽվ¥,,ʱ,,ĵ
                            DataRow[] resultRows = dt.Select("Day like '%" + timeList[i] + "%'");

                            if (resultRows.Count() > 0)
                            {
                                //޸ıʶ
                                airSign = true;
                            }

                            //ͬһֻһж
                            if (resultRows.Count() == 1)
                            {

                                #region 

                                string _citycode = resultRows[0]["Three"].ToString();

                                //ɳ
                                Res_ThreeCode font_threecode = null;
                                string font_citycode = _citycode.Replace("/", string.Empty).Substring(0, 3);
                                //ִ
                                string font_City = "";
                                //ɳл
                                string font_Airport = "";

                                //ִ
                                Res_ThreeCode back_threecode = null;
                                string end_citycode = _citycode.Replace("/", string.Empty).Substring(3, 3);
                                //ִл
                                string back_Airport = "";
                                //ִ
                                string back_City = "";




                                font_threecode = getByThree(font_citycode);
                                //֤Ƿ
                                if (font_threecode == null)
                                {
                                    city = city + "" + font_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                    font_Airport = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                    font_City = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                }
                                else
                                {
                                    city = city + "/" + font_threecode.City;
                                    font_Airport = font_threecode.AirPort;
                                    font_City = font_threecode.City; ;
                                }
                                back_threecode = getByThree(end_citycode);
                                if (back_threecode == null)
                                {
                                    city = city + "" + end_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                    back_Airport = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                    back_City = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                }
                                else
                                {
                                    city = city + "/" + back_threecode.City;
                                    //ֻȲңҪѴ
                                    string result = GetCountryInfo(back_threecode.Country);
                                    if (result.Contains("3"))
                                    {
                                        city += "˵ΪȲע磩";
                                    }
                                    back_Airport = back_threecode.AirPort;
                                    back_City = back_threecode.City;
                                    //ѯƵ·Ҫ
                                    AirPort = back_threecode.AirPort;
                                }
                                //г
                                #endregion

                                #region Ϣ׼

                                trip = city.TrimStart('/');
                                //ɺվ¥
                                string _StartBuilding = resultRows[0]["StartBuilding"].ToString();
                                //תվ¥
                                string _EndBuilding = resultRows[0]["EndBuilding"].ToString();
                                //ʱ
                                string _startTime = resultRows[0]["StartTime"].ToString();
                                //ʱ
                                string _flightTime = resultRows[0]["FlightTime"].ToString();
                                _flightTime = _flightTime.Contains("H") ? _flightTime.Split('H')[0] + "Сʱ" + _flightTime.Split('H')[1].Split('M')[0] + "" : _flightTime.Split('M')[0] + "";
                                //ʱ
                                string _endTime = resultRows[0]["EndTime"].ToString();

                                //
                                string _flightcode = resultRows[0]["Fliagtcode"].ToString();
                                //˾
                                Res_AirCompany aircompany = getByShortCode(_flightcode.Substring(0, 2));
                                string _aircompany_Name = "";
                                if (aircompany == null)
                                {
                                    _aircompany_Name = "˺˾" + resultRows[0]["Fliagtcode"].ToString().Substring(0, 2) + "δ¼Ʊͬ¼롿";
                                }
                                else
                                {
                                    _aircompany_Name = aircompany.CnName;
                                }



                                //ж
                                string airModel = resultRows[0]["AirModel"].ToString();

                                airModel = GetLonger(airModel.Substring(0, 1)) + airModel;
                                #endregion

                                #region trip༭
                                //еִʱ"+1",Ϊĸ,ʾǻ
                                if (resultRows[0]["Sign"].ToString() == "0" && _endTime.Contains("+"))
                                {
                                    //ݺϢʱ                               
                                    int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰСʱ
                                    string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰСʱ
                                    if (result.Contains("2"))
                                    {
                                        temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                    }
                                    if (temp < 0)
                                    {
                                        temp = temp + 24;
                                    }
                                    GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                    GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                    //һ֮г̿ԼϡƵľʱ
                                    if (i > 0)
                                    {
                                        #region Ƶ      
                                        foreach (var h in listht)
                                        {
                                            if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                             && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                            {
                                                //ùȸAPI·
                                                if (AirPort != "")
                                                {
                                                    GoogleMapApiResult g = null;

                                                    if (g != null)
                                                    {
                                                        //㡰Ƶ굽ʱ
                                                        string CheckoutHotelTime;

                                                        //ʱʽ
                                                        string hours = "", mins = "";
                                                        if (g.Time.Contains("hour"))
                                                        {
                                                            g.Time = g.Time.Replace("hour", "h");

                                                        }
                                                        else if (g.Time.Contains("hours"))
                                                        {
                                                            g.Time = g.Time.Replace("hours", "h");
                                                        }

                                                        g.Time = g.Time.Replace("mins", "m");
                                                        if (g.Time.Contains("h"))
                                                        {
                                                            hours = g.Time.Split('h')[0].Trim();

                                                        }
                                                        else if (!g.Time.Contains("h"))
                                                        {
                                                            mins = g.Time.Split('m')[0].Trim();
                                                        }

                                                        int hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                        int min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                        min = min - Convert.ToInt32(mins);
                                                        if (min < 0)
                                                        {
                                                            min = min + 60;
                                                            hour = hour - 1;
                                                        }
                                                        if (hours != "")
                                                        {
                                                            hour = hour - Convert.ToInt32(hours);
                                                        }
                                                        if (hour < 0)
                                                        {
                                                            hour = hour + 24;
                                                        }

                                                        CheckoutHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                        CheckoutHotelTime = CheckoutHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                        trip = trip + "\r\n"
                                                                    + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                    }
                                                    else
                                                    {
                                                        try
                                                        {
                                                            JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                            //㡰ִƵסʱ
                                                            string CheckoutHotelTime;

                                                            //ʱʽ
                                                            string Gtime = "", hours = "", mins = "";
                                                            if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                            {
                                                                Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                            }
                                                            else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                            {
                                                                Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                            }
                                                            Gtime = Gtime.Replace("mins", "m");

                                                            if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                            {
                                                                hours = Gtime.Split('h')[0].Trim();

                                                            }
                                                            else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                            {
                                                                mins = Gtime.Split('m')[0].Trim();
                                                            }


                                                            int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                            int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                            min = min - Convert.ToInt32(mins);
                                                            if (min < 0)
                                                            {
                                                                min = min + 60;
                                                                hour = hour - 1;
                                                            }

                                                            if (hours != "")
                                                            {
                                                                hour = hour + Convert.ToInt32(hours);
                                                            }
                                                            if (hour < 0)
                                                            {
                                                                hour = hour + 24;
                                                            }
                                                            CheckoutHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                            CheckoutHotelTime = CheckoutHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                            trip = trip + "\r\n"
                                                                        + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                            GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                            gtemp.Diid = di.Id;
                                                            gtemp.Date = "";
                                                            gtemp.Moment = "";
                                                            gtemp.StartAddress = AirPort;
                                                            gtemp.EndAddress = h.HotelAddress;
                                                            gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                            gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                            //gmrs.Add(gtemp);

                                                        }
                                                        catch
                                                        {
                                                            trip = trip + "\r\n"
                                                                 + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        #endregion
                                    }

                                    //г
                                    trip = trip
                                         + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                         + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                         + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + "";

                                    //ǱΪĸ
                                    //flightcode_Sign = resultRows[0]["Fliagtcode"].ToString();
                                    //citycode_Sign = resultRows[0]["Three"].ToString();
                                }
                                //ǰһк,ͬұеִʱ䲻"+1"Ǳɵظ,ʾִ
                                else if (resultRows[0]["Sign"].ToString() == "1") /* && (!_endTime.Contains("+"))&&(_flightcode == flightcode_Sign)&&(_citycode == citycode_Sign)*/
                                {

                                    //г
                                    trip = trip
                                         + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                    //ݺϢ뿪ʱ
                                    int temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                    leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                    leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                    if (i == timeList.Count - 1)//г̵һ죬ѡгԲ 
                                    {
                                        trip = trip + "Բ˴η֮У";
                                    }
                                    else //ղг̵һ죬
                                    {
                                        trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                        trip = trip + "\r\n" + leaveAirPortTime + "רǰƵִ꣬ס";
                                    }

                                    //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                    int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                    int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                    min = min + 10;
                                    if (min > 59)
                                    {
                                        min = min - 60;
                                        hour = hour + 1;
                                    }
                                    if (hour > 23)
                                    {
                                        hour = hour - 24;
                                    }
                                    leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                    leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                }
                                //ʾ
                                else
                                {
                                    //ݺϢʱ
                                    int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰ2Сʱ
                                    string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰ3Сʱ
                                    if (result.Contains("2"))
                                    {
                                        temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                    }
                                    if (temp < 0)
                                    {
                                        temp = temp + 24;
                                    }
                                    GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                    GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                    //ݺϢ뿪ʱ
                                    temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                    leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                    leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                    //һ֮г̿ԼϡƵľʱ
                                    if (i > 0)
                                    {
                                        #region Ƶ      
                                        foreach (var h in listht)
                                        {
                                            if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                             && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                            {
                                                //ùȸAPI·
                                                if (AirPort != "")
                                                {
                                                    GoogleMapApiResult g = null;

                                                    if (g != null)
                                                    {
                                                        //㡰Ƶ굽ʱ
                                                        string CheckoutHotelTime;

                                                        //ʱʽ
                                                        string hours = "0", mins = "0";
                                                        if (g.Time.Contains("hour"))
                                                        {
                                                            g.Time = g.Time.Replace("hour", "h");

                                                        }
                                                        else if (g.Time.Contains("hours"))
                                                        {
                                                            g.Time = g.Time.Replace("hours", "h");
                                                        }

                                                        g.Time = g.Time.Replace("mins", "m");
                                                        if (g.Time.Contains("h"))
                                                        {
                                                            hours = g.Time.Split('h')[0].Trim();

                                                        }
                                                        else if (!g.Time.Contains("h"))
                                                        {
                                                            mins = g.Time.Split('m')[0].Trim();
                                                        }

                                                        int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                        int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                        _min = _min - Convert.ToInt32(mins);
                                                        if (_min < 0)
                                                        {
                                                            _min = _min + 60;
                                                            _hour = _hour - 1;
                                                        }
                                                        if (hours != "")
                                                        {
                                                            _hour = _hour - Convert.ToInt32(hours);
                                                        }
                                                        if (_hour < 0)
                                                        {
                                                            _hour = _hour + 24;
                                                        }

                                                        CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                        CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                        trip = trip + "\r\n"
                                                                    + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                    }
                                                    else
                                                    {
                                                        try
                                                        {
                                                            JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                            //㡰ִƵסʱ
                                                            string CheckoutHotelTime;

                                                            //ʱʽ
                                                            string Gtime = "", hours = "0", mins = "0";
                                                            if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                            {
                                                                Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                            }
                                                            else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                            {
                                                                Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                            }
                                                            Gtime = Gtime.Replace("mins", "m");

                                                            if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                            {
                                                                hours = Gtime.Split('h')[0].Trim();

                                                            }
                                                            else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                            {
                                                                mins = Gtime.Split('m')[0].Trim();
                                                            }


                                                            int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                            int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                            _min = _min - Convert.ToInt32(mins);
                                                            if (_min < 0)
                                                            {
                                                                _min = _min + 60;
                                                                _hour = _hour - 1;
                                                            }

                                                            if (hours != "")
                                                            {
                                                                _hour = _hour + Convert.ToInt32(hours);
                                                            }
                                                            if (_hour < 0)
                                                            {
                                                                _hour = _hour + 24;
                                                            }
                                                            CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                            CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());



                                                            GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                            gtemp.Diid = di.Id;
                                                            gtemp.Date = "";
                                                            gtemp.Moment = "";
                                                            gtemp.StartAddress = AirPort;
                                                            gtemp.EndAddress = h.HotelAddress;
                                                            gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                            gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                            //gmrs.Add(gtemp);

                                                            trip = trip + "\r\n"
                                                                      + CheckoutHotelTime + " ˳ǰ:" + gtemp.Distance + "" + gtemp.Time + "";
                                                        }
                                                        catch
                                                        {
                                                            trip = trip + "\r\n"
                                                                 + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        #endregion
                                    }

                                    trip = trip
                                         + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                         + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                         + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                         + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";



                                    if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                    {
                                        trip = trip + "Բ˴η֮У";
                                    }
                                    else //ղг̵һ죬
                                    {
                                        trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                        trip = trip + "\r\n" + leaveAirPortTime + " רǰƵִ꣬ס";
                                    }

                                    //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                    int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                    int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                    min = min + 10;
                                    if (min > 59)
                                    {
                                        min = min - 60;
                                        hour = hour + 1;
                                    }
                                    if (hour > 23)
                                    {
                                        hour = hour - 24;
                                    }
                                    leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                    leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                }
                                #endregion

                            }
                            //ͬһ߷
                            else
                            {
                                for (int n = 0; n < resultRows.Count(); n++)
                                {
                                    city = "";

                                    #region 

                                    string _citycode = resultRows[n]["Three"].ToString();

                                    //ɳ
                                    Res_ThreeCode font_threecode = null;
                                    string font_citycode = _citycode.Replace("/", string.Empty).Substring(0, 3);
                                    //ִ
                                    string font_City = "";
                                    //ɳл
                                    string font_Airport = "";

                                    //ִ
                                    Res_ThreeCode back_threecode = null;
                                    string end_citycode = _citycode.Replace("/", string.Empty).Substring(3, 3);
                                    //ִл
                                    string back_Airport = "";
                                    //ִ
                                    string back_City = "";


                                    font_threecode = getByThree(font_citycode);
                                    //֤Ƿ
                                    if (font_threecode == null)
                                    {
                                        city = city + "" + font_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                        font_Airport = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                        font_City = "" + font_citycode + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        city = city + "/" + font_threecode.City;
                                        font_Airport = font_threecode.AirPort;
                                        font_City = font_threecode.City; ;
                                    }
                                    back_threecode = getByThree(end_citycode);
                                    if (back_threecode == null)
                                    {
                                        city = city + "" + end_citycode + "δ¼Ʊͬ¼롿" + "һ";
                                        back_Airport = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                        back_City = "" + end_citycode + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        city = city + "/" + back_threecode.City;
                                        //ֻȲңҪѴ
                                        string result = GetCountryInfo(back_threecode.Country);
                                        if (result.Contains("3"))
                                        {
                                            city += "˵ΪȲע磩";
                                        }
                                        back_Airport = back_threecode.AirPort;
                                        back_City = back_threecode.City;
                                        //ѯƵ·Ҫ
                                        AirPort = back_threecode.AirPort;
                                    }
                                    //г
                                    if (trip == "")
                                    {
                                        trip = city.TrimStart('/');
                                    }
                                    else
                                    {
                                        trip = trip + "\r\n"
                                             + city.TrimStart('/');
                                    }
                                    //ɺվ¥
                                    string _StartBuilding = resultRows[n]["StartBuilding"].ToString();
                                    //תվ¥
                                    string _EndBuilding = resultRows[n]["EndBuilding"].ToString();
                                    //ʱ
                                    string _startTime = resultRows[n]["StartTime"].ToString();
                                    //ʱ
                                    string _flightTime = resultRows[n]["FlightTime"].ToString();
                                    _flightTime = _flightTime.Contains("H") ? _flightTime.Split('H')[0] + "Сʱ" + _flightTime.Split('H')[1].Split('M')[0] + "" : _flightTime.Split('M')[0] + "";
                                    //ʱ
                                    string _endTime = resultRows[n]["EndTime"].ToString();

                                    //
                                    string _flightcode = resultRows[n]["Fliagtcode"].ToString();
                                    //˾
                                    Res_AirCompany aircompany = getByShortCode(_flightcode.Substring(0, 2));
                                    string _aircompany_Name = "";
                                    if (aircompany == null)
                                    {
                                        _aircompany_Name = "˺˾" + resultRows[n]["Fliagtcode"].ToString().Substring(0, 2) + "δ¼Ʊͬ¼롿";
                                    }
                                    else
                                    {
                                        _aircompany_Name = aircompany.CnName;
                                    }



                                    //ж
                                    string airModel = resultRows[n]["AirModel"].ToString();

                                    airModel = GetLonger(airModel.Substring(0, 1)) + airModel;
                                    #endregion

                                    //SignֶΪʶstringͣ壺0ʾΪԭ롢1ʾ+1ĺ
                                    //ĿǰͬһĶݱʶΪ0->01->0
                                    //ʾ
                                    //Day ArrivedDate Sign
                                    //10      10       0
                                    //10      11       0
                                    //11      11       1
                                    //11      12       0
                                    //12      12       1
                                    if (n == 0)
                                    {
                                        //ԭƱ
                                        if (resultRows[n]["Sign"].ToString() == "0")
                                        {
                                            #region trip༭
                                            //ݺϢʱ
                                            int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰСʱ
                                            string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰСʱ
                                            if (result.Contains("2"))
                                            {
                                                temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                            }
                                            if (temp < 0)
                                            {
                                                temp = temp + 24;
                                            }
                                            GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                            GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);


                                            //һ֮г̿ԼϡƵľʱ
                                            if (i > 0)
                                            {
                                                #region Ƶ      
                                                foreach (var h in listht)
                                                {
                                                    if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                     && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                                    {
                                                        //ùȸAPI·
                                                        if (AirPort != "")
                                                        {
                                                            GoogleMapApiResult g = null;

                                                            if (g != null)
                                                            {
                                                                //㡰Ƶ굽ʱ
                                                                string CheckoutHotelTime;

                                                                //ʱʽ
                                                                string hours = "0", mins = "0";
                                                                if (g.Time.Contains("hour"))
                                                                {
                                                                    g.Time = g.Time.Replace("hour", "h");

                                                                }
                                                                else if (g.Time.Contains("hours"))
                                                                {
                                                                    g.Time = g.Time.Replace("hours", "h");
                                                                }

                                                                g.Time = g.Time.Replace("mins", "m");
                                                                if (g.Time.Contains("h"))
                                                                {
                                                                    hours = g.Time.Split('h')[0].Trim();

                                                                }
                                                                else if (!g.Time.Contains("h"))
                                                                {
                                                                    mins = g.Time.Split('m')[0].Trim();
                                                                }

                                                                int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                                int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                                _min = _min - Convert.ToInt32(mins);
                                                                if (_min < 0)
                                                                {
                                                                    _min = _min + 60;
                                                                    _hour = _hour - 1;
                                                                }
                                                                if (hours != "")
                                                                {
                                                                    _hour = _hour - Convert.ToInt32(hours);
                                                                }
                                                                if (_hour < 0)
                                                                {
                                                                    _hour = _hour + 24;
                                                                }

                                                                CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                trip = trip + "\r\n"
                                                                            + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                            }
                                                            else
                                                            {
                                                                try
                                                                {
                                                                    JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                    //㡰ִƵסʱ
                                                                    string CheckoutHotelTime;

                                                                    //ʱʽ
                                                                    string Gtime = "", hours = "0", mins = "0";
                                                                    if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                    {
                                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                    }
                                                                    else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                    {
                                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                    }
                                                                    Gtime = Gtime.Replace("mins", "m");

                                                                    if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                    {
                                                                        hours = Gtime.Split('h')[0].Trim();

                                                                    }
                                                                    else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                    {
                                                                        mins = Gtime.Split('m')[0].Trim();
                                                                    }


                                                                    int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                    int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                    _min = _min - Convert.ToInt32(mins);
                                                                    if (_min < 0)
                                                                    {
                                                                        _min = _min + 60;
                                                                        _hour = _hour - 1;
                                                                    }

                                                                    if (hours != "")
                                                                    {
                                                                        _hour = _hour + Convert.ToInt32(hours);
                                                                    }
                                                                    if (_hour < 0)
                                                                    {
                                                                        _hour = _hour + 24;
                                                                    }
                                                                    CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                    CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                    trip = trip + "\r\n"
                                                                                + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                    GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                    gtemp.Diid = di.Id;
                                                                    gtemp.Date = "";
                                                                    gtemp.Moment = "";
                                                                    gtemp.StartAddress = AirPort;
                                                                    gtemp.EndAddress = h.HotelAddress;
                                                                    gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                    gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                    //gmrs.Add(gtemp);

                                                                }
                                                                catch
                                                                {
                                                                    trip = trip + "\r\n"
                                                                         + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                #endregion
                                            }

                                            trip = trip
                                                 + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                                 + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                                 + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                                 + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,ȡ";

                                            #endregion
                                        }
                                        //"+1"ɵĻƱ
                                        else if (resultRows[n]["Sign"].ToString() == "1")
                                        {
                                            #region trip༭
                                            //г
                                            trip = trip
                                                 + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,ȡ";
                                            #endregion
                                        }
                                    }
                                    else if (n > 0)
                                    {
                                        //ǰԭģжΪת
                                        if (resultRows[n - 1]["Sign"].ToString() == "0")
                                        {
                                            #region trip༭
                                            int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 1;//һǰǰ2Сʱ
                                            if (temp < 0)
                                            {
                                                temp = temp + 24;
                                            }
                                            GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                            GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                            trip = trip
                                             + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                             + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                             + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                             + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                            //ΪһУ󱸵ʱ
                                            if (n == resultRows.Count() - 1)
                                            {
                                                //ݺϢ뿪ʱ
                                                temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                                leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                                leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                                if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                                {
                                                    trip = trip + "Բ˴η֮У";
                                                }
                                                else //ղг̵һ죬
                                                {
                                                    trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                                    trip = trip + "\r\n" + leaveAirPortTime + "רǰƵִ꣬ס";
                                                }

                                                //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                                int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                                min = min + 10;
                                                if (min > 59)
                                                {
                                                    min = min - 60;
                                                    hour = hour + 1;
                                                }
                                                if (hour > 23)
                                                {
                                                    hour = hour - 24;
                                                }
                                                leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                            }
                                            #endregion
                                        }
                                        //ǰɵģжΪ³
                                        else if (resultRows[n - 1]["Sign"].ToString() == "1")
                                        {
                                            #region trip༭
                                            //ݺϢʱ
                                            int temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 2;//һǰǰ2Сʱ
                                            string result = GetCountryInfo(back_threecode.Country);//ŷ޹ǰ3Сʱ
                                            if (result.Contains("2"))
                                            {
                                                temp = Convert.ToInt32(_startTime.Substring(0, 2)) - 3;//ǰ3Сʱ
                                            }
                                            if (temp < 0)
                                            {
                                                temp = temp + 24;
                                            }
                                            GoAirportTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                            GoAirportTime = GoAirportTime + ":" + _startTime.Substring(2, _startTime.Length - 2);

                                            //ݺϢ뿪ʱ
                                            temp = Convert.ToInt32(_endTime.Substring(0, 2)) + 1;
                                            leaveAirPortTime = temp < 10 ? "0" + temp.ToString() : temp.ToString();
                                            leaveAirPortTime = leaveAirPortTime + ":" + _endTime.Substring(2, _endTime.Length - 2);

                                            //һ֮г̿ԼϡƵľʱ
                                            if (i > 0)
                                            {
                                                #region Ƶ      
                                                foreach (var h in listht)
                                                {
                                                    if (Convert.ToDateTime(h.CheckInDate) < Convert.ToDateTime(timeList[i])
                                                     && Convert.ToDateTime(h.CheckOutDate) >= Convert.ToDateTime(timeList[i]))
                                                    {
                                                        //ùȸAPI·
                                                        if (AirPort != "")
                                                        {
                                                            GoogleMapApiResult g = null;

                                                            if (g != null)
                                                            {
                                                                //㡰Ƶ굽ʱ
                                                                string CheckoutHotelTime;

                                                                //ʱʽ
                                                                string hours = "0", mins = "0";
                                                                if (g.Time.Contains("hour"))
                                                                {
                                                                    g.Time = g.Time.Replace("hour", "h");

                                                                }
                                                                else if (g.Time.Contains("hours"))
                                                                {
                                                                    g.Time = g.Time.Replace("hours", "h");
                                                                }

                                                                g.Time = g.Time.Replace("mins", "m");
                                                                if (g.Time.Contains("h"))
                                                                {
                                                                    hours = g.Time.Split('h')[0].Trim();

                                                                }
                                                                else if (!g.Time.Contains("h"))
                                                                {
                                                                    mins = g.Time.Split('m')[0].Trim();
                                                                }

                                                                int _hour = Convert.ToInt32(GoAirportTime.Substring(0, 2));
                                                                int _min = Convert.ToInt32(GoAirportTime.Substring(3, 2));

                                                                _min = _min - Convert.ToInt32(mins);
                                                                if (_min < 0)
                                                                {
                                                                    _min = _min + 60;
                                                                    _hour = _hour - 1;
                                                                }
                                                                if (hours != "")
                                                                {
                                                                    _hour = _hour - Convert.ToInt32(hours);
                                                                }
                                                                if (_hour < 0)
                                                                {
                                                                    _hour = _hour + 24;
                                                                }

                                                                CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                trip = trip + "\r\n"
                                                                            + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";
                                                            }
                                                            else
                                                            {
                                                                try
                                                                {
                                                                    JObject Result = GetDirectionByGoogleApi(h.HotelAddress, font_Airport);

                                                                    //㡰ִƵסʱ
                                                                    string CheckoutHotelTime;

                                                                    //ʱʽ
                                                                    string Gtime = "", hours = "0", mins = "0";
                                                                    if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                                    {
                                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                                    }
                                                                    else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                                    {
                                                                        Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                                    }
                                                                    Gtime = Gtime.Replace("mins", "m");

                                                                    if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                                    {
                                                                        hours = Gtime.Split('h')[0].Trim();

                                                                    }
                                                                    else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                                    {
                                                                        mins = Gtime.Split('m')[0].Trim();
                                                                    }


                                                                    int _hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                                    int _min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                                    _min = _min - Convert.ToInt32(mins);
                                                                    if (_min < 0)
                                                                    {
                                                                        _min = _min + 60;
                                                                        _hour = _hour - 1;
                                                                    }

                                                                    if (hours != "")
                                                                    {
                                                                        _hour = _hour + Convert.ToInt32(hours);
                                                                    }
                                                                    if (_hour < 0)
                                                                    {
                                                                        _hour = _hour + 24;
                                                                    }
                                                                    CheckoutHotelTime = _hour < 10 ? "0" + _hour.ToString() : _hour.ToString();
                                                                    CheckoutHotelTime = CheckoutHotelTime + ":" + (_min < 10 ? "0" + _min.ToString() : _min.ToString());

                                                                    trip = trip + "\r\n"
                                                                                + CheckoutHotelTime + " ˳ǰ:" + g.Distance + "" + g.Time + "";

                                                                    GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                                    gtemp.Diid = di.Id;
                                                                    gtemp.Date = "";
                                                                    gtemp.Moment = "";
                                                                    gtemp.StartAddress = AirPort;
                                                                    gtemp.EndAddress = h.HotelAddress;
                                                                    gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                                    gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                                    //gmrs.Add(gtemp);

                                                                }
                                                                catch
                                                                {
                                                                    trip = trip + "\r\n"
                                                                         + "          ˳ǰ:ȸӿ쳣޷·ʱ䣩";
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                #endregion
                                            }

                                            trip = trip
                                                 + "\r\n" + GoAirportTime + " ִ" + font_Airport + _StartBuilding + "վ¥,ǻ"
                                                 + "\r\n" + _startTime.Substring(0, 2) + ":" + _startTime.Substring(2, _startTime.Length - 2) + " " + _aircompany_Name + "չ˾" + _flightcode + "࣬" + font_City + "" + back_City + ""
                                                 + "\r\n" + "       " + font_Airport + "/" + back_Airport + "  ͣ" + airModel + "    ʱ" + (_flightTime) + ""
                                                 + "\r\n" + _endTime.Substring(0, 2) + ":" + _endTime.Substring(2, _endTime.Length - 2) + " ִ" + back_Airport + _EndBuilding + "վ¥,뾳֮ǰȡ";

                                            if (i == timeList.Count - 1)//г̵һ죬ӾƵ굽ľʱ䣬ĩβѡгԲ 
                                            {
                                                trip = trip + "Բ˴η֮У";
                                            }
                                            else //ղг̵һ죬
                                            {
                                                trip += pushTrip(leaveAirPortTime, back_Airport, city, out leaveAirPortTime);
                                                trip = trip + "\r\n" + leaveAirPortTime + " רǰƵִ꣬ס";
                                            }

                                            //뿪ʱ +10Ϊ"˳ǰƵ"ʱ
                                            int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                            int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));
                                            min = min + 10;
                                            if (min > 59)
                                            {
                                                min = min - 60;
                                                hour = hour + 1;
                                            }
                                            if (hour > 23)
                                            {
                                                hour = hour - 24;
                                            }
                                            leaveAirPortTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                            leaveAirPortTime = leaveAirPortTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());
                                            #endregion
                                        }

                                    }
                                }
                            }



                            #endregion


                            #region г̺ͳиֵ
                            if (trip == "" || trip == " " || city == "" || city == " ")
                            {
                                city = CityInDateList.Find(cid => cid.Date == timeList[i]).City;
                                //ֻȲңҪѴ
                                string result = GetCountryInfo(getByCity(city)[0].Country);
                                if (result.Contains("3"))
                                {
                                    city += "˵ΪȲע磩";
                                }
                                trip = city;
                            }
                            #endregion


                            #region   20210820 
                            string OATemp = "";//ݴ湫

                            //źźڻȡ
                            List<Res_OfficialActivities> listoa = getByDiidAndDate(comb_Diid, timeList[i]);

                            //listoaڹݣٽе
                            if (listoa != null && listoa.Count > 0)
                            {
                                //datatableŹ
                                DataTable OA_DataTable = new DataTable();
                                OA_DataTable.Columns.Add("StartTime", typeof(string)); //activityʼʱ
                                OA_DataTable.Columns.Add("EndTime", typeof(string)); //activityʱ
                                OA_DataTable.Columns.Add("Client", typeof(string)); //activityλ
                                OA_DataTable.Columns.Add("Address", typeof(string)); //activityַ
                                OA_DataTable.Columns.Add("Contact", typeof(string)); //activityϵ
                                OA_DataTable.Columns.Add("Tel", typeof(string)); //activityϵ˵绰
                                OA_DataTable.Columns.Add("Dresscode", typeof(string)); //activityװҪ
                                OA_DataTable.Columns.Add("isTranslate", typeof(bool));//ǷҪԱ
                                OA_DataTable.Columns.Add("Language", typeof(string));//ǷҪԱ
                                //
                                for (int b = 0; b < listoa.Count; b++)
                                {
                                    //ֹʱ
                                    string[] time = new string[2];
                                    if (listoa[b].Time.Contains(''))
                                    {
                                        time = listoa[b].Time.Split('');
                                    }
                                    else if (listoa[b].Time.Contains('-'))
                                    {
                                        time = listoa[b].Time.Split('-');
                                    }

                                    //
                                    if (time.Length >= 2)
                                    {
                                        OA_DataTable.Rows.Add(time[0], time[1], listoa[b].Client, listoa[b].Address, listoa[b].Contact, listoa[b].Tel, listoa[b].Dresscode, listoa[b].IsNeedTrans, listoa[b].language);
                                    }
                                    else
                                    {
                                        //PublicCode.GetAlertMsg(this, GetType(), timeList[i] + "Ĺ");
                                    }

                                }
                                //
                                OA_DataTable.DefaultView.Sort = "StartTime asc";
                                OA_DataTable = OA_DataTable.DefaultView.ToTable();


                                //Ϣ
                                for (int index = 0; index < OA_DataTable.Rows.Count; index++)
                                {
                                    if (i == 0)//г̵һĹھƵ棬ݴһ
                                    {
                                        if (OATemp != "")
                                        {
                                            OATemp = OATemp + "\r\n"
                                                     + OA_DataTable.Rows[index]["StartTime"].ToString()
                                                     + "-"
                                                     + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                        }
                                        else
                                        {
                                            OATemp = OA_DataTable.Rows[index]["StartTime"].ToString()
                                                     + "-"
                                                     + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                        }
                                    }
                                    else
                                    {
                                        //빫
                                        trip = trip + "\r\n"
                                                    + OA_DataTable.Rows[index]["StartTime"].ToString()
                                                    + "-"
                                                    + OA_DataTable.Rows[index]["EndTime"].ToString()
                                                         + "  ݷ" + OA_DataTable.Rows[index]["Client"].ToString()
                                                         + "ϵˣ" + OA_DataTable.Rows[index]["Contact"].ToString()
                                                         + "绰" + OA_DataTable.Rows[index]["Tel"].ToString()
                                                         + "ַ" + OA_DataTable.Rows[index]["Address"].ToString()
                                                         + "װҪ" + OA_DataTable.Rows[index]["Dresscode"].ToString()
                                                         + "ǷҪ룺" + (bool.Parse(OA_DataTable.Rows[index]["isTranslate"].ToString()) ? "ҪԱ" + "Ϊ" + OA_DataTable.Rows[index]["Language"].ToString() : "ҪԱ")
                                                         + "⣺-";
                                    }
                                    //һǴӾƵ˿ɼƵ굽ַľʱ
                                    if (index == 0)
                                    {
                                        #region Ƶ
                                        foreach (var h in listht)
                                        {
                                            if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                             && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                            {
                                                //ùȸAPI·
                                                GoogleMapApiResult g = null;
                                                if (g != null)
                                                {
                                                    if (i == 0)//г̵һĹھƵ棬ݴһ
                                                    {
                                                        OATemp = OATemp + "  " + g.Distance + "" + g.Time + "";
                                                    }
                                                    else
                                                    {
                                                        trip = trip + "  " + g.Distance + "" + g.Time + "";
                                                    }

                                                }
                                                else
                                                {
                                                    try
                                                    {
                                                        JObject Result = GetDirectionByGoogleApi(h.HotelAddress, OA_DataTable.Rows[0]["Address"].ToString());

                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                            + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                        + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                        }


                                                        GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                        gtemp.Diid = di.Id;
                                                        gtemp.Date = "";
                                                        gtemp.Moment = "";
                                                        gtemp.StartAddress = h.HotelAddress;
                                                        gtemp.EndAddress = OA_DataTable.Rows[0]["Address"].ToString();
                                                        gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                        gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                        //gmrs.Add(gtemp);
                                                    }
                                                    catch
                                                    {
                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  ȸӿ쳣޷·ʱ䣩";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  ȸӿ쳣޷·ʱ䣩";
                                                        }

                                                    }
                                                }
                                            }
                                        }
                                        #endregion
                                    }
                                    //ڶĲǰַԣ˲˷ʱ䣻ɼɹַؾƵϢ
                                    else
                                    {
                                        #region Ƶ
                                        foreach (var h in listht)
                                        {
                                            if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                             && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))
                                            {
                                                //ùȸAPI·
                                                GoogleMapApiResult g = null;
                                                if (g != null)
                                                {
                                                    if (i == 0)//г̵һĹھƵ棬ݴһ
                                                    {
                                                        OATemp = OATemp + "  " + g.Distance + "" + g.Time + "";
                                                    }
                                                    else
                                                    {
                                                        trip = trip + "  " + g.Distance + "" + g.Time + "";
                                                    }
                                                }
                                                else
                                                {
                                                    try
                                                    {
                                                        JObject Result = GetDirectionByGoogleApi(OA_DataTable.Rows[index]["Address"].ToString(), h.HotelAddress);
                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                            + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  " + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                        + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";
                                                        }

                                                        GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                        gtemp.Diid = di.Id;
                                                        gtemp.Date = "";
                                                        gtemp.Moment = "";
                                                        gtemp.StartAddress = OA_DataTable.Rows[0]["Address"].ToString();
                                                        gtemp.EndAddress = h.HotelAddress;
                                                        gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                        gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                        //gmrs.Add(gtemp);
                                                    }
                                                    catch
                                                    {
                                                        if (i == 0)//г̵һĹھƵ棬ݴһ
                                                        {
                                                            OATemp = OATemp + "  ȸӿ쳣޷·ʱ䣩";
                                                        }
                                                        else
                                                        {
                                                            trip = trip + "  ȸӿ쳣޷·ʱ䣩";
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        #endregion
                                    }
                                }
                            }
                            #endregion


                            #region Ƶ      
                            foreach (var h in listht)
                            {

                                if (Convert.ToDateTime(h.CheckInDate) <= Convert.ToDateTime(timeList[i])
                                 && Convert.ToDateTime(h.CheckOutDate) > Convert.ToDateTime(timeList[i]))//ȥ=ԭгһһ㲻оƵ
                                {
                                    //ùȸAPI·
                                    if (AirPort != "")
                                    {
                                        GoogleMapApiResult g = null;

                                        if (g != null)
                                        {
                                            trip = trip + "\r\n"
                                                + leaveAirPortTime + " ˳ǰƵ:" + g.Distance + "" + g.Time + "";

                                            //㡰ִƵסʱ
                                            string CheckInHotelTime;

                                            //ʱʽ
                                            string hours = "", mins = "";
                                            if (g.Time.Contains("hour"))
                                            {
                                                g.Time = g.Time.Replace("hour", "h");

                                            }
                                            else if (g.Time.Contains("hours"))
                                            {
                                                g.Time = g.Time.Replace("hours", "h");
                                            }

                                            g.Time = g.Time.Replace("mins", "m");
                                            if (g.Time.Contains("h"))
                                            {
                                                hours = g.Time.Split('h')[0].Trim();

                                            }
                                            else if (!g.Time.Contains("h"))
                                            {
                                                mins = g.Time.Split('m')[0].Trim();
                                            }

                                            int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                            int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                            min = min + Convert.ToInt32(mins);
                                            if (min > 59)
                                            {
                                                min = min - 60;
                                                hour = hour + 1;
                                            }
                                            if (hours != "")
                                            {
                                                hour = hour + Convert.ToInt32(hours);
                                            }
                                            if (hour > 23)
                                            {
                                                hour = hour - 24;
                                            }

                                            CheckInHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                            CheckInHotelTime = CheckInHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                            trip = trip + "\r\n"
                                                        + CheckInHotelTime + " ִƵס";
                                        }
                                        else
                                        {
                                            try
                                            {
                                                JObject Result = GetDirectionByGoogleApi(AirPort, h.HotelAddress);

                                                trip = trip + "\r\n"
                                                    + leaveAirPortTime + " ˳ǰƵ:" + Result["routes"][0]["legs"][0]["distance"]["text"].ToString() + ""
                                                                                             + Result["routes"][0]["legs"][0]["duration"]["text"].ToString() + "";

                                                //㡰ִƵסʱ
                                                string CheckInHotelTime;

                                                //ʱʽ
                                                string Gtime = "", hours = "", mins = "";
                                                if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hour"))
                                                {
                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hour", "h");
                                                }
                                                else if (Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Contains("hours"))
                                                {
                                                    Gtime = Result["routes"][0]["legs"][0]["duration"]["text"].ToString().Replace("hours", "h");
                                                }
                                                Gtime = Gtime.Replace("mins", "m");

                                                if (!string.IsNullOrEmpty(Gtime) && Gtime.Contains("h"))
                                                {
                                                    hours = Gtime.Split('h')[0].Trim();

                                                }
                                                else if (!string.IsNullOrEmpty(Gtime) && !Gtime.Contains("h"))
                                                {
                                                    mins = Gtime.Split('m')[0].Trim();
                                                }


                                                int hour = Convert.ToInt32(leaveAirPortTime.Substring(0, 2));
                                                int min = Convert.ToInt32(leaveAirPortTime.Substring(3, 2));

                                                if (mins != "")
                                                    min = min + Convert.ToInt32(mins);

                                                if (min > 59)
                                                {
                                                    min = min - 60;
                                                    hour = hour + 1;
                                                }

                                                if (hours != "")
                                                {
                                                    hour = hour + Convert.ToInt32(hours);
                                                }
                                                if (hour > 23)
                                                {
                                                    hour = hour - 24;
                                                }
                                                CheckInHotelTime = hour < 10 ? "0" + hour.ToString() : hour.ToString();
                                                CheckInHotelTime = CheckInHotelTime + ":" + (min < 10 ? "0" + min.ToString() : min.ToString());

                                                trip = trip + "\r\n"
                                                            + CheckInHotelTime + " ִƵס";

                                                GoogleMapApiResult gtemp = new GoogleMapApiResult();
                                                gtemp.Diid = di.Id;
                                                gtemp.Date = "";
                                                gtemp.Moment = "";
                                                gtemp.StartAddress = AirPort;
                                                gtemp.EndAddress = h.HotelAddress;
                                                gtemp.Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                                                gtemp.Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();
                                                //gmrs.Add(gtemp);

                                            }
                                            catch
                                            {
                                                trip = trip + "\r\n"
                                                     + "          ȸӿ쳣޷·ʱ䣩";
                                            }
                                        }

                                    }

                                    trip = trip + "\r\n"
                                        + "          Ƶƣ" + h.HotelName + "\r\n"
                                        + "          Ƶַ" + h.HotelAddress + "\r\n"
                                        + "          Ƶ绰" + h.HotelTel + "      Ƶ괫棺" + (h.HotelFax == "" ? "-" : h.HotelFax);

                                    if (i == 0 && !string.IsNullOrEmpty(OATemp))
                                    {
                                        trip = trip + "\r\n" + OATemp;
                                    }
                                }
                            }
                            #endregion


                            #region 콻ͨ߸ֵ
                            //һг̵һ춼ȳɻ
                            if (i == 0)
                            {
                                tlTemp.Traffic_First = "ɻ";
                                tlTemp.Traffic_Second = "";
                            }
                            else
                            {
                                // ݳؽӱжϽͨߣ
                                List<Grp_CarTouristGuideGroundReservations> ListCar = listctg.FindAll(c => Convert.ToDateTime(c.ServiceStartTime) <= Convert.ToDateTime(timeList[i])
                                                                                                    && Convert.ToDateTime(c.ServiceEndTime) >= Convert.ToDateTime(timeList[i]));
                                //ͨߣ
                                if (ListCar.Count > 0)
                                {
                                    tlTemp.Traffic_First = "";

                                    //ͨߣɻ
                                    if (airSign == true)
                                    {
                                        tlTemp.Traffic_Second = "ɻ";
                                    }
                                    else
                                    {
                                        tlTemp.Traffic_Second = "";
                                    }
                                }
                                else
                                {
                                    tlTemp.Traffic_First = "";

                                    //ͨߣɻ
                                    if (airSign == true)
                                    {
                                        tlTemp.Traffic_Second = "ɻ";
                                    }
                                    else
                                    {
                                        tlTemp.Traffic_Second = "";
                                    }
                                }


                            }
                            #endregion

                            tlTemp.Trip = trip;

                            tlTemp.CreateUserId = di.Id;
                            tlTemp.CreateTime = DateTime.Now;
                            //tlTemp.OPdate = PublicCode.GetBeijingTime().ToString("yyyy-MM-dd hh:mm:ss");
                            tlTemp.Issel = 1;
                            tlTemp.Diffgroup = 1;
                            tlTemp.IsDel = 0;

                            AddTravelList(tlTemp);
                        }
                    }
                }
                catch (Exception ex)
                {
                    //Response.Write(ex.Message.ToString());
                    lblImport.Text = ex.Message;
                }

                lblImport.Text = "¼";
            }
        }

        private string pushTrip(string timeStr, string startAddress, string endAddress, out string timeOut)
        {
            startAddress = startAddress.Trim().Replace("˵ΪȲע磩", "");
            endAddress = endAddress.Trim().Replace("˵ΪȲע磩", "");

            decimal conversion = 1.61M;

            DateTime tripTime = DateTime.Now;
            try
            {
                tripTime = DateTime.Parse(timeStr).AddHours(-1);
            }
            catch (Exception e)
            { }

            endAddress = endAddress.TrimStart('/');
            string CheckoutHotelTime = string.Empty;
            string endCity = string.Empty;
            if (endAddress.Contains("/"))
            {
                endCity = endAddress.Split('/')[1] + "";
            }
            else
            {
                endCity = endAddress + "";
            }

            string Time = string.Empty;
            string Distance = string.Empty;
            int GetGoogleResult = 0;
            JObject Result = null;
            try
            {
                Result = GetDirectionByGoogleApi(startAddress, endCity);
                Time = Result["routes"][0]["legs"][0]["duration"]["text"].ToString();
                Distance = Result["routes"][0]["legs"][0]["distance"]["text"].ToString();


                if (Time.Contains("hours"))
                {
                    Time = Time.Replace("hours", "Сʱ");
                }
                else if (Time.Contains("hour"))
                {
                    Time = Time.Replace("hour", "Сʱ");
                }
                Time = Time.Replace("mins", "");

                if (Time.Contains("Сʱ"))
                {
                    GetGoogleResult = int.Parse(Regex.Split(Regex.Split(Time, "Сʱ")[1], "")[0]);
                }
                else if (Time.Contains(""))
                {
                    GetGoogleResult = int.Parse(Regex.Split(Time, "")[0]);
                }

                if (Distance.Contains("mi"))
                {
                    var distSp = Regex.Split(Distance, "mi");
                    if (distSp.Length > 0)
                    {
                        Distance = (decimal.Parse(distSp[0]) * conversion).ToString("#0.00") + " ";
                    }
                }
                else if (Distance.Contains("km"))
                {
                    Distance = Distance.Replace("km", "");
                }

                Time = Time.Replace(" ", "");
                Distance = Distance.Replace(" ", "");
            }
            catch (Exception e)
            {
                Time = "δ֪";
                Distance = "δ֪";
            }

            string trip = string.Empty;
            if (timeStr.Contains(":"))
            {
                int H = tripTime.Hour;
                int M = tripTime.Minute;

                if (H < 12)
                {
                    tripTime = tripTime.AddMinutes(90);

                    CheckoutHotelTime = tripTime.ToString("HH:mm");

                    trip += $"\r\n{CheckoutHotelTime} רǰ";

                    trip += $"{startAddress} - {endCity} ·{Distance}ʱ{Time}";

                    if (H <= 13)
                    {
                        tripTime = tripTime.AddMinutes(GetGoogleResult);
                        trip += $"\r\n{tripTime.ToString("HH:mm")} ڵز;";
                    }


                }
                else if (H == 12 && M <= 30)
                {
                    tripTime = tripTime.AddMinutes(90);

                    CheckoutHotelTime = tripTime.ToString("HH:mm");

                    trip += $"\r\n{CheckoutHotelTime} רǰ";

                    trip += $"{startAddress} - {endCity} ·{Distance}ʱ{Time}";

                    if (H <= 13)
                    {
                        tripTime = tripTime.AddMinutes(GetGoogleResult);
                        trip += $"\r\n{tripTime.ToString("HH:mm")} ڵز;";
                    }

                }
                else if (H >= 14)
                {
                    tripTime = tripTime.AddMinutes(90);

                    CheckoutHotelTime = tripTime.ToString("HH:mm");

                    trip += $"\r\n{CheckoutHotelTime} רǰ;";

                    trip += $"{startAddress} - {endCity} ·{Distance}ʱ{Time}";

                    tripTime = DateTime.Parse(CheckoutHotelTime).AddMinutes(GetGoogleResult);

                    trip += $"\r\n{tripTime.ToString("HH:mm")} ڵز;";
                }
            }

            timeOut = tripTime.AddMinutes(60).ToString("HH:mm");

            return trip;
        }


        /// <summary>
        /// ùȸͼAPIѯ֮
        /// </summary>
        /// <param name="Origin"></param>
        /// <param name="Destination">Ŀĵ</param>
        /// <returns>Jsonʽ</returns>
        public JObject GetDirectionByGoogleApi(string Origin, string Destination)
        {

            string appkey = "AIzaSyBdLf8u8DinXQWVPLEkdrxOJpClXSqEnho";
            string url = "https://maps.googleapis.com/maps/api/directions/json?origin=" + Origin
                       + "&destination=" + Destination + "&key=" + appkey;

            JObject result = null;
            try
            {
                #region HttpWebRequestAPI
                ////Webʶ
                //HttpWebRequest req = HttpWebRequest.Create(url) as HttpWebRequest;
                //req.Method = "GET";
                //req.ContentType = "application/json";
                ////webӦ
                //HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
                ////ͨӦStreamReaderΪStreamReader߼
                //StreamReader reader = new StreamReader(resp.GetResponseStream(), Encoding.UTF8);
                ////б
                ////string returnXml = HttpUtility.UrlDecode(reader.ReadToEnd());
                ////StreamReaderͿԴӦݴͷβ
                //string returnJson = reader.ReadToEnd();

                ////л
                //result = JsonConvert.DeserializeObject(returnJson) as JObject;
                #endregion

                #region HttpClientAPI
                HttpClient myHttpClient = new HttpClient();
                HttpResponseMessage response = myHttpClient.GetAsync(url).Result;
                //var content = response.Content.ReadAsAsync<object>().Result;
                var content = response.Content.ReadAsStringAsync().Result;

                result = JObject.Parse(content);
                #endregion

                return result;
            }
            catch (Exception e)
            {
                string error = e.Message.ToString();
                result = JsonConvert.DeserializeObject(error) as JObject;
                return result;
            }




        }


        /// <summary>
        ///ݻƱDataTable
        /// </summary>
        /// <param name="diid"></param>
        /// <returns></returns>
        public DataTable GetTableByBlackCode(int diid)
        {
            //Ϣ
            List<Air_TicketBlackCode> listcode = Db.Queryable<Air_TicketBlackCode>().Where(x => x.DiId == diid && x.IsDel == 0).ToList();

            //Ϊ,,,,ʱ,ʱ,վ¥,ﺽվ¥,,ʱ
            //1.3U8391   TU17NOV CTUCAI  0220 0715   T1 T2  330  10H55M
            DataTable dt = new DataTable();
            dt.Columns.Add("Fliagtcode", typeof(string)); //
            dt.Columns.Add("Date", typeof(string));//
            dt.Columns.Add("Three", typeof(string));//
            dt.Columns.Add("StartTime", typeof(string));//ʱ
            dt.Columns.Add("EndTime", typeof(string));//ʱ
            dt.Columns.Add("StartBuilding", typeof(string));//վ¥
            dt.Columns.Add("EndBuilding", typeof(string));//ﺽվ¥
            dt.Columns.Add("AirModel", typeof(string)); //
            dt.Columns.Add("FlightTime", typeof(string));//ʱ
            dt.Columns.Add("Day", typeof(string));//;Ϊ 
            dt.Columns.Add("ArrivedDate", typeof(string));//ĵ
            dt.Columns.Add("Error", typeof(string));//ĵ
            dt.Columns.Add("Sign", typeof(string));//ʶ0ʾΪԭ롢1ʾ+1ĺ

            //жǷ¼
            if (listcode.Count() == 0 || listcode == null)
            {
                dt.Rows.Add(null, null, null, null, null, null, null, null, null, null, null, "δ¼!", null);
            }
            else
            {
                //ȡκ
                for (int i = 0; i < listcode.Count; i++)
                {
                    //ȥ
                    string[] CodeList = Regex.Split(listcode[i].BlackCode, "\\d+\\.", RegexOptions.IgnoreCase);
                    //ȥո񣬷һLinqչ
                    CodeList = CodeList.Where(str => str != "").ToArray();
                    CodeList = CodeList.Where(str => str != " ").ToArray();

                    //
                    int year = Convert.ToInt32(DateTime.Now.Year.ToString());

                    //ȡ
                    for (int j = 0; j < CodeList.Count(); j++)
                    {
                        //ȥո񣬷ʹSplit()зָ,ָһѡRemoveEmptyEntries
                        CodeList[j] = CodeList[j].Replace("\r\n", string.Empty).Replace("\\r\\n", string.Empty).TrimStart().TrimEnd();
                        string[] Info = CodeList[j].Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

                        //string[] Info = CodeList[j].Replace("\r\n", string.Empty).Replace("\\r\\n", string.Empty)
                        //                   .TrimStart().TrimEnd().Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

                        //ȥո
                        Info = Info.Where(str => str != "").ToArray();
                        Info = Info.Where(str => str != " ").ToArray();

                        //жϺǷȷ; Ӧ9
                        if (Info.Count() < 9)
                        {
                            dt.Rows.Add(null, null, null, null, null, null, null, null, null, null, null, "" + (i + 1) + "κе" + (j + 1) + " ,ϵƱͬº˶", null);
                        }
                        else
                        {
                            try
                            {
                                //                  
                                int month = Convert.ToInt32(GetLonger(Info[1].Substring(4, 3)));
                                //
                                int day = Convert.ToInt32(Info[1].Substring(2, 2));

                                #region һȽ·,жǷ;һȽ붥,жǷܴ
                                if (j > 0)
                                {
                                    string[] Temp = CodeList[j - 1].Replace("\r\n", string.Empty).Replace("\\r\\n", string.Empty)
                                                  .TrimStart().TrimEnd().Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);
                                    Temp = Temp.Where(str => str != "").ToArray();
                                    Temp = Temp.Where(str => str != " ").ToArray();
                                    int monthTemp = Convert.ToInt32(GetLonger(Temp[1].Substring(4, 3)));
                                    // ·֮С0,֤һ+1
                                    if (month - monthTemp < 0)
                                    {
                                        year = year + 1;
                                    }
                                    //ڴ벻棬
                                    string FootThree = Temp[2].Substring(3, 3);
                                    string HeadThree = Info[2].Substring(0, 3);
                                    if (FootThree != HeadThree)
                                    {
                                        //DelegationInfoService s = new DelegationInfoService();
                                        //UsersService us = new UsersService();
                                        //GroupsTaskAssignmentService gts = new GroupsTaskAssignmentService();

                                        //77	г
                                        List<Grp_GroupsTaskAssignment> list2 = Db.Queryable<Grp_GroupsTaskAssignment>().Where(x => x.CTId == 77 && x.DIId == diid && x.IsDel == 0).ToList();
                                        foreach (var temp in list2)
                                        {
                                            //if (temp.UId != 21)
                                            //SendAndReturn(us.GetUsersByID(temp.UId).Email,
                                            //    "",
                                            //   s.GetDelegationInfoByID(diid).TeamName + "ĻƱУںε벻鿴");
                                        }

                                        //85	ƱԤ
                                        List<Grp_GroupsTaskAssignment> list6 = Db.Queryable<Grp_GroupsTaskAssignment>().Where(x => x.CTId == 85 && x.DIId == diid && x.IsDel == 0).ToList();
                                        foreach (var temp in list6)
                                        {
                                            //if (temp.UId != 21)
                                            //SendAndReturn(us.GetUsersByID(temp.UId).Email,
                                            //    "",
                                            //     s.GetDelegationInfoByID(diid).TeamName + "ĻƱУںε벻鿴");
                                        }
                                    }

                                }
                                #endregion


                                #region жϵǷҪ1
                                if (Info[4].Contains("+"))
                                {
                                    //+1
                                    day = day + 1;

                                    //жǷһ
                                    if (day > Convert.ToInt32(GetDaysByMonth(Info[1].Substring(4, 3), year)))
                                    {
                                        day = day - Convert.ToInt32(GetDaysByMonth(Info[1].Substring(4, 3), year));
                                        month = month + 1;

                                        //жǷһ
                                        if (month > 12)
                                        {
                                            month = month - 12;
                                            year = year + 1;
                                        }
                                    }

                                    //·ʽ
                                    string monthTemp = month.ToString();
                                    if (month < 10)
                                    {
                                        monthTemp = "0" + monthTemp;
                                    }
                                    //ʽ
                                    string daytemp = day.ToString();
                                    if (day < 10)
                                    {

                                        daytemp = "0" + daytemp;
                                    }

                                    string temp = Info[4].Split('+')[0];

                                    //
                                    dt.Rows.Add(Info[0],
                                       Info[1],
                                       Info[2],
                                       Info[3],
                                       temp,
                                       Info[5],
                                       Info[6],
                                       Info[7],
                                       Info[8],
                                       year + "-" + GetLonger(Info[1].Substring(4, 3)) + "-" + Info[1].Substring(2, 2),
                                       year + "-" + monthTemp + "-" + daytemp,
                                       "",
                                       "0");
                                    //1죬ӵ
                                    dt.Rows.Add(Info[0],
                                       Info[1].Replace(Info[1].Substring(2, 2), daytemp),
                                       Info[2],
                                       Info[3],
                                       temp,
                                       Info[5],
                                       Info[6],
                                       Info[7],
                                       Info[8],
                                       year + "-" + monthTemp + "-" + daytemp,
                                       year + "-" + monthTemp + "-" + daytemp,
                                       "",
                                       "1");
                                }
                                else
                                {
                                    //·ʽ
                                    string monthTemp = month.ToString();
                                    if (month < 10)
                                    {
                                        monthTemp = "0" + monthTemp;
                                    }
                                    //ʽ
                                    string daytemp = day.ToString();
                                    if (day < 10)
                                    {

                                        daytemp = "0" + daytemp;
                                    }

                                    dt.Rows.Add(Info[0],
                                        Info[1],
                                        Info[2],
                                        Info[3],
                                        Info[4],
                                        Info[5],
                                        Info[6],
                                        Info[7],
                                        Info[8],
                                        year + "-" + monthTemp + "-" + daytemp,
                                        year + "-" + monthTemp + "-" + daytemp,
                                        "",
                                        "0");
                                }
                                #endregion
                            }
                            catch (Exception ex)
                            {
                                string exstr = ex.Message.ToString();
                            }
                        }

                    }

                    //
                    dt.DefaultView.Sort = "Day asc";
                    dt = dt.DefaultView.ToTable();
                }
            }

            return dt;
        }


        /// <summary>
        /// ,·ݵд,תֻȫ
        /// ݱƷرִ
        /// ַػͺš23ͷľǿտͣտ3207ͷľǲ粨777
        /// 20210903
        /// </summary>
        /// <param name="startDate"></param>
        /// <param name="endDate"></param>
        /// <returns></returns>
        public string GetLonger(string temp)
        {
            string str = "";
            switch (temp.ToUpper())
            {
                case "Ԫ":
                    str = "USD";
                    break;
                case "Ԫ":
                    str = "JPY";
                    break;
                case "Ӣ":
                    str = "GBP";
                    break;
                case "ŷԪ":
                    str = "EUR";
                    break;
                case "۱":
                    str = "HKD";
                    break;
                case "MO":
                    str = "һ";
                    break;
                case "TU":
                    str = "ڶ";
                    break;
                case "WE":
                    str = "";
                    break;
                case "TH":
                    str = "";
                    break;
                case "FR":
                    str = "";
                    break;
                case "SA":
                    str = "";
                    break;
                case "SU":
                    str = "";
                    break;
                case "JAN":
                    str = "01";
                    break;
                case "FEB":
                    str = "02";
                    break;
                case "MAR":
                    str = "03";
                    break;
                case "APR":
                    str = "04";
                    break;
                case "MAY":
                    str = "05";
                    break;
                case "JUN":
                    str = "06";
                    break;
                case "JUL":
                    str = "07";
                    break;
                case "AUG":
                    str = "08";
                    break;
                case "SEP":
                    str = "09";
                    break;
                case "OCT":
                    str = "10";
                    break;
                case "NOV":
                    str = "11";
                    break;
                case "DEC":
                    str = "12";
                    break;
                case "MONDAY":
                    str = "һ";
                    break;
                case "TUESDAY":
                    str = "ڶ";
                    break;
                case "WEDNESDAY":
                    str = "";
                    break;
                case "THURSDAY":
                    str = "";
                    break;
                case "FRIDAY":
                    str = "";
                    break;
                case "SATURDAY":
                    str = "";
                    break;
                case "SUNDAY":
                    str = "";
                    break;
                case "01":
                    str = "JAN";
                    break;
                case "02":
                    str = "FEB";
                    break;
                case "03":
                    str = "MAR";
                    break;
                case "04":
                    str = "APR";
                    break;
                case "05":
                    str = "MAY";
                    break;
                case "06":
                    str = "JUN";
                    break;
                case "07":
                    str = "JUL";
                    break;
                case "08":
                    str = "AUG";
                    break;
                case "09":
                    str = "SEP";
                    break;
                case "10":
                    str = "OCT";
                    break;
                case "11":
                    str = "NOV";
                    break;
                case "12":
                    str = "DEC";
                    break;
                case "2":
                    str = "տA";
                    break;
                case "3":
                    str = "տA";
                    break;
                case "7":
                    str = "";
                    break;
            }

            return str;
        }

        /// <summary>
        /// 1ѯùǷΪ;ϵͳΪ
        /// 2ѯùǷλŷ;Ҫǰ3Сʱ
        /// 3ѯùǷΪȲ;ϵͳһҪ
        /// 20210824 
        /// </summary>
        /// <param name="Country">ѯ</param>
        /// <returns>ؽ1Ϊղѯ;2Ϊŷ޻ѯ;3ΪȲѯ</returns>
        public string GetCountryInfo(string Country)
        {
            //Ϊ56ĳе;ϵͳΪ
            string[] CountryOne = {"","United Arab Emirates","","Bahrain","","Qatar","ɳذ","Saudi Arabia","","Oman","","Kuwait","","Egypt",
                            "Լ","Jordan","","Iran","","Iraq","","Syria","","Lebanon","˹̹","Palestine","ɳ","Ҳ","Yemen"};
            //ŷ޻;Ҫǰ3Сʱ
            string[] CountryTwo = {"","","Ų","","","Ⱥ","ɳ","ά","","׶˹","˹","ڿ","Ħ","","ݿ","˹工",
                            "","¹","µ","ʿ","֧ʿ","Ӣ","","","ʱ","¬ɭ","","Ħɸ","","","ά","",
                            "","ϣ","˹","޵","˹Ǻīά","","ٸ","ʥŵ","","","","","" };
            //Ȳ;ϵͳһҪ
            string[] CountryThree = {"","¡","","ɷ","¡","зǹ͹","է","չ","","","Ա","","","Ǳ",
                            "","","ص","","","","ն","","ڼӶ","","յ","յ","","ڸɴ","ë",
                            "չ͹","ά","","϶","","³","","","ί","","͢","Ͷ͸" };
            string result = "";


            if (CountryOne.Contains(Country))
                result += "1";
            if (CountryTwo.Contains(Country))
                result += "2";
            if (CountryThree.Contains(Country))
                result += "3";

            return result;
        }

        /// <summary>
        /// 20210816
        /// datatableĳһʱε
        /// </summary>
        /// <param name="dt">ɵdatatable</param>
        /// <returns></returns>
        public List<string> GetTimeListByDataTable(DataTable dt)
        {
            if (dt.Rows[0]["Day"].ToString() != "")
            {
                DateTime datestart = Convert.ToDateTime(dt.Rows[0]["Day"].ToString());
                DateTime dateend = Convert.ToDateTime(dt.Rows[dt.Rows.Count - 1]["ArrivedDate"].ToString());

                List<string> timeList = new List<string>();
                while (datestart <= dateend)
                {
                    timeList.Add(datestart.ToString("yyyy-MM-dd"));
                    datestart = datestart.AddDays(1);
                }

                return timeList;
            }
            return null;
        }


        /// <summary>
        /// ʱ --ʱ
        /// </summary>
        /// <returns></returns>
        public DateTime GetBeijingTime()
        {
            WebRequest request = null;
            WebResponse response = null;
            WebHeaderCollection headerCollection = null;
            string datetime = string.Empty;
            try
            {
                request = WebRequest.Create("https://www.baidu.com");
                request.Timeout = 3000;
                request.Credentials = CredentialCache.DefaultCredentials;
                response = request.GetResponse();
                headerCollection = response.Headers;
                foreach (var h in headerCollection.AllKeys)
                {
                    if (h == "Date")
                    {
                        datetime = headerCollection[h];
                    }
                }
                return Convert.ToDateTime(datetime);
            }
            catch (Exception)
            {
                return DateTime.Now;
            }
            finally
            {
                if (request != null)
                {
                    request.Abort();
                }
                if (response != null)
                {
                    response.Close();
                }
                if (headerCollection != null)
                {
                    headerCollection.Clear();
                }
            }

        }

        /// <summary>
        /// ·ݷ
        /// </summary>
        /// <param name="temp"></param>
        /// <returns></returns>
        public static string GetDaysByMonth(string Month, int year)
        {
            string str = "";
            //жǷ
            if (DateTime.IsLeapYear(year) == false)
            {
                switch (Month.ToUpper())
                {
                    case "JAN":
                        str = "31";
                        break;
                    case "FEB":
                        str = "28";
                        break;
                    case "MAR":
                        str = "31";
                        break;
                    case "APR":
                        str = "30";
                        break;
                    case "MAY":
                        str = "31";
                        break;
                    case "JUN":
                        str = "30";
                        break;
                    case "JUL":
                        str = "31";
                        break;
                    case "AUG":
                        str = "31";
                        break;
                    case "SEP":
                        str = "30";
                        break;
                    case "OCT":
                        str = "31";
                        break;
                    case "NOV":
                        str = "30";
                        break;
                    case "DEC":
                        str = "31";
                        break;
                    case "01":
                        str = "31";
                        break;
                    case "02":
                        str = "28";
                        break;
                    case "03":
                        str = "31";
                        break;
                    case "04":
                        str = "30";
                        break;
                    case "05":
                        str = "31";
                        break;
                    case "06":
                        str = "30";
                        break;
                    case "07":
                        str = "31";
                        break;
                    case "08":
                        str = "31";
                        break;
                    case "09":
                        str = "30";
                        break;
                    case "10":
                        str = "31";
                        break;
                    case "11":
                        str = "30";
                        break;
                    case "12":
                        str = "31";
                        break;
                }
            }
            else
            {
                switch (Month.ToUpper())
                {
                    case "JAN":
                        str = "31";
                        break;
                    case "FEB":
                        str = "29";
                        break;
                    case "MAR":
                        str = "31";
                        break;
                    case "APR":
                        str = "30";
                        break;
                    case "MAY":
                        str = "31";
                        break;
                    case "JUN":
                        str = "30";
                        break;
                    case "JUL":
                        str = "31";
                        break;
                    case "AUG":
                        str = "31";
                        break;
                    case "SEP":
                        str = "30";
                        break;
                    case "OCT":
                        str = "31";
                        break;
                    case "NOV":
                        str = "30";
                        break;
                    case "DEC":
                        str = "31";
                        break;
                    case "01":
                        str = "31";
                        break;
                    case "02":
                        str = "29";
                        break;
                    case "03":
                        str = "31";
                        break;
                    case "04":
                        str = "30";
                        break;
                    case "05":
                        str = "31";
                        break;
                    case "06":
                        str = "30";
                        break;
                    case "07":
                        str = "31";
                        break;
                    case "08":
                        str = "31";
                        break;
                    case "09":
                        str = "30";
                        break;
                    case "10":
                        str = "31";
                        break;
                    case "11":
                        str = "30";
                        break;
                    case "12":
                        str = "31";
                        break;
                }

            }


            return str;
        }

        /// <summary>
        /// ,PublicCodeڲ
        /// </summary>
        public class CityInDate
        {
            public int Id { get; set; }
            //
            public string City { get; set; }
            //
            public string Date { get; set; }
        }


        /// <summary>
        /// 20210823
        /// datatableгÿһڵĳ
        /// </summary>
        /// <param name="dt">ɵdatatable</param>
        /// <returns></returns>
        public List<CityInDate> GetCityByDataTable(DataTable dt)
        {
            //ڼֵ
            List<CityInDate> list = new List<CityInDate>();
            //ThreeCodeServices tcs = new ThreeCodeServices();

            int id = 0;
            for (int i = 1; i < dt.Rows.Count; i++)
            {


                //i-1е
                string Pre_citycode = dt.Rows[i - 1]["Three"].ToString();
                if (string.IsNullOrWhiteSpace(Pre_citycode))
                {
                    continue;
                }

                Pre_citycode = Pre_citycode.Replace("/", string.Empty).Substring(3, 3);

                string city = "";

                //ѯӦе
                //ThreeCode Pre_TC = tcs.getByThree(Pre_citycode);
                Res_ThreeCode Pre_TC = Db.Queryable<Res_ThreeCode>().First(x => x.Three.ToUpper() == Pre_citycode.ToUpper() && x.IsDel == 0 );

                //֤Ƿ
                if (Pre_TC == null)
                    city = "" + Pre_citycode + "δ¼Ʊͬ¼롿";
                else
                    city = Pre_TC.City;

                //
                DateTime datestart = Convert.ToDateTime(dt.Rows[i - 1]["Day"].ToString());
                DateTime dateend = Convert.ToDateTime(dt.Rows[i]["Day"].ToString());

                List<string> timeList = new List<string>();
                while (datestart < dateend)
                {
                    timeList.Add(datestart.ToString("yyyy-MM-dd"));
                    datestart = datestart.AddDays(1);
                }

                if (i == dt.Rows.Count - 1)
                    timeList.Add(dt.Rows[i]["Day"].ToString());

                for (int j = 0; j < timeList.Count; j++)
                {
                    CityInDate cid = new CityInDate() { };
                    cid.Id = id;
                    cid.City = city;
                    cid.Date = timeList[j];
                    list.Add(cid);
                    id++;
                }

            }
            return list;
        }

        Res_ThreeCode getByThree(string three)
        {
            return Db.Queryable<Res_ThreeCode>().First(x => x.Three == three && x.IsDel == 0 );
        }

        Res_AirCompany getByShortCode(string ShortCode)
        {
            //return this.excuteType("select * from AirCompany where Isdel=0 and ShortCode=@ShortCode", new SqlParameter("@ShortCode", ShortCode.ToUpper()));
            return Db.Queryable<Res_AirCompany>().First(x => x.ShortCode.ToUpper() == ShortCode.ToUpper() && x.IsDel == 0);
        }

        public class GoogleMapApiResult
        {
            int id;
            /// <summary>
            /// ʶ
            /// </summary>
            public int Id { get => id; set => id = value; }

            int diid;
            /// <summary>
            /// ID
            /// </summary>
            public int Diid { get => diid; set => diid = value; }

            string date;
            /// <summary>
            ///  
            /// </summary>
            public string Date { get => date; set => date = value; }

            string moment;
            /// <summary>
            /// ʱ
            /// </summary>
            public string Moment { get => moment; set => moment = value; }

            string startAddress;
            /// <summary>
            /// ַ
            /// </summary>
            public string StartAddress { get => startAddress; set => startAddress = value; }

            string endAddress;
            /// <summary>
            /// ַ
            /// </summary>
            public string EndAddress { get => endAddress; set => endAddress = value; }
            string time;
            /// <summary>
            /// ʱ
            /// </summary>
            public string Time { get => time; set => time = value; }

            string distance;
            /// <summary>
            /// 
            /// </summary>
            public string Distance { get => distance; set => distance = value; }
        }


        List<Res_ThreeCode> getByCity(string city)
        {
            //return this.excuteSql("select * from ThreeCode w" +
            //    "here Isdel=0 and City='" + city + "'");
            return Db.Queryable<Res_ThreeCode>().Where(x => x.City == city && x.IsDel == 0).ToList();
        }

        public List<Res_OfficialActivities> getByDiidAndDate(int diid, string date)
        {
            //return excuteSql("select * from OfficialActivities where Isdel=0" +
            //    " and Diid=@diid and IsSubmitApproval=0 and Date=@Date " +
            //    "order by Date", new SqlParameter("@diid", diid),
            //    new SqlParameter("@Date", date));

            return Db.Queryable<Res_OfficialActivities>().Where(x => x.IsDel == 0 && x.DiId == diid
            && x.Date == date).ToList();
        }

        bool AddTravelList(Grp_TravelList data)
        {
            return Db.Insertable<Grp_TravelList>(data).ExecuteCommand() > 0;
        }

        bool EditTravelList(Grp_TravelList hd)
        {
            //string sql = "update TravelList set Diid=@Diid,Days = @Days,Date = @Date,WeekDay = @WeekDay,Traffic_First = @Traffic_First,"
            //        + "Traffic_Second = @Traffic_Second,Trip = @Trip,OPer = @OPer,OPdate = @OPdate,Isdel = @Isdel where Id = @Id";

            //SqlParameter[] parameter = new SqlParameter[]{
            //    new SqlParameter("@Diid",hd.Diid),
            //    new SqlParameter("@Days",hd.Days),
            //    new SqlParameter("@Date",hd.Date),
            //    new SqlParameter("@WeekDay",hd.WeekDay),
            //    new SqlParameter("@Traffic_First",hd.Traffic_First),
            //    new SqlParameter("@Traffic_Second",hd.Traffic_Second),
            //    new SqlParameter("@Trip",hd.Trip),
            //    new SqlParameter("@OPer",hd.OPer),
            //    new SqlParameter("@OPdate",hd.OPdate),
            //    new SqlParameter("@Isdel",hd.Isdel),
            //    new SqlParameter("@Id",hd.Id)
            //};
            //if (SqlHelper.ExecuteNonQuery(sql, CommandType.Text, parameter) > 0)
            //    return true;
            //return false;

            return Db.Updateable<Grp_TravelList>(hd).ExecuteCommand() > 0;
        }


        bool DelOld(int Diid, int start, int end)
        {
            //if (SqlHelper.ExecuteNonQuery("delete from TravelList where Diid=" + Diid + " and ( Id>=" + start + " and Id<=" + end + ")", CommandType.Text) > 0)
            //    return true;
            //return false;

            return Db.Deleteable<Grp_TravelList>().Where(x => x.Diid == Diid && x.Id >= start && x.Id <= end).ExecuteCommand() > 0;
        }

        /// <summary>
        /// ŲѯϢ
        /// </summary>
        /// <returns>ؿջ߶Ϣ</returns>
        List<Grp_TravelList> GetByDiid(int Diid)
        {
            //ûȡķ
            return Db.Queryable<Grp_TravelList>().Where(x => x.Diid == Diid && x.IsDel == 0).ToList();
        }

        public List<Crm_DeleClient> GetByDiidClient(int DIID)
        {
            return Db.Queryable<Crm_DeleClient>().Where(x => x.DiId == DIID && x.IsDel == 0).ToList();
        }

        /// <summary>
        /// ݴдַСдֻСдַشд
        /// </summary>
        /// <param name="num"></param>
        /// <returns></returns>
        public string GetNum(string num)
        {

            string str = "";
            switch (num)
            {
                case "1":
                    str = "һ";
                    break;
                case "2":
                    str = "";
                    break;
                case "3":
                    str = "";
                    break;
                case "4":
                    str = "";
                    break;
                case "5":
                    str = "";
                    break;
                case "6":
                    str = "";
                    break;
                case "7":
                    str = "";
                    break;
                case "8":
                    str = "";
                    break;
                case "9":
                    str = "";
                    break;
                case "10":
                    str = "ʮ";
                    break;
                case "11":
                    str = "ʮһ";
                    break;
                case "12":
                    str = "ʮ";
                    break;
                case "һ":
                    str = "1";
                    break;
                case "":
                    str = "2";
                    break;
                case "":
                    str = "3";
                    break;
                case "":
                    str = "4";
                    break;
                case "":
                    str = "5";
                    break;
                case "":
                    str = "6";
                    break;
                case "":
                    str = "7";
                    break;
                case "":
                    str = "8";
                    break;
                case "":
                    str = "9";
                    break;
                case "ʮ":
                    str = "10";
                    break;
                case "ʮһ":
                    str = "11";
                    break;
                case "ʮ":
                    str = "12";
                    break;
            }
            return str;
        }

        public bool Del(int diid)
        {
            return Db.Updateable<Grp_TravelList>().Where(x => x.Diid == diid && x.IsDel == 0).SetColumns(x => new Grp_TravelList { IsDel = 1, DeleteTime = DateTime.Now.ToString("yyyy-MM-dd") }).ExecuteCommand() > 0;
        }


        private void comb_Delegation_TextUpdate(object sender, EventArgs e)
        {
            ComboBox cb = (ComboBox)sender;
            cb.DataSource = null;
            cb.Items.Clear();
            string s = cb.Text;
            var bindList = soure.Where(item => item.TeamName != null && item.TeamName.Contains(s)).ToList();
            if (bindList.Count >= 1) // ڷ
            {
                this.comb_Delegation.Items.AddRange(bindList.ToArray());
            }
            else
            {
                this.comb_Delegation.Items.Add(new Grp_DelegationInfo { TeamName = "", Id = -1 });
            }
           
            cb.SelectionStart = cb.Text.Length;  // ùλããλʼձڵһУؼʵĵ
            cb.Cursor = Cursors.Default; //ָԭ״̬ʱָᱻ򸲸ǣҪһ
            cb.MaxDropDownItems = 8; // Զ            
        }


        private void comb_Delegation_MouseClick(object sender, MouseEventArgs e)
        {
            comb_Delegation.Text = "";
            comb_Delegation_TextUpdate(sender, e);
            comb_Delegation.DropDownHeight = 200;
            comb_Delegation.DroppedDown = true;
        }
    }
}